/*
 * Copyright (c) 2001-2003 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <frassi@iit.cnr.it>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: actions.c,v 1.5 2003/02/17 15:32:11 frassi Exp $
 */

#include "actions.h"
#include <stdio.h>
#include "parser.h"
//#include <sys/ptrace.h>
#include <sys/types.h>   
#include <signal.h>
#include "automa_management.h"
#include <sys/stat.h>
#include <fcntl.h>
//#include "queue.h"
//#include "socket_utility.h"

#include <assert.h>

extern struct tcb *current; /* definito in strace.c */

/* blocca il processo che ha eseguito la syscall corrente */
void
freeze()
{
  /*
    if (ptrace(PTRACE_CONT, current->pid, (char *) 1, SIGSTOP) < 0)
    {
    perror("freeze");
    exit(-1);
    }
  */
  
  if  (kill(current->pid, SIGSTOP) < 0) 
    {
      perror("freeze");
      exit(-1);
    }
  //printf("%d\n",current->flags);
  current->flags |= TCB_STOPPED;
  
}

extern struct tcb*pid2tcb(int pid);

/* fa ripartire il processo passato come parametro */
void
de_freeze(int *pid)
{
  struct tcb *t;

  if ((t = pid2tcb(*pid)) == NULL)
    {
      fprintf(stderr, "unknown pid: %u\n", *pid);
      return;
    }

  t->flags &= ~TCB_STOPPED;
  //printf("%d\n",t->flags);
  /*
  if  (kill(*pid, SIGCONT) < 0) 
    {
      perror("de_freeze");
      exit(-1);
    }
  */
  
  if (ptrace(PTRACE_CONT, *pid, (char *) 1, 0) < 0)
    {
      perror("freeze");
      exit(-1);
    }
  
}

/* uccide il processo che ha eseguito la syscall corrente */
void
kill_actual()
{
  fprintf(stderr, "process %d KILLED **\n", current->pid);  
  //detach(current, SIGKILL);
  
  /*if  (kill(current->pid, SIGKILL) < 0) 
    {
    perror("kill_actual");
    exit(-1);
    }
  */
  current->flags |= TCB_KILLING;
}




/* restituisce il pid del processo che ha eseguito la syscall corrente */
int *
get_pid()
{
  int *res = malloc(sizeof(int));
  
  *res = current->pid;
  
  return res;
}



//#include <sys/socket.h>
//#include <net/netinet.h>
//#include <netinet/in.h>
//#include <arpa/inet.h>   

char *
get_ip_addr(struct sockaddr_in *sa)
{
  char *tmp;
  
  tmp = inet_ntoa(sa->sin_addr);
  tmp = clone_string(tmp);

  return tmp;
}


int *
get_sa_family(struct sockaddr *sa)
{
  int *res = malloc(sizeof(int));

  //tmp = inet_ntoa(sa->sin_addr);
  //tmp = clone_string(tmp);

  *res = sa->sa_family;

  return res;
}



/* extern str_queue *squeue; */

/* manda messaggi alla console grafica */
void
log(int *level,char *msg)
{
/*   char *str=malloc(strlen(msg)+8); */
/*   //LOG?~msg;;  dove ? puo'essere: */
/*   //se level == 0 --> N */
/*   //se level == 1 --> L */
/*   //se level == 2 --> H */

/*   switch (*level) */
/*     { */
/*     case 0: */
/*       sprintf(str,"LOGN~%s;;",msg); */
/*       break; */
/*     case 1: */
/*       sprintf(str,"LOGL~%s;;",msg); */
/*       break; */
/*     case 2: */
/*       sprintf(str,"LOGH~%s;;",msg); */
/*       break; */
/*     default: */
/*       sprintf(str,"LOGN~%s;;",msg); */
/*       break; */
/*     } */

/*   pthread_mutex_lock(squeue->mut); */

/*   while (squeue->full) */
/*     pthread_cond_wait (squeue->notFull, squeue->mut); */
  
/*   push_str_queue (squeue,str); */
  
/*   pthread_cond_signal (squeue->notEmpty); */
  
/*   pthread_mutex_unlock (squeue->mut); */

  return;
}

/* viene cambiato automa (e lo stato parte da 0) al processo attuale 
   mi aspetto che tutti gli automi siano creati quando parte wids */
/*
void
switch_automa(char *nome_file_regole)
{
  int num;
  
  if (num = num_[Aatm(nome_file_regole) < 0)
    {
      printf("file regole inesistente\n");
      exit(-1);
    }
  
  current->atm = atm[num];
  
  current->process_state = init_automa_state(current->process_state, var_table[num] );

}
*/


void printchar(char *ve)
{
  printf("%c\n", *ve);
}


int printint(int *ve)
{
  long *res = malloc(sizeof(long));
  
  printf("%d\n", *ve);
  *res = 1;
  
  return (int)res;
  //return 1;
}


void printfile(char *filename, char *str)
{
  FILE *file;

  assert (str != NULL);
  
  file = fopen (filename, "a");
  
  /* fprintf(file, "%s", str); */
  if ( fputs(str, file) == EOF )
    printf("\nprintfile: errore fputs\n");
  
  fprintf(file, "\n******************************************************\n");
  
  fclose (file);
  
}


void printconsole(char *str)
{
  int out_fd;
  char buf[80]; /* da stabilire grandezza buffer */
  
  assert (str != NULL);
  
  /*if (mkfifo("/home/frassi/widsard/fifo.wiz", 0666) == -1)
    {
      perror("printconsole");
      //return;
    }
  */
  
  out_fd = open("/var/tmp/fifo.wiz", O_WRONLY|O_NONBLOCK); // Aprire una sola volta......
  if (out_fd == -1) {
    //printf("Error opening pipe. processo read non in ascolto\n");
    printf("%s", str);
  }
  
  strncpy(buf, str, 79);
  buf[79] = '\0';

  write(out_fd, buf, 80);
  
  close(out_fd);
}

/*GHashTable *ht = g_hash_table_new (g_str_hash, g_str_equal);*/

void firewalla(char *ipaddr)
{
  char com[100];

  char *newipaddr = strdup(ipaddr); // ATTENZIONE, e' allocata con una malloc

  static GHashTable *ht = NULL; 

  if (ht == NULL) 
    ht = g_hash_table_new (g_str_hash, g_str_equal);

  

  if ( g_hash_table_lookup(ht, newipaddr) == NULL)
    g_hash_table_insert (ht, newipaddr, newipaddr);
  else
    {
      sprintf(com, "/sbin/ipchains -A input -s %s -j DENY", ipaddr); /* sostituire con fork ed execv */
      
      system(com);
    } 
  
}


/******************************** 
Dichiarazioni globali
*********************************/

#define MAX_SEQ 1000
int can_access[MAX_SEQ];


/********************************
fine dichiarazioni
*********************************/




long *
find(char *text,char *str2,char *sep) 
//+++++++++++++++++++++++++++++++++++++++++ 
// Trova nel buffer text (primo argomento) le parole in str2 (secondo arg) distinte da un separatore (terzo arg).
// ritorna 1 se trovate altrimenti 0

{
   char *a,*part0;
   int find=1,tro=0;
   int MAXWORDS=10000;   // si fissa il massimo numero di parole (words).
   int i;
   char *temp;
   long *res = malloc(sizeof(long));
   char *copy=malloc(strlen(str2)+1);
   char *copy_backup;

   copy=strcpy(copy,str2);
   copy_backup=copy;
   
   //   printf("cerca %s\n",copy);
   part0 = strtok(copy,sep);
   
   //printf("(find)textbegin  \"%s\"\n", text);
   
   
   if ( ( a = strstr(text,part0) )!= NULL) {find=1 ; //cerco la prima parola
   
   //printf("\trovato0 \"%s\"\n",part0);
   }
   else {find=0;
   }
   
   if (a!=NULL) {
     text=a; 
     text=(text+strlen(part0)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
   }  
   
   for(i=1;(((temp = strtok(NULL,sep))!= NULL)&&(i<MAXWORDS)&&(find==1));i++)  
     { 
       
       if ( ( a = strstr(text,temp) )!= NULL) {tro=1 ;// printf("trovato%i \"%s\"   \n",i+1,temp);
       }
       else {tro=0;
       }
   
       if (a!=NULL) {
	 text=a; 
	 text=(text+strlen(temp)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
       }    
       find=(find && tro);   
       
     }//end_for

   //printf(" find=\"%i\"\n ",find);
   
   if (find==1)  *res = 1;
   else  *res = 0;
   free(copy_backup);
 
   return res;  
 }



long *
find_begin(char *text,char *str2,char *sep)  
//+++++++++++++++++++++++++++++++++++++++++ 
// E' simile alla funzione find, soltanto che in piu' fa altri 2 controlli.
// Come prima cosa, davanti alla prima parola da cercare non ci deve essere nessun carattere.
// Come seconda, si considera due situazioni distinte: Se le parole del buffer text provengono da un browser, limito la ricerca sulla query string. Nel caso in cui invece provengono da una richiesta telnet, si cerca le parole sull'intero buffer.
{
  char *a,*part0,*b;
  int find=1,tro=0,rit;
  
  int MAXWORDS=10000;   // si fissa il massimo numero di words.
  int i;
  char *temp;
  long *res = malloc(sizeof(long));
  char *copy=malloc(strlen(str2)+1);
  char *copy_text=malloc(strlen(text)+1);   
  char *backup_copy_text; 
  char *backup_copy;
  
  
  copy=strcpy(copy,str2);
  backup_copy=copy;
  
  
  part0 = strtok(copy,sep);
  copy_text=strcpy(copy_text,text);

  backup_copy_text=copy_text;

  while (*copy_text == ' ')
    copy_text++;
  

  //backup_copy_text=copy_text;
 

  if ( ((b = strstr(copy_text,"HTTP")))&&( strstr(copy_text,"Connection:"))&&( strstr(copy_text,"User-Agent:"))) 
    {//printf("caso Browser");
      
      *b = '\0'; 
    }  
  
  //printf("copy modificato = \"%s\"\n",copy_text);
  
  if ( (rit=strncmp(copy_text,part0,strlen(part0))) == 0)
    { 
      if ( ( a = strstr(copy_text,part0) )!= NULL) 
	{
	  find=1 ; 
	  //printf("\ntrovato0 \"%s\"\n",part0);
	}
    }
  else 
    {
      find=0;
    }
 
  if (a!=NULL) 
    {
      copy_text=a; 
      copy_text=(copy_text+strlen(part0)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
    }  
 
  for(i=1;(((temp = strtok(NULL,sep))!= NULL)&&(i<MAXWORDS)&&(find==1));i++) //metto le words da cercare in un array  
    {
      
      if ( ( a = strstr(copy_text,temp) )!= NULL) 
	{
	  tro=1 ;// printf("trovato%i \"%s\"   \n",i+1,temp);
	}
      else 
	{
	  tro=0;
	}
      
      
      if (a!=NULL) 
	{
	  copy_text=a; 
	  copy_text=(copy_text+strlen(temp)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
	  
	}    
      find=(find && tro);   
      // if (find) printf("find --> ok.\n"); 
    }
  
  
  if (find==1) 
    *res = 1;
  else  
    *res = 0;
  
  free(backup_copy);
  free(backup_copy_text);
  
  return res;  
}




long *
two_find(char *text,char *str2,char *sep,int *seq)  
// Analoga alla find, soltanto che in piu' utilizza una variabile globale che da o meno l'accesso a questa funzione(se questa var=0 la tale funzione restituisce sempre 0). 
// Puo' essere utilizzata solo in coppia con una one_"qualcosa" che precedentemente ha messo a 1 la variabile globale.
// Questo tipo di funzioni viene utilizzato quando voglio che una certa syscall si verifichi solo se e' arrivata un'altra syscall.


{
   char *a,*part0;
   int find=1,tro=0;
   
   int MAXWORDS=10000;   // si fissa il massimo numero di words = 100
   int i;
 
   char *temp;
   long *res = malloc(sizeof(long));
   char *copy=malloc(strlen(str2)+1);
 
   extern int can_access[];
   copy=strcpy(copy,str2);
   
   //printf("cerca %s\n",copy);
   part0 = strtok(copy,sep);
   
   //printf("(find)textbegin  \"%s\"\n", text);
  
   
   if ( ( a = strstr(text,part0) )!= NULL) {find=1 ; 
  
   //printf("\ntrovato0 \"%s\"\n",part0);
   }
   else {find=0;
   }
   
   if (a!=NULL) {
	text=a; 
	text=(text+strlen(part0)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
   }  
   
   for(i=1;(((temp = strtok(NULL,sep))!= NULL)&&(i<MAXWORDS)&&(find==1));i++) //metto le words da cercare in un array  
     {
      
       if ( ( a = strstr(text,temp) )!= NULL) {tro=1 ;// printf("trovato%i \"%s\"   \n",i+1,temp);
       }
       else {tro=0;
       }
       
       
       if (a!=NULL) {
	 text=a; 
	 text=(text+strlen(temp)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
	 
       }    
       find=(find && tro);   
       
     }
  
   //printf(" find=\"%i\"\n ",find);
   // printf("can_access[%i]=\"%i\"\n ",*seq,can_access[*seq]);  
   
 
   if ((find==1)&&(can_access[*seq]==1))  *res = 1;
   else  *res = 0;
   free(copy);
   can_access[*seq]=0; //la prima write meccia disabilito l'accesso a tutte le altre find che non abbiano prima mecciato anche la chiamata precedente. Nel caso in cui la prima write non meccia disabilito comunque accesso.
   return res;  
 }










long *
one_find_begin(char *text,char *str2,char *sep,int *seq) 
// Analoga alla find_begin, soltanto che in piu' utilizza una variabile globale che da o meno l'accesso a questa funzione (se questa var=0 la tale funzione restituisce sempre 0). 
// Puo' essere utilizzata solo in coppia con una one_"qualcosa" che precedentemente ha messo a 1 la variabile globale.
//Questo tipo di funzioni viene utilizzato quando voglio che una certa syscall si verifichi solo se e' arrivata un'altra syscall.

{
   char *a,*part0,*b;
   int find=1,tro=0,rit;
   
   int MAXWORDS=10000;   // si fissa il massimo numero di words = 100
   int i;
 
   char *temp;
   long *res = malloc(sizeof(long));
   char *copy=malloc(strlen(str2)+1);
   char *copy_text=malloc(strlen(text)+1);
   char *backup_copy_text;   
 
   extern int can_access[];
   
   copy=strcpy(copy,str2);
 
   part0 = strtok(copy,sep);
   copy_text=strcpy(copy_text,text);
   backup_copy_text=copy_text;
  
   
   if ( ((b = strstr(copy_text,"HTTP")))&&( strstr(copy_text,"Connection:"))&&( strstr(copy_text,"User-Agent:"))) 
     {//printf("caso Browser");
   
     *b = '\0'; 
     }  
   
   //printf("copy modificato = \"%s\"\n",copy_text);
   
   
   if ( ( a = strstr(copy_text,part0) )!= NULL) {
     find=1 ; 
    
     //printf("\ntrovato0 \"%s\"\n",part0);
     
     if ((rit=strncmp(copy_text,part0,strlen(part0))) != 0) {find=0; 
     //printf("text= %s \nprimo pezzo= %s\n >>>>qualcosa davanti<<<<\n",copy_text,part0);
}
   }
   
   else {find=0;
   }
   
   if (a!=NULL) {
     copy_text=a; 
     copy_text=(copy_text+strlen(part0)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
   }  
   
  
   
   for(i=1;(((temp = strtok(NULL,sep))!= NULL)&&(i<MAXWORDS)&&(find==1));i++) //metto le words da cercare in un array  
     { 
       
       if ( ( a = strstr(copy_text,temp) )!= NULL) {tro=1 ;// printf("trovato%i \"%s\"   \n",i+1,temp);
       }
       else {tro=0; 
       }
       
       
       if (a!=NULL) {
	 copy_text=a; 
	 copy_text=(copy_text+strlen(temp)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
	 
       }    
       find=(find && tro);   
       // if (find) printf("find --> ok.\n"); 
     }
  
   
   if (find==1) {*res = 1;can_access[*seq]=1;}
   else  *res = 0;
   free(copy);
   free(backup_copy_text);
   
   return res;  
 }












//---------------------------------------------------------------------------------------------------------------------
int find_2_without_3(char *text,char *str2,char *par_in,char *sep) 
// ritorna 1 se trova nel primo arg. str2 (la stringa da  cercare) ma non trova par_in (che equivale a  "/"<sep><path1>) e cioe' la parte che non si deve trovare davanti. Funzione richiamata dalla "find_begin_nobar".

                                                               
{               
  long *result;
  long first,second;

  result=find (text,str2,sep);
  first=*result;
  free(result);

  if  (first) 
    {
      result=find(text,par_in,sep);
      second=*result;
      free(result);
      if  (!second)
	return 1 ;
      else 
	return 0;
    } 
  else
    return 0;
}


long *
find_begin_nobar(char *text,char *str2,char *sep)        
//+++++++++++++++++++++++++++++++++++++++++++++++++++++
// ritorna 1 se trova i pattern della stringa str2 e se  davanti al primo di  questi non c'e' "/"

{
  // int MAXWORDS=100,i,n;   // si fissa il massimo numero di words = 100
  char *p,*bar_e_sep,*par_in;//,*par_in2;
  //  char  bar[3]="/";
  char *bar;  
  char *temp;
  long *res = malloc(sizeof(long));
  
  temp=malloc(strlen(str2)+1);
  strcpy(temp,str2);
  
  p=strtok(temp,sep);// printf("primo pezzo: %s\n",p);  
  
  bar = malloc(strlen(p)+1+2);
  //printf("grandezza 1pezzo=%i\n ",strlen(p));
  bar = strcpy(bar,"/"); 
  
  bar_e_sep = strcat(bar,sep);//printf("part davanti 1) %s\n",bar_e_sep);
  par_in = strcat(bar_e_sep,p);//printf("part davanti 2) %s\n",bar_e_sep);
  
  //printf("grandezza 2pezzo=%i\n ",strlen(par_in));
  if  (find_2_without_3(text,str2,par_in,sep))
    {
      *res = 1;
    }
  else 
    { 
      *res = 0; 
    } 
  free(temp);
  free(par_in);
  return res;
}  



long *
one_find_begin_nobar(char *text,char *str2,char *sep,int *seq) 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++  
// Analoga alla find_begin_nobar, soltanto che in piu' utilizza una variabile globale che da o meno l'accesso a questa funzione(se questa var=0 la tale funzione restituisce sempre 0). 
// Puo' essere utilizzata solo in coppia con una one_"qualcosa" che precedentemente ha messo a 1 la variabile globale.
// Questo tipo di funzioni viene utilizzato quando voglio che una certa syscall si verifichi solo se e' arrivata un'altra syscall.

{
 
  char *p,*bar_e_sep,*par_in;
  char *bar;  
  char *temp;
  long *res = malloc(sizeof(long));
  extern int can_access[];
  
  temp=malloc(strlen(str2)+1);
  strcpy(temp,str2);
  
  p=strtok(temp,sep);// printf("primo pezzo: %s\n",p);  
  
  bar = malloc(strlen(p)+1+2);
  //printf("grandezza 1pezzo=%i\n ",strlen(p));
  bar = strcpy(bar,"/"); 
  
  bar_e_sep = strcat(bar,sep);//printf("parte davanti 1) %s\n",bar_e_sep);
  par_in = strcat(bar_e_sep,p);//printf("parte davanti 2) %s\n",bar_e_sep);
  
  //printf("grandezza 2pezzo=%i\n ",strlen(par_in));
  if  (find_2_without_3(text,str2,par_in,sep))
    { 
      can_access[*seq]=1;
      *res = 1;
    }
  else 
    { 
      *res = 0; 
    } 
   free(temp);
   free(par_in); 
   return res;
}  







//__________________________________________________________________________________________________________________________ 


char *read_str_pwd(char *file)  
//+++++++++++++++++++++++++++++
 // Legge e restituisce la prima riga del file che riceve per parametro (per es. /etc/passwd).

{
  
  char *string= malloc(sizeof(char) * 10000);
  FILE *punt;
  
  punt = fopen (file,"r");
  fscanf(punt,"%s",string); 
  return string;
  
}



//__________________________________________________________________________________________________________________________

int  search_words_or (char *text,char **words)  
// Cerco le words del secondo argomento nel text, appena ne trova una ritorna 1 altrimenti ritorna 0.
// Tale funzione viene richiamata dalla "find_or".

{						  
  char *a, *b;
  int find=0, i,tro;
  char *copy=malloc(strlen(text)+1);
  
  copy=strcpy(copy,text);
  //printf("copy non modificato = \"%s\"\n",copy);
  
  if ( ((b = strstr(copy,"HTTP")))&&( strstr(copy,"Connection:"))&&( strstr(copy,"User-Agent:"))) 
    {//printf("caso Browser");
    *b = '\0'; 
    }  
 
  //printf("copy modificato = \"%s\"\n",copy);

   for (i=0;((words[i]!=NULL)&&(find==0));i++)
    { 
      a = strstr(copy,words[i]); 
      
      if (a != NULL) { tro=1; //printf("\"%s\" trovato.\n",words[i]) ;
      }
      else { tro=0;
      }
      
      find=(find || (tro));       
      
    }
  free(copy);   
  return find;  
  
}

long *
find_or(char *text,char *str2,char *sep)       
     //+++++++++++++++++++++++++++++++++++++++++++  
     // trova nel text(arg 1) le words (arg 2) distinte da un separatore (arg3)
     // ritorna 1 se trovate altrimenti 0

{
  int MAXWORDS=10000;   // si fissa il massimo numero di words
  int i;
  char *p[MAXWORDS];
  char *temp; 
  long *res = malloc(sizeof(long));  
  char *copy=malloc(strlen(str2)+1);
  
  copy=strcpy(copy,str2);
  
  //printf("cerca\"%s---\"\n", copy);
  
  for ( i=0;i<MAXWORDS;i++) p[i]=NULL; //inizializzo
  
  p[0]=strtok(copy,sep);

  for(i=1;(((temp = strtok(NULL,sep))!= NULL)&&(i<MAXWORDS));i++) //metto le words da cercare in un array  
    {
      p[i]=temp;
    }
  if  (search_words_or(text,p) == 1)  *res = 1;//passo l'array alla funzione ricerca_words che ritorna 1 se trova la parola
  else *res = 0;                                 // altrimenti torna 0
  free(copy);
  return res;
}





long *
two_find_or(char *text,char *str2,char *sep,int *seq) 
 // Analoga alla find_or, soltanto che in piu' utilizza una variabile globale che da o meno l'accesso a questa funzione(se questa var=0 la tale funzione restituisce sempre 0). 
// Puo' essere utilizzata solo in coppia con una one_"qualcosa" che precedentemente ha messo a 1 la variabile globale.
// Questo tipo di funzioni viene utilizzato quando voglio che una certa syscall si verifichi solo se e' arrivata un'altra syscall.

{
  int MAXWORDS=10000;   // si fissa il massimo numero di words
  int i;
  char *p[MAXWORDS];
  char *temp; 
  long *res = malloc(sizeof(long));  
  char *copy=malloc(strlen(str2)+1);
  extern int can_access[];
  
  copy=strcpy(copy,str2);
  
  //printf("cerca\"%s---\"\n", copy);
  
  for ( i=0;i<MAXWORDS;i++) p[i]=NULL; //inizializzo
  
  p[0]=strtok(copy,sep);
 
  for(i=1;(((temp = strtok(NULL,sep))!= NULL)&&(i<MAXWORDS));i++) //metto le words da cercare in un array  
    {
      p[i]=temp;
    }

  //printf("can_access[%i]=\"%i\"\n ",*seq,can_access[*seq]); 
  
  if  ( (search_words_or(text,p) == 1)&&(can_access[*seq]==1) )  {*res = 1; }//passo l'array alla funzione ricerca_words che ritorna 1 se trova la parola
  else *res = 0; // altrimenti torna 0
  
  can_access[*seq]=0; //la prima write meccia disabilito l'accesso a tutte le altre trova che non abbiano prima mecciato anche la chiamata precedente. Nel caso in cui la prima write non meccia disabilito comunque accesso.
  free(copy);
  return res;
}






//________________________________________________________________________________________________________________________
int checklenght (char *text,int maxpar) 
     // Controlla che la lunghezza del parametro sia inferiore all'arg. "maxpar".
     // ritorna 1 se la lunghezza e' inferiore, altrimenti 0.
{ 
  // printf("max execve_path = %i\n",maxpar);  
  //printf("lunghezza execve_path %i\n",strlen(text));
  if ((strlen(text)) <= maxpar) {
    //printf("lenght path ok \n"); 
    return 1;
  }
  else {// printf("lenght path WRONG \n"); 
  return 0;
  }

}



long *
checksize (char *p1,char *p2[],int *maxpar1,int *maxpar2)  
     //++++++++++++++++++++++++++++++++++++++++++++++++++  
     // controlla che la lunghezza di tutti e due i  parametri sia inferiore 
     // a quella dell' arg. "maxpar1" e "maxpar2".
     // Ritorna 1 se lunghezza e' minore, altrimenti 0.
{
  int sum=0,i;
  long *res = malloc(sizeof(long));

  for (i=0;p2[i]!=NULL;i++)
    {sum=sum+strlen(p2[i]);}

  //printf("max execve_arg = %i\n",*maxpar2);
  //printf("lunghezza execve_arg = %i\n",sum);

  if (( checklenght(p1,*maxpar1) ) && ( sum <= *maxpar2 ) ) { *res = 1; //printf("lenght arg ok \n");
} 

  else {*res = 0; //printf("lenght arg WRONG \n"); 
}

  return res;
}

//___________________________________________________________________________________________________________________________



GHashTable *insert_cgi(char *text)  

{


  GHashTable  *tab_cgi_insecure; 
  int MAXWORDS=100;   // si fissa il massimo numero di words
  int i;
  char *p[10000];
  char *sep=":";
  
  for ( i=0;i<MAXWORDS;i++) p[i]=NULL; //inizializzo
  
  p[0]= malloc(sizeof(char)*20);
  p[0]=strtok(text,sep);
  
  //printf(" \"%s---\"\n", p[0]);
  //printf(" \"--------  0a  parola---\"\n");
  
  p[1] = malloc(sizeof(char)*20); 
  
  tab_cgi_insecure = g_hash_table_new (g_str_hash,g_str_equal ); 
  g_hash_table_insert (tab_cgi_insecure,p[0],p[0]);
  
  i=1; 
  while((p[i] = strtok(NULL,sep))!= NULL)
    {
      //printf(" \"%s---\"\n", p[i]);
      //printf(" \"-------- %ia  parola---\"\n", i);
      g_hash_table_insert (tab_cgi_insecure,p[i],p[i]); 
      i++;
      p[i]= malloc(sizeof(char)*100);
      
    }
  
  return tab_cgi_insecure ;  
}






int  search_cgi_e_dir (GHashTable *tab_cgi_insecure,char **words)  
     // Cerco le words nella tabella. Appena ne trovo una, ritorna 1
     // altrimenti se nessuna e' presente ritorna 0
     
{
  
  int find=0, i,tro;
  
  for (i=0;((words[i]!=NULL)&&(find==0));i++)
    { 
      if  (g_hash_table_lookup (tab_cgi_insecure , words[i])!= NULL)
	{
	  tro=1; //printf("%s trovato\n",words[i]) ;
	}
      else { 
	tro=0; //printf("%s non  trovato\n",words[i]);
      }
      find=(find|| tro);       
    }
  
  return find;  
  
}


int find_cgi_e_dir(GHashTable *tab_cgi_insecure,char *path_cgi,char *text) 
     //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     // Cerca i cgi pericolosi presenti nel file di configurazione.
     // Come parametri riceve per primo la hash table,nella quale  ricerca il cgi, per secondo il path nel quale sono 
     // installati gli script.
     // L'ultimo parametro e' il buffer della execve. Nel caso in cui questo indica che si sta per eseguire di un cgi, ne 
     // viene filtrata la parte dell'estensione (.pl o .cgi) e le eventuali query presenti, dopodiche' sia il nome dello script
     // che i nomi delle dir in cui si trova verranno cercati tramite la funzione search_cgi.
     // Se per esempio ho "path_di_install/cgi-bin/path1/path2/script.cgi" cerco separatamente "path1" "path2" "cgi-bin" "script".
                                                                      
{
  char *a;
  int MAXWORDS=10000;   // si fissa il massimo numero di words
  int i;
  char *p[MAXWORDS];
  char *sep="/";
  char *temp;
  
  for ( i=0;i<MAXWORDS;i++) p[i]=NULL; //inizializzo
  
  a = strstr(text,path_cgi);
  
  if (a == NULL) { return 0; //se non e' un cgi esce subito
  }
 if (a!=NULL) {
   text=a; 
   text=(text+strlen(path_cgi));
               }
 
 p[0]=strtok(text,sep);
 
 for(i=1;( ((temp = strtok(NULL,sep))!= NULL) && (i<MAXWORDS) );i++) //metto le words da cercare in un array
   {p[i]=temp;}
 text=p[i-1];
 p[i-1]=strtok(text,".");  //elimino l'estensione dello script (".cgi",".pl") e tutto cio' che trova dopo lo script
 //come per esempio le varie query string. 
 
 if  (search_cgi_e_dir(tab_cgi_insecure,p) == 1)  return 1;  //passo l'array alla funzione search_cgi che ritorna 1
 // se trova la parola, altrimenti torna 0
 else return 0;                                      
 
 return 1;  
}


long *
search_path (GHashTable *tab_cgi_insecure, char *string_cgi)
{
  long *res = malloc(sizeof(long));
  char *temp;
  
  if  (g_hash_table_lookup (tab_cgi_insecure , string_cgi) != NULL)
    {  // trovato
      *res = 1;
      
    }
  else 
    { 
      temp = strrchr(string_cgi, '/');
      *(++temp) = '\0';
      
      
      if  (g_hash_table_lookup (tab_cgi_insecure , string_cgi) != NULL)
	{  // trovato
	  *res = 1;
	  
	}
      else
	*res = 0;
      
    }
  
  return res;
}

int  search_cgi (GHashTable *tab_cgi_insecure,char *string_cgi)
     // Analoga alla "search_cgi_e_dir", solo che invece di cercare piu' words ne cerca solo una.
     // Tale funzione e' richiamata dalla "find_cgi_con_path" oppure dalla "find_cgi".
  
     
{
  int tro;
  
  if  (g_hash_table_lookup (tab_cgi_insecure , string_cgi)!= NULL)
    {  //printf("%s trovato\n",string_cgi) ;
      return 1;
    }
  else 
    { 
      tro=0;
      return 0;            
    }
}

int find_cgi_con_path(GHashTable *tab_cgi_insecure,char *path_cgi,char *text) 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     // Cerca i cgi pericolosi presenti nel file di configurazione.
     // Come parametri riceve per primo la hash table,nella quale  ricerca il cgi, per secondo il path nel quale sono 
     //installati gli script.
     // L'ultimo parametro e' il buffer della execve. Nel caso in cui questo indica che si sta per eseguire di un cgi, ne 
     // viene filtrata la parte dell'estensione (.pl o .cgi) e le eventuali query presenti, dopodiche' verra' cercato il cgi
     // completo del path con a funzione search_cgi.
     // Ad  es.se ho "path_di_install/cgi-bin/path1/path2/script.cgi" ricerca tutto "/path1/path2/script.cgi" come una stringa unica. 
                                                                      
{
  char *a;
  int MAXWORDS=10000;   // si fissa il massimo numero di words
  int i,n;
  char *p[MAXWORDS];
  char *sep="/",*ricostruito;
  char *temp;
  
  ricostruito = malloc(strlen(text)+1);
  
  for ( i=0;i<MAXWORDS;i++) p[i]=NULL; //inizializzo
  
  a = strstr(text,path_cgi);
  
  if (a == NULL) { return 0; //se non e' un cgi esce subito
  }
  if (a!=NULL) {
    text=a; 
    text=(text+strlen(path_cgi));
  }
  
  p[0]=strtok(text,sep);
  
  for(i=1;( ((temp = strtok(NULL,sep))!= NULL) && (i<MAXWORDS) );i++) //metto le words da cercare in un array
    {p[i]=temp;}
  
  text=p[i-1];
  p[i-1]=strtok(text,".");  //elimino l'estensione dello script (".cgi",".pl") e tutto cio' che trova dopo lo script
  //come per esempio le varie query string. 
  ricostruito=strcpy(ricostruito,p[0]);
  for (n=1;n<i;n++)
    { ricostruito=strcat(ricostruito,sep);
    ricostruito=strcat(ricostruito,p[n]);
    } 
 
  if  (search_cgi(tab_cgi_insecure,ricostruito) == 1)  
    {
     free(ricostruito);
      return 1;
    }
  else
    { 
      free(ricostruito);
      return 0;                                      
    }
  
  
  return 1;  
}


long *
find_cgi(GHashTable *tab_cgi_insecure,char *path_cgi,char *text) 
     //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     // Cerca i cgi pericolosi presenti nel file di configurazione.
     // Come parametri riceve per primo la hash table,nella quale  ricerca il cgi, per secondo il path nel quale sono 
     //installati gli script.
     // L'ultimo parametro e' il buffer della execve. Nel caso in cui questo indica che si sta per eseguire di un cgi, ne 
     // viene filtrata la parte dell'estensione (.pl o .cgi) e le eventuali query presenti, dopodiche' verra' cercato il nome
     // dello script tramite la funzione search_cgi.
     // Per esempio se ho "path_di_install/cgi-bin/path1/path2/script.cgi" ricerco solo "script"
     
{
  char *a;
  int MAXWORDS=10000;   // si fissa il massimo numero di words 
  int i;
  char *p[MAXWORDS];
  char *sep="/";
  char *temp;
  long *res = malloc(sizeof(long));
  
  for ( i=0;i<MAXWORDS;i++) p[i]=NULL; //inizializzo
  
  a = strstr(text,path_cgi);
 
  if (a == NULL) 
    { 
      *res = 0; //se non e' un cgi esce subito
      return res;
    }
  if (a!=NULL) {
    text=a; 
    text=(text+strlen(path_cgi));
  }
  
  p[0]=strtok(text,sep);
  
  for(i=1;( ((temp = strtok(NULL,sep))!= NULL) && (i<MAXWORDS) );i++) //metto le words da cercare in un array
    {p[i]= temp;}  
  
  text=p[i-1];
  p[i-1]=strtok(text,".");  //elimino l'estensione dello script (".cgi",".pl") e tutto cio' che trova dopo lo script
  //come per esempio le varie query string. 
 
  if  (search_cgi(tab_cgi_insecure,p[i-1]) == 1)  *res = 1;  //passo l'array alla funzione search_cgi che ritorna 1
                                                             // se trova la parola, altrimenti torna 0
  else *res = 0;                                      
  
  
  
  return res;  
}




//------------------------------------------------------------------------------------------------------------------

char *union_str(char *part1,char *part2) 
//+++++++++++++++++++++++++++++++++++++++++
// Restituisce la concatenazione dei due argomenti.     

{
   char *temp,*unions;
   temp=malloc(strlen(part1)+strlen(part2)+1);
   part1=strcpy(temp,part1); 
   unions=strcat(part1,part2);   
   return unions;
   
}




//___________________________________________________________________________________________________________________________






long * find_execve(char *text,char *argv[],char *str1,char *str2,char *sep,char *sep_arr)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++ 
// Come la funzione "multi_find_begin_nobar" si controlla che cio' che sta per eseguire l'execve sia o meno lecito.
// Con questa funzione si controlla sia il primo (opzionale) che il secondo argomento della execve.
// Se la stringa str1 e' vuota, passa direttamente a controllare l'array (argv).
// Se invece non e' vuota e non e' contenuta in 'text' ritorna 0.
// Se infine non e' vuota ed e' contenuta in argv[0] prosegue e  controlla argv.
// In particolare si controlla che il secondo argomento di una execve, che e' un array, sia quello che mi aspetto. Piu' precisamente da str1 si ricava un array. Ogni posizione di questo array deve essere contenuto nella rispettiva posizione dell'array argv, l'argomento 2 dell'execve.
// Si cerca in ogni posizione dell'array tramite la funzione find_begin_nobar le corrispondenti parole di str2 separate da un separatore sep. Le varie posizioni dell'array sono delimitate dal separatore sep_arr.Ritorna uno se ha trovato le parole.



{
  char *a,*part0;
  int find=1,tro=0;
  int MAXWORDS=10000;   // si fissa il massimo numero di words
  int i;
  long *res = malloc(sizeof(long));
  char *copy=malloc(strlen(str2)+1);
  char *temp; //=malloc(sizeof(char)*100);
  char **work=malloc(strlen(str2)+1);
  char **work_backup;
  long *result;
  long val;

  if (str1!=NULL) 
    {  
      *res = 0;   
      result=find_begin_nobar(text,str1,sep);
      val=*result;
      free(result);
      if( !(val) ){
	//printf("primo argomento %s diverso.\n",text); 
      return res;}
      // printf("primo argomento %s uguale.\n",text);      
    }  
  
  work_backup=work;
  copy=strcpy(copy,str2);
  //printf("Nel tot. cerca %s in %s %s %s\n",copy,argv[0],argv[1],argv[2]);
  part0 = strtok_r(copy,sep_arr,work); 
  //printf("____________\ncerca %s in ",copy);
  //printf("(find_execve)array0=  \"%s\"\n",argv[0] );
  result=find_begin_nobar(argv[0],part0,sep);
  val=*result;
  free(result);
  if ( val ==1) 
    {find=1 ;// printf("trovato il Num 1 \"%s\"\n",part0);
    }
  else 
    {find=0;
    }

  for(i=1;(((temp=strtok_r(NULL,sep_arr,work))!= NULL)&&(i<MAXWORDS)&&(find==1)&&(argv[i]!=NULL));i++) 
    {
      //printf("____________\ncerca %s in %s\n",temp,argv[i]);
 result=find_begin_nobar(argv[i],temp,sep);
 val=*result;
 free(result);      
 if ( val == 1) 
   {tro=1 ; //printf("trovato il Num %i \"%s\"   \n____________\n",i+1,temp);
   }
      else {tro=0;} 
      if (a!=NULL)
	{text=a; 
	text=(text+strlen(temp)); //ogni volta faccio la ricerca solo sul text rimanente dopo la parola trov.
	}    
      find=(find && tro);   
      
    }
  free(work_backup);     
  free(copy);     
  if (find==1) *res=1;
  else *res=0 ;
  
  return res;
}




long * find_or_array(char *text,char *argv[],char *str1,char *str2,char *sep,int *num_arr) 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++
// Si controlla se nel secondo argomento dell'execve (argv) sia presente almeno uno dei caratteri particolari di str2 separati da sep.
// Con questa funzione si controlla sia il primo (opzionale) che il secondo argomento della execve.

// Se la stringa str1 e' vuota, passa direttamente a controllare l'array (argv).
// Se invece non e' vuota e non e' contenuta in 'text' ritorna 0.
// Se infine non e' vuota ed e' contenuta in argv[0] prosegue e  controlla argv.
// Ritorna 1 se trova almeno una delle parole di str2 divise da un separatore sep, nella posizione dell'array 'argv' specificata da num_arr. 

{
  
  int find=1;
  long *res = malloc(sizeof(long));
  char *copy=malloc(strlen(str2)+1);
  long *result;
  long val;


  if (str1!=NULL) 
    {  
      *res = 0;   
 
      result=find_begin_nobar(text,str1,sep);
      val=*result;
      free(result); 
      if( !val ){
	//printf("primo argomento %s diverso.\n",text); 
	return res;}
      //printf("primo argomento %s uguale.\n",text);      
    }  
  
  copy=strcpy(copy,str2);
  //printf("Nel tot. cerca %s in %s \n",copy,argv[*num_arr]);
  result=find_or(argv[*num_arr],str2,sep);
  val=*result;
  free(result); 
  
  if ( val ==1) 
    {find=1 ; //printf("trovato nella posizione %i \n",*num_arr);
    }
  else 
    {find=0;
    }
  free(copy);     
  if (find==1) *res=1;
  else *res=0 ;
  
  return res;
}
    




long *multi_find_begin_nobar(char *testo,char *str2,char *sep,char *sep_control)
//+++++++++++++++++++++++++++++++++++++++++     
// Controlla che tutto cio' che tenta di eseguire l'execve sia lecito.
// In particolare si controlla che il primo argomento della execve, contenga almeno una delle chiamate previste che si trovano in str2.
//_________
// Per ogni sequenza delimitata dal separatore "sep_control" viene richiamata la funzione find_begin_nobar che riceve oltre alla seq. il primo argomento (testo) nel quale effettuare la ricerca. Se almento una di queste chiamate ha esito positivo ritorna 1 altrimenti 0.
{
     char *parte0;
     int trovate=1;
     int MAXPAROLE=10000;   // si fissa il massimo numero di parole
     int i;
     char *temp;
     long *res = malloc(sizeof(long));
     char *copia=malloc(strlen(str2)+1);
     char **work1=malloc(strlen(str2)+1);
     
      
     long *result;
     long val;

        
     copia=strcpy(copia,str2);
     //printf("l'intera stringa e' %s\n",copia);
     parte0 = strtok_r(copia,sep_control,work1);
     
     //printf("parte0=%s testo=%s\n ",parte0,testo);
     result=find_begin_nobar(testo,parte0,sep);
     val=*result;
     free(result); 
     
     trovate=val;
     
     for(i=1;(((temp = strtok_r(NULL,sep_control,work1))!= NULL)&&(i<MAXPAROLE)&&(trovate==0));i++) //metto le parole da cercare in un array  
{
  result=find_begin_nobar(testo,temp,sep);
  val=*result;
  free(result); 
  
  trovate=val;
  
}

     //printf(" trovate=\"%i\"\n ",trovate);

if (trovate==1)  *res = 1;
else  *res = 0;
free(copia);
free(work1);
return res;  

}
