#ifndef COMMS_H
#define COMMS_H

/*
 * Copyright (c) 2001-2003 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <frassi@iit.cnr.it>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: comms.h,v 1.2 2003/02/17 15:43:50 frassi Exp $
 */


#include "automa_management.h"
/*-------------------------------------------
  struttura usata per inviare all'interfaccia 
  grafica le chiamate di sistema intercettate
  -------------------------------------------*/

typedef struct
{
  int pid;			/* Process Id of this entry */
  long scno;			/* System call number */
  long u_arg[MAX_ARGS];		/* System call arguments */
  arg_state_t arg_state[MAX_ARGS + 1];	/* state arguments */
  int u_error;			/* Error code */
  long u_rval;			/* (first) return value */
  FILE *outf;			/* Output file for this process */
  char *auxstr;			/* Auxiliary info from syscall (see RVAL_STR) */

  event_set_t *ev_set;
  int send_anyway;

  int erase;
} msg_building_info;

msg_building_info *make_msg (struct tcb *tcp);	//il codice e' in msg_element.c

void free_msg_element (msg_building_info ** mbi);	//il codice e' in msg_element.c

#endif
