#ifndef DEFS_H
#define DEFS_H

/*
 * Copyright (c) 2001-2003 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <frassi@iit.cnr.it>
 * for adding wIDSard code
 * Copyright (c) 1991, 1992 Paul Kranenburg <pk@cs.few.eur.nl>
 * Copyright (c) 1993 Branko Lankester <branko@hacktic.nl>
 * Copyright (c) 1993, 1994, 1995, 1996 Rick Sladkey <jrs@world.std.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: defs.h,v 1.2 2003/02/17 15:29:38 frassi Exp $
 */


#include <features.h>


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


/*************************
 * CONFIGURATION SECTION *
 *************************/

#ifndef MAX_PROCS
#define MAX_PROCS	64	/* maximum number of processes tracable */
#endif
#ifndef DEFAULT_STRLEN
#define DEFAULT_STRLEN	32	/* default maximum # of bytes printed in `printstr', change with `-s' switch */
#endif

#ifndef MAX_ARGS
/* #define MAX_ARGS	32	 maximum number of args to a syscall */
#define MAX_ARGS	 8	/* maximum number of args to a syscall */
#endif



/***************
 * FUNDAMENTAL *
 ***************/

#include <sys/types.h>
//#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sys/time.h>
#include <errno.h>
#include <glib.h>

#ifdef STDC_HEADERS
#include <stddef.h>
#endif /* STDC_HEADERS */

/*static const int rval = MAX_ARGS;   syscall return value position */

#ifndef RVAL
#define RVAL	 MAX_ARGS
#endif



/**********
 * PTRACE *
 **********/

/* Work around awkward prototype in ptrace.h. */
#define ptrace xptrace
#include <sys/ptrace.h>
#undef ptrace
#ifdef __STDC__
extern long ptrace(int, int, char *, long);
#else /* !__STDC__ */
extern int ptrace();
#endif /* !__STDC__ */


#if !defined(__GLIBC__)
#define	PTRACE_PEEKUSER	PTRACE_PEEKUSR
#define	PTRACE_POKEUSER	PTRACE_POKEUSR
#endif

#define DEFAULT_PERSONALITY 0




/***********************
 * LINUX SYSCALL TABLE *
 ***********************/

struct sysent 
{
  int	nargs;
  int   (*internal_func)();
  int	(*sys_func)();
  int   (*print_sys)();
  void  (*free_sys)();
  char	*sys_name;
};

extern struct sysent *sysent;


extern int max_strlen; /* lunghezza massima delle stringhe stampate su schermo */


#endif /* !DEFS_H */
