/*
 * Copyright (c) 2000, 2001 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <rete_nera@yahoogroups.com>
 * Copyright (c) 1993 Branko Lankester <branko@hacktic.nl>
 * Copyright (c) 1993, 1994, 1995 Rick Sladkey <jrs@world.std.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: dummy.h,v 1.2 2003/02/17 16:11:04 frassi Exp $
 */


/**********************************
 * FUNCTIONS TO TAKE SYSCALL ARGS *
 **********************************/


/* still unfinished */
#define	sys_ioperm		move_arg
#define	sys_syslog		move_arg
#define	sys_iopl		move_arg
#define	sys_vm86old		move_arg
#define	sys_modify_ldt		move_arg
#define	sys_get_kernel_syms	move_arg
#define	sys_bdflush		move_arg
#define	sys_sysfs		move_arg
#define	sys_afs_syscall		move_arg

#define sys_sched_setparam	move_arg
#define sys_sched_getparam	move_arg
#define sys_sched_setscheduler	move_arg
#define sys_sched_getscheduler	move_arg
#define sys_sched_yield		move_arg
#define sys_sched_get_priority_max move_arg
#define sys_sched_get_priority_min move_arg
#define sys_sched_rr_get_interval  move_arg


/* TODO: controllare che le seguenti definizioni siano corrette */
/* like another call */
#define	sys_uselib		sys_chdir
#define	sys_umount		sys_chdir
#define	sys_swapon		sys_chdir
#define	sys_swapoff		sys_chdir
/* #define	sys_clone		sys_fork */
#define	sys_delete_module	sys_chdir
#define	sys_fchdir		sys_close
#define	sys_setfsuid		sys_setuid
#define	sys_setfsgid		sys_setgid
#define sys_nanosleep		sys_adjtime
#define	sys_acct		sys_chdir ///////////////////////////////////////////
#define sys_fdatasync		sys_close
#define sys_mlock		sys_munmap
#define sys_munlock		sys_munmap

/* move_arg does the right thing */
#define	sys_setup		move_arg
#define	sys_getpid		move_arg
#define	sys_getuid		move_arg
#define	sys_pause		move_arg
#define	sys_sync		move_arg
#define	sys_getgid		move_arg
#define	sys_geteuid		move_arg
#define	sys_getegid		move_arg
#define	sys_getppid		move_arg
#define	sys_getpgrp		move_arg
#define	sys_setsid		move_arg
#define	sys_vhangup		move_arg
#define	sys_idle		move_arg
#define	sys_getpgid		move_arg
#define sys_munlockall		move_arg

/* subcall entry points */
#define	sys_socketcall		move_arg
#define	sys_ipc			move_arg

/* unimplemented */
#define	sys_stty		move_arg
#define	sys_gtty		move_arg
#define	sys_ftime		move_arg
#define	sys_prof		move_arg
//#define	sys_acct		move_arg
#define	sys_phys		move_arg
#define	sys_lock		move_arg
#define	sys_mpx			move_arg
#define	sys_ulimit		move_arg
#define	sys_profil		move_arg
#define	sys_ustat		move_arg
#define	sys_break		move_arg

/* deprecated */
#define	sys_olduname		move_arg
#define	sys_oldolduname		move_arg

/* no library support */
#ifndef HAVE_SENDMSG
#define sys_sendmsg		move_arg
#define sys_recvmsg		move_arg
#endif

#if DONE
#define sys_oldselect		move_arg
#define	sys_msync		move_arg
#define	sys_flock		move_arg
#define	sys_getdents		move_arg
#define	sys_stime		move_arg
#define	sys_time		move_arg
#define	sys_times		move_arg
#define	sys_mount		move_arg
#define	sys_nice		move_arg
#define	sys_mprotect		move_arg
#define	sys_sigprocmask		move_arg
#define	sys_adjtimex		move_arg
#define	sys_sysinfo		move_arg
#define	sys_ipc			move_arg
#define	sys_setdomainname	move_arg
#define	sys_statfs		move_arg
#define	sys_fstatfs		move_arg
#define	sys_ptrace		move_arg
#define	sys_sigreturn		move_arg
#define	sys_fsync		move_arg
#define	sys_alarm		move_arg
#define	sys_socketcall		move_arg
#define	sys_sigsuspend		move_arg
#define	sys_utime		move_arg
#define	sys_brk			move_arg
#define	sys_mmap		move_arg
#define	sys_munmap		move_arg
#define	sys_select		move_arg
#define	sys_setuid		move_arg
#define	sys_setgid		move_arg
#define	sys_setreuid		move_arg
#define	sys_setregid		move_arg
#define	sys_getgroups		move_arg
#define	sys_setgroups		move_arg
#define	sys_setrlimit		move_arg
#define	sys_getrlimit		move_arg
#define	sys_getrusage		move_arg
#define	sys_getpriority		move_arg
#define	sys_setpriority		move_arg
#define	sys_setpgid		move_arg
#define	sys_access		move_arg
#define	sys_sethostname		move_arg
#define	sys_readdir		move_arg
#define	sys_waitpid		move_arg
#define	sys_wait4		move_arg
#define	sys_execve		move_arg
#define	sys_fork		move_arg
#define	sys_uname		move_arg
#define	sys_pipe		move_arg
#define	sys_siggetmask		move_arg
#define	sys_sigsetmask		move_arg
#define	sys_exit		move_arg
#define	sys_kill		move_arg
#define	sys_signal		move_arg
#define	sys_sigaction		move_arg
#define	sys_sigpending		move_arg
#define	sys_fcntl		move_arg
#define	sys_dup			move_arg
#define	sys_dup2		move_arg
#define	sys_close		move_arg
#define	sys_ioctl		move_arg
#define	sys_read		move_arg
#define	sys_write		move_arg
#define	sys_open		move_arg
#define	sys_creat		move_arg
#define	sys_link		move_arg
#define	sys_unlink		move_arg
#define	sys_chdir		move_arg
#define	sys_mknod		move_arg
#define	sys_chmod		move_arg
#define	sys_chown		move_arg
#define	sys_lseek		move_arg
#define	sys_rename		move_arg
#define	sys_mkdir		move_arg
#define	sys_rmdir		move_arg
#define	sys_umask		move_arg
#define	sys_chroot		move_arg
#define	sys_gettimeofday	move_arg
#define	sys_settimeofday	move_arg
#define	sys_symlink		move_arg
#define	sys_readlink		move_arg
#define	sys_truncate		move_arg
#define	sys_ftruncate		move_arg
#define	sys_fchmod		move_arg
#define	sys_fchown		move_arg
#define	sys_setitimer		move_arg
#define	sys_getitimer		move_arg
#define	sys_stat		move_arg
#define	sys_lstat		move_arg
#define	sys_fstat		move_arg
#define	sys_personality		move_arg
#define sys_poll		move_arg
#define	sys_create_module	move_arg
#define	sys_init_module		move_arg
//#define sys_quotactl		move_arg
//#define sys_mlockall		move_arg
#endif


/***********************************
 * FUNCTIONS TO PRINT SYSCALL ARGS *
 ***********************************/



/* still unfinished */
#define	print_reboot		printargs
#define	print_ioperm		printargs
#define	print_syslog		printargs
#define	print_iopl		printargs
#define	print_vm86old		printargs
#define	print_modify_ldt	printargs
#define	print_get_kernel_syms	printargs
#define	print_quotactl		printargs
#define	print_bdflush		printargs
#define	print_sysfs		printargs
#define	print_afs_syscall	printargs

#define print_fdatasync		printargs
#define print_mlock		printargs
#define print_munlock		printargs
#define print_mlockall		printargs
#define print_munlockall	printargs
#define print_sched_setparam	printargs
#define print_sched_getparam	printargs
#define print_sched_setscheduler	printargs
#define print_sched_getscheduler	printargs
#define print_sched_yield		printargs
#define print_sched_get_priority_max    printargs
#define print_sched_get_priority_min    printargs
#define print_sched_rr_get_interval     printargs

/* like another call */
#define	print_uselib		print_chdir
#define	print_umount		print_chdir
#define	print_swapon		print_chdir
#define	print_swapoff		print_chdir
/* #define	print_clone		print_fork */
#define	print_delete_module	print_chdir
#define	print_fchdir		print_close
#define	print_setfsuid		print_setuid
#define	print_setfsgid		print_setgid
#define print_nanosleep		print_adjtime

/* printargs does the right thing */
#define	print_setup		printargs
#define	print_getpid		printargs
#define	print_getuid		printargs
#define	print_pause		printargs
#define	print_sync		printargs
#define	print_getgid		printargs
#define	print_geteuid		printargs
#define	print_getegid		printargs
#define	print_getppid		printargs
#define	print_getpgrp		printargs
#define	print_setsid		printargs
#define	print_vhangup		printargs
#define	print_idle		printargs
#define	print_getpgid		printargs

/* subcall entry points */
#define	print_socketcall	printargs
#define	print_ipc		printargs

/* unimplemented */
#define	print_stty		printargs
#define	print_gtty		printargs
#define	print_ftime		printargs
#define	print_prof		printargs
#define	print_acct		printargs
#define	print_phys		printargs
#define	print_lock		printargs
#define	print_mpx		printargs
#define	print_ulimit		printargs
#define	print_profil		printargs
#define	print_ustat		printargs
#define	print_break		printargs

/* deprecated */
#define	print_olduname		printargs
#define	print_oldolduname	printargs

/* no library support */
#ifndef HAVE_SENDMSG
#define print_sendmsg		printargs
#define print_recvmsg		printargs
#endif

#if DONE
#define print_oldselect		printargs
#define	print_msync		printargs
#define	print_flock		printargs
#define	print_getdents		printargs
#define	print_stime		printargs
#define	print_time		printargs
#define	print_times		printargs
#define	print_mount		printargs
#define	print_nice		printargs
#define	print_mprotect		printargs
#define	print_sigprocmask	printargs
#define	print_adjtimex		printargs
#define	print_sysinfo		printargs
#define	print_ipc		printargs
#define	print_setdomainname	printargs
#define	print_statfs		printargs
#define	print_fstatfs		printargs
#define	print_ptrace		printargs
#define	print_sigreturn		printargs
#define	print_fsync		printargs
#define	print_alarm		printargs
#define	print_socketcall	printargs
#define	print_sigsuspend	printargs
#define	print_utime		printargs
#define	print_brk		printargs
#define	print_mmap		printargs
#define	print_munmap		printargs
#define	print_select		printargs
#define	print_setuid		printargs
#define	print_setgid		printargs
#define	print_setreuid		printargs
#define	print_setregid		printargs
#define	print_getgroups		printargs
#define	print_setgroups		printargs
#define	print_setrlimit		printargs
#define	print_getrlimit		printargs
#define	print_getrusage		printargs
#define	print_getpriority	printargs
#define	print_setpriority	printargs
#define	print_setpgid		printargs
#define	print_access		printargs
#define	print_sethostname	printargs
#define	print_readdir		printargs
#define	print_waitpid		printargs
#define	print_wait4		printargs
#define	print_execve		printargs
#define	print_fork		printargs
#define	print_uname		printargs
#define	print_pipe		printargs
#define	print_siggetmask	printargs
#define	print_sigsetmask	printargs
#define	print_exit		printargs
#define	print_kill		printargs
#define	print_signal		printargs
#define	print_sigaction		printargs
#define	print_sigpending	printargs
#define	print_fcntl		printargs
#define	print_dup		printargs
#define	print_dup2		printargs
#define	print_close		printargs
#define	print_ioctl		printargs
#define	print_read		printargs
#define	print_write		printargs
#define	print_open		printargs
#define	print_creat		printargs
#define	print_link		printargs
#define	print_unlink		printargs
#define	print_chdir		printargs
#define	print_mknod		printargs
#define	print_chmod		printargs
#define	print_chown		printargs
#define	print_lseek		printargs
#define	print_rename		printargs
#define	print_mkdir		printargs
#define	print_rmdir		printargs
#define	print_umask		printargs
#define	print_chroot		printargs
#define	print_gettimeofday	printargs
#define	print_settimeofday	printargs
#define	print_symlink		printargs
#define	print_readlink		printargs
#define	print_truncate		printargs
#define	print_ftruncate		printargs
#define	print_fchmod		printargs
#define	print_fchown		printargs
#define	print_setitimer		printargs
#define	print_getitimer		printargs
#define	print_stat		printargs
#define	print_lstat		printargs
#define	print_fstat		printargs
#define	print_personality	printargs
#define print_poll		printargs
#define	print_create_module	printargs
#define	print_init_module	printargs
#endif

