/*
 * Copyright (c) 2000, 2001 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <rete_nera@yahoogroups.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: syscallargsent.h,v 1.3 2003/02/17 16:12:32 frassi Exp $
 */


{0,               0,                           0,                     0,             0,0}, /* 0 */
{INT,             0,                           0,                     0,             0,0}, /* 1 */
{0,               0,                           0,                     0,             0,0}, /* 2 */
{UNSIGNED_INT,    CHAR_PTR,                   SIZE_T,                0,             0,0}, /* 3 */
{UNSIGNED_INT,    CHAR_PTR,                   SIZE_T,                0,             0,0}, /* 4 */
{CHAR_PTR, INT,                               INT,                   0,             0,0}, /* 5 */
{UNSIGNED_INT,    0,                           0,                     0,             0,0}, /* 6 */
{PID_T,           UNSIGNED_INT_PTR,           INT,                   0,             0,0}, /* 7 */
{CHAR_PTR, INT,                         0,                     0,             0,0}, /* 8 */
{CHAR_PTR, CHAR_PTR,             0,                     0,             0,0}, /* 9 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 10 */
{CHAR_PTR, CHAR_PTR_PTR,       CHAR_PTR_PTR, 0,             0,0}, /* 11 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 12 */
{INT_PTR,        0,                           0,                     0,             0,0}, /* 13 */
{CHAR_PTR, INT,                         DEV_T,                 0,             0,0}, /* 14 */
{CHAR_PTR, MODE_T,                      0,                     0,             0,0}, /* 15 */
{CHAR_PTR, UID_T,                       GID_T,                 0,             0,0}, /* 16 */
{0,               0,                           0,                     0,             0,0}, /* 17 */
{CHAR_PTR, STRUCT_OLD_KERNEL_STAT_PTR, 0,                     0,             0,0}, /* 18 */
{UNSIGNED_INT,    OFF_T,                       UNSIGNED_INT,          0,             0,0}, /* 19 */
{0,               0,                           0,                     0,             0,0}, /* 20 */
{CHAR_PTR, CHAR_PTR,             CHAR_PTR,       UNSIGNED_LONG, VOID_PTR,0}, /* 21 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 22 */
{UID_T,           0,                           0,                     0,             0,0}, /* 23 */
{0,               0,                           0,                     0,             0,0}, /* 24 */
{INT_PTR,        0,                           0,                     0,             0,0}, /* 25 */
{LONG,            LONG,                        LONG,                  LONG,          0,0}, /* 26 */
{UNSIGNED_INT,    0,                           0,                     0,             0,0}, /* 27 */
{UNSIGNED_INT,    STRUCT_OLD_KERNEL_STAT_PTR, 0,                     0,             0,0}, /* 28 */
{0,               0,                           0,                     0,             0,0}, /* 29 */
{CHAR_PTR,       STRUCT_UTIMBUF_PTR,         0,                     0,             0,0}, /* 30 */
{0,               0,                           0,                     0,             0,0}, /* 31 non implementata, neanche nell'strace, penso che faccia il printargs*/
{0,               0,                           0,                     0,             0,0}, /* 32 non implementata, neanche nell'strace, penso che faccia il printargs*/
{CHAR_PTR, INT,                         0,                     0,             0,0}, /* 33 */
{INT,             0,                           0,                     0,             0,0}, /* 34 */
{0,               0,                           0,                     0,             0,0}, /* 35 implementata come funzione di libreria, neanche nell'....*/
{0,               0,                           0,                     0,             0,0}, /* 36 */
{INT,             INT,                         0,                     0,             0,0}, /* 37 */
{CHAR_PTR, CHAR_PTR,             0,                     0,             0,0}, /* 38 */
{CHAR_PTR, INT,                         0,                     0,             0,0}, /* 39 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 40 */
{UNSIGNED_INT,    0,                           0,                     0,             0,0}, /* 41 */
{UNSIGNED_LONG_PTR, 0,                        0,                     0,             0,0}, /* 42 */
{STRUCT_TMS_PTR, 0,                           0,                     0,             0,0}, /* 43 */
{0,               0,                           0,                     0,             0,0}, /* 44 non implementata,neanche...*/
{VOID_PTR,       0,                           0,                     0,             0,0}, /* 45 */
{GID_T,           0,                           0,                     0,             0,0}, /* 46 */
{0,               0,                           0,                     0,             0,0}, /* 47 */
{INT,             SIGHANDLER_T,                0,                     0,             0,0}, /* 48 da ricontrollare perche' syscallent.h si aspetta 3 argomenti, anche se poi non ci fa niente con il terzo argomento*/
{0,               0,                           0,                     0,             0,0}, /* 49 */
{0,               0,                           0,                     0,             0,0}, /* 50 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 51 */
{CHAR_PTR,       INT,                         0,                     0,             0,0}, /* 52 */
{0,               0,                           0,                     0,             0,0}, /* 53 */
{UNSIGNED_INT,    UNSIGNED_INT,                UNSIGNED_LONG,         0,             0,0}, /* 54 */
{UNSIGNED_INT,    UNSIGNED_INT,                UNSIGNED_LONG,         0,             0,0}, /* 55 */
{0,               0,                           0,                     0,             0,0}, /* 56 */
{PID_T,           PID_T,                       0,                     0,             0,0}, /* 57 */
{0,               0,                           0,                     0,             0,0}, /* 58 obsoleta,la funzione sys_ulimit non e' implementata nell'strace*/
{STRUCT_OLDOLD_UTSNAME_PTR, 0,                0,                     0,             0,0}, /* 59 da ricontrollare,obsoleta*/
{INT,             0,                           0,                     0,             0,0}, /* 60 */	
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 61 */
{DEV_T,           STRUCT_USTAT_PTR,           0,                     0,             0,0}, /* 62 */
{UNSIGNED_INT,    UNSIGNED_INT,                0,                     0,             0,0}, /* 63 */
{0,               0,                           0,                     0,             0,0}, /* 64 */
{0,               0,                           0,                     0,             0,0}, /* 65 */
{0,               0,                           0,                     0,             0,0}, /* 66 */
{INT,             STRUCT_OLD_SIGACTION_PTR, STRUCT_OLD_SIGACTION_PTR, 0,     0,0}, /* 67 */
{0,               0,                           0,                     0,             0,0}, /* 68 */
{INT,             0,                           0,                     0,             0,0}, /* 69 */
{UID_T,           UID_T,                       0,                     0,             0,0}, /* 70 */
{GID_T,           GID_T,                       0,                     0,             0,0}, /* 71 */
{INT,             INT,                         OLD_SIGSET_T,          0,             0,0}, /* 72 il man segnala un solo argomento, il terzo, ma solo perche' gli altri 2 sono reliquie storiche, difatti strace lavora solo sul terzo*/
{OLD_SIGSET_PTR, 0,                           0,                     0,             0,0}, /* 73 */
{CHAR_PTR,       INT,                         0,                     0,             0,0}, /* 74 */
{UNSIGNED_INT,    STRUCT_RLIMIT_PTR,          0,                     0,             0,0}, /* 75 */
{UNSIGNED_INT,    STRUCT_RLIMIT_PTR,          0,                     0,             0,0}, /* 76 */
{INT,             STRUCT_RUSAGE_PTR,          0,                     0,             0,0}, /* 77 */
{STRUCT_TIMEVAL_PTR, STRUCT_TIMEZONE_PTR,    0,                     0,             0,0}, /* 78 */
{STRUCT_TIMEVAL_PTR, STRUCT_TIMEZONE_PTR,    0,                     0,             0,0}, /* 79 */
{INT,             GID_T_PTR,                  0,                     0,             0,0}, /* 80 */
{INT,             GID_T_PTR,                  0,                     0,             0,0}, /* 81 */
{STRUCT_SEL_ARG_STRUCT_PTR, 0,                0,                     0,             0,0}, /* 82 */
{CHAR_PTR, CHAR_PTR,             0,                     0,             0,0}, /* 83 */
{CHAR_PTR,       STRUCT_OLD_KERNEL_STAT_PTR, 0,                     0,             0,0}, /* 84 */
{CHAR_PTR, CHAR_PTR,                   INT,                   0,             0,0}, /* 85 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 86 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 87 numero arg. sbagliato, ci sarebbe anche un int (flags),strace in realta' lo tratta come se fosse chdir (non definito, stampa solo gli argomenti) */
{INT,             INT,                         INT,                   0,             0,0}, /* 88 ? strace ne stampa solo gli argomenti, ma il man segnala un quarto argomento di tipo puntatore a void,non so che fare*/
{UNSIGNED_INT,    VOID_PTR,                   UNSIGNED_INT,          0,             0,0}, /* 89 */
{VOID_PTR,       SIZE_T,                      INT,                   INT,           INT, OFF_T}, /* 90 VEDI ANCHE SYSCALLS (2) NEL MAN*/
{UNSIGNED_LONG,   SIZE_T,                      0,                     0,             0,0}, /* 91 */
{CHAR_PTR, UNSIGNED_LONG,               0,                     0,             0,0}, /* 92 */
{UNSIGNED_INT,    UNSIGNED_LONG,               0,                     0,             0,0}, /* 93 */
{UNSIGNED_INT,    MODE_T,                      0,                     0,             0,0}, /* 94 */
{UNSIGNED_INT,    UID_T,                       GID_T,                 0,             0,0}, /* 95 */
{INT,             INT,                         0,                     0,             0,0}, /* 96 */
{INT,             INT,                         INT,                   0,             0,0}, /* 97 */
{U_SHORT_PTR,    SIZE_T,                      SIZE_T,                  UINT,         0,0}, /* 98 implementata come funzione di libreria. strace stampa solo argomenti*/
{CHAR_PTR, STRUCT_STATFS_PTR,          0,                     0,             0,0}, /* 99 */
{UNSIGNED_INT,    STRUCT_STATFS_PTR,          0,                     0,             0,0}, /* 100 */
{UNSIGNED_LONG,   UNSIGNED_LONG,               INT,                   0,             0,0}, /* 101 */
{INT,             UNSIGNED_LONG_PTR,          0,                     0,             0,0}, /* 102 */
{INT,             CHAR_PTR,                   INT,                   0,             0,0}, /* 103 */
{INT,             STRUCT_ITIMERVAL_PTR,       STRUCT_ITIMERVAL_PTR, 0,            0,0}, /* 104 */
{INT,             STRUCT_ITIMERVAL_PTR,       0,                     0,             0,0}, /* 105 */
{CHAR_PTR,       STRUCT_STAT_PTR,             0,                     0,             0,0}, /* 106 */
{CHAR_PTR,       STRUCT_STAT_PTR,             0,                     0,             0,0}, /* 107 */
{UNSIGNED_INT,    STRUCT_STAT_PTR,             0,                     0,             0,0}, /* 108 */
{STRUCT_OLD_UTSNAME_PTR, 0,                   0,                     0,             0,0}, /* 109 */
{UNSIGNED_LONG,   0,                           0,                     0,             0,0}, /* 110 */
{0,               0,                           0,                     0,             0,0}, /* 111 */
{0,               0,                           0,                     0,             0,0}, /* 112 */

/*
  FINO QUI
 */

{UNSIGNED_LONG,   0,                           0,                     0,             0,0}, /* 113 DA C.*/
{PID_T,           UNSIGNED_LONG_PTR,          INT,                   STRUCT_RUSAGE_PTR, 0,0}, /* 114 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 115 */
{STRUCT_SYSINFO_PTR, 0,                       0,                     0,             0,0}, /* 116 */
{UINT,            INT,                         INT,                   INT,           VOID_PTR,0}, /* 117 DA C.*/
{UNSIGNED_INT,    0,                           0,                     0,             0,0}, /* 118 */
{UNSIGNED_LONG,   0,                           0,                     0,             0,0}, /* 119 */
{STRUCT_PT_REGS,  0,                           0,                     0,             0,0}, /* 120 DA C.*/
{CHAR_PTR,       INT,                         0,                     0,             0,0}, /* 121 */
{STRUCT_NEW_UTSNAME_PTR, 0,                   0,                     0,             0,0}, /* 122 */
{INT,             VOID_PTR,                   UNSIGNED_LONG,         0,             0,0}, /* 123 */
{STRUCT_TIMEX_PTR, 0,                         0,                     0,             0,0}, /* 124 */
{UNSIGNED_LONG,   SIZE_T,                      UNSIGNED_LONG,         0,             0,0}, /* 125 */
{INT,             OLD_SIGSET_PTR,             OLD_SIGSET_PTR,       0,             0,0}, /* 126 */
{CHAR_PTR, SIZE_T,                      0,                     0,             0,0}, /* 127 */
{CHAR_PTR, STRUCT_MODULE_PTR,          0,                     0,             0,0}, /* 128 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 129 */
{CHAR_PTR, 0,                           0,                     0,             0,0}, /* 130 */
{INT,             CHAR_PTR,             INT,                   CADDR_T,       0,0}, /* 131 */
{PID_T,           0,                           0,                     0,             0,0}, /* 132 */
{UNSIGNED_INT,    0,                           0,                     0,             0,0}, /* 133 */
{INT,             LONG,                        0,                     0,             0,0}, /* 134 DA C.*/
{INT,             UNSIGNED_LONG,               UNSIGNED_LONG,         0,             0,0}, /* 135 */
{UNSIGNED_LONG,   0,                           0,                     0,             0,0}, /* 136 */
{0,               0,                           0,                     0,             0,0}, /* 137 DA C. */
{UID_T,           0,                           0,                     0,             0,0}, /* 138 */
{GID_T,           0,                           0,                     0,             0,0}, /* 139 */
{UNSIGNED_INT,    UNSIGNED_LONG,               UNSIGNED_LONG,         LOFF_T_PTR,   UNSIGNED_INT,0}, /* 140 */
{UNSIGNED_INT,    VOID_PTR,                   UNSIGNED_INT,          0,             0,0}, /* 141 */
{INT,             FD_SET_PTR,                 FD_SET_PTR,           FD_SET_PTR,   STRUCT_TIMEVAL_PTR,0}, /* 142 */
{UNSIGNED_INT,    UNSIGNED_INT,                0,                     0,             0,0}, /* 143 */
{UNSIGNED_LONG,   SIZE_T,                      INT,                   0,             0,0}, /* 144 */
{UNSIGNED_LONG,   STRUCT_IOVEC_PTR,     UNSIGNED_LONG,         0,             0,0}, /* 145 */
{UNSIGNED_LONG,   STRUCT_IOVEC_PTR,     UNSIGNED_LONG,         0,             0,0}, /* 146 */
{PID_T,           0,                           0,                     0,             0,0}, /* 147 */
{UNSIGNED_INT,    0,                           0,                     0,             0,0}, /* 148 */
{STRUCT_SYSCTL_ARGS_PTR, 0,                   0,                     0,             0,0}, /* 149 */
{UNSIGNED_LONG,   0,                           0,                     0,             0,0}, /* 150 DA C. */
{UNSIGNED_LONG,   SIZE_T,                      0,                     0,             0,0}, /* 151 */
{INT,             0,                           0,                     0,             0,0}, /* 152 DA C. */
{0,               0,                           0,                     0,             0,0}, /* 153 DA C.*/
{0,               0,                           0,                     0,             0,0}, /* 154 DA C.*/
{PID_T,           STRUCT_SCHED_PARAM_PTR,     0,                     0,             0,0}, /* 155 */
{PID_T,           INT,                         STRUCT_SCHED_PARAM_PTR, 0,           0,0}, /* 156 */
{PID_T,           0,                           0,                     0,             0,0}, /* 157 */
{0,               0,                           0,                     0,             0,0}, /* 158 */
{INT,             0,                           0,                     0,             0,0}, /* 159 */
{INT,             0,                           0,                     0,             0,0}, /* 160 */
{PID_T,           STRUCT_TIMESPEC_PTR,        0,                     0,             0,0}, /* 161 */
{STRUCT_TIMESPEC_PTR, STRUCT_TIMESPEC_PTR,   0,                     0,             0,0}, /* 162 */
{UNSIGNED_LONG,   UNSIGNED_LONG,               UNSIGNED_LONG,         UNSIGNED_LONG, 0,0}, /* 163 */
{UID_T,           UID_T,                       UID_T,                 0,             0,0}, /* 164 */
{UID_T_PTR,      UID_T_PTR,                  UID_T_PTR,            0,             0,0}, /* 165 */
{STRUCT_VM86_STRUCT_PTR, 0,                   0,                     0,             0,0}, /* 166 DA C. */
{CHAR_PTR, INT,                         CHAR_PTR,             SIZE_T,        SIZE_T_PTR,0}, /* 167 */
{STRUCT_POLLFD_PTR, UNSIGNED_INT,             LONG,                  0,             0,0}, /* 168 */
{INT,             VOID_PTR,                   VOID_PTR,             0,             0,0}, /* 169 */
{GID_T,           GID_T,                       GID_T,                 0,             0,0}, /* 170 */
{GID_T_PTR,      GID_T_PTR,                  GID_T_PTR,            0,             0,0}, /* 171 */
{INT,             UNSIGNED_LONG,               UNSIGNED_LONG,         UNSIGNED_LONG, UNSIGNED_LONG,0}, /* 172 */
{UNSIGNED_LONG,   0,                           0,                     0,             0,0}, /* 173 */
{INT,             STRUCT_SIGACTION_PTR, STRUCT_SIGACTION_PTR, SIZE_T,        0,0}, /* 174 */
{INT,             SIGSET_T_PTR,               SIGSET_T_PTR,          SIZE_T,        0,0}, /* 175 */
{SIGSET_T_PTR,   SIZE_T,                      0,                     0,             0,0}, /* 176 */
{SIGSET_T_PTR, SIGINFO_T_PTR,          STRUCT_TIMESPEC_PTR, SIZE_T,   0,0}, /* 177 */
{INT,             INT,                         SIGINFO_T_PTR,        0,             0,0}, /* 178 */
{SIGSET_T_PTR,   SIZE_T,                      0,                     0,             0,0}, /* 179 */
{UNSIGNED_INT,    CHAR_PTR,                   SIZE_T,                LOFF_T,        0,0}, /* 180 DA C.*/
{UNSIGNED_INT,    CHAR_PTR,             SIZE_T,                LOFF_T,        0,0}, /* 181 DA C.*/
{CHAR_PTR, UID_T,                       GID_T,                 0,             0,0}, /* 182 */
{CHAR_PTR,       UNSIGNED_LONG,               0,                     0,             0,0}, /* 183 */
{CAP_USER_HEADER_T, CAP_USER_DATA_T,           0,                     0,             0,0}, /* 184 */
{CAP_USER_HEADER_T, CAP_USER_DATA_T,     0,                     0,             0,0}, /* 185 */
{STACK_T_PTR, STACK_T_PTR,             0,                     0,             0,0}, /* 186 */
{INT,             INT,                         OFF_T_PTR,            SIZE_T,        0,0}, /* 187 */
{0,               0,                           0,                     0,             0,0}, /* 188 non utilizzata*/
{0,               0,                           0,                     0,             0,0}, /* 189 non utilizzata*/
{0,               0,                           0,                     0,             0,0}, /* 190 DA C. */
{UNSIGNED_INT,    STRUCT_RLIMIT_PTR,          0,                     0,             0,0}, /* 191 PRINTARGS */
{VOID_PTR,       SIZE_T,                      INT,                   INT,           INT, OFF_T}, /* 192 */
{0,               0,                           0,                     0,             0,0}, /* 193 da c.,non ne trovo traccia*/
{0,               0,                           0,                     0,             0,0}, /* 194 da c.,non ne trovo traccia*/
{CHAR_PTR, STRUCT_STAT_PTR,            0,                     0,             0,0}, /* 195 */
{CHAR_PTR, STRUCT_STAT_PTR,            0,                     0,             0,0}, /* 196 */
{INT,             STRUCT_STAT_PTR,            0,                     0,             0,0}, /* 197 */
{0,               0,                           0,                     0,             0,0}, /* 198 non utilizzata*/
{0,               0,                           0,                     0,             0,0}, /* 199 non utilizzata*/

{0,               0,                           0,                     0,             0,0}, /* 200 */
{0,               0,                           0,                     0,             0,0}, /* 201 */
{0,               0,                           0,                     0,             0,0}, /* 202 */
{0,               0,                           0,                     0,             0,0}, /* 203 */
{0,               0,                           0,                     0,             0,0}, /* 204 */
{0,               0,                           0,                     0,             0,0}, /* 205 */
{0,               0,                           0,                     0,             0,0}, /* 206 */
{0,               0,                           0,                     0,             0,0}, /* 207 */
{0,               0,                           0,                     0,             0,0}, /* 208 */
{0,               0,                           0,                     0,             0,0}, /* 209 */
{0,               0,                           0,                     0,             0,0}, /* 210 */
{0,               0,                           0,                     0,             0,0}, /* 211 */
{0,               0,                           0,                     0,             0,0}, /* 212 */
{0,               0,                           0,                     0,             0,0}, /* 213 */
{0,               0,                           0,                     0,             0,0}, /* 214 */
{0,               0,                           0,                     0,             0,0}, /* 215 */
{0,               0,                           0,                     0,             0,0}, /* 216 */
{0,               0,                           0,                     0,             0,0}, /* 217 */
{0,               0,                           0,                     0,             0,0}, /* 218 */
{0,               0,                           0,                     0,             0,0}, /* 219 */
{0,               0,                           0,                     0,             0,0}, /* 220 */
{0,               0,                           0,                     0,             0,0}, /* 221 */
{0,               0,                           0,                     0,             0,0}, /* 222 */
{0,               0,                           0,                     0,             0,0}, /* 223 */
{0,               0,                           0,                     0,             0,0}, /* 224 */
{0,               0,                           0,                     0,             0,0}, /* 225 */
{0,               0,                           0,                     0,             0,0}, /* 226 */
{0,               0,                           0,                     0,             0,0}, /* 227 */
{0,               0,                           0,                     0,             0,0}, /* 228 */
{0,               0,                           0,                     0,             0,0}, /* 229 */
{0,               0,                           0,                     0,             0,0}, /* 230 */
{0,               0,                           0,                     0,             0,0}, /* 231 */
{0,               0,                           0,                     0,             0,0}, /* 232 */
{0,               0,                           0,                     0,             0,0}, /* 233 */
{0,               0,                           0,                     0,             0,0}, /* 234 */
{0,               0,                           0,                     0,             0,0}, /* 235 */
{0,               0,                           0,                     0,             0,0}, /* 236 */
{0,               0,                           0,                     0,             0,0}, /* 237 */
{0,               0,                           0,                     0,             0,0}, /* 238 */
{0,               0,                           0,                     0,             0,0}, /* 239 */
{0,               0,                           0,                     0,             0,0}, /* 240 */
{0,               0,                           0,                     0,             0,0}, /* 241 */
{0,               0,                           0,                     0,             0,0}, /* 242 */
{0,               0,                           0,                     0,             0,0}, /* 243 */
{0,               0,                           0,                     0,             0,0}, /* 244 */
{0,               0,                           0,                     0,             0,0}, /* 245 */
{0,               0,                           0,                     0,             0,0}, /* 246 */
{0,               0,                           0,                     0,             0,0}, /* 247 */
{0,               0,                           0,                     0,             0,0}, /* 248 */
{0,               0,                           0,                     0,             0,0}, /* 249 */
{0,               0,                           0,                     0,             0,0}, /* 250 */
{0,               0,                           0,                     0,             0,0}, /* 251 */
{0,               0,                           0,                     0,             0,0}, /* 252 */
{0,               0,                           0,                     0,             0,0}, /* 253 */
{0,               0,                           0,                     0,             0,0}, /* 254 */
{0,               0,                           0,                     0,             0,0}, /* 255 */
{0,               0,                           0,                     0,             0,0}, /* 256 */
{0,               0,                           0,                     0,             0,0}, /* 257 */
{0,               0,                           0,                     0,             0,0}, /* 258 */
{0,               0,                           0,                     0,             0,0}, /* 259 */
{0,               0,                           0,                     0,             0,0}, /* 260 */
{0,               0,                           0,                     0,             0,0}, /* 261 */
{0,               0,                           0,                     0,             0,0}, /* 262 */
{0,               0,                           0,                     0,             0,0}, /* 263 */
{0,               0,                           0,                     0,             0,0}, /* 264 */
{0,               0,                           0,                     0,             0,0}, /* 265 */
{0,               0,                           0,                     0,             0,0}, /* 266 */
{0,               0,                           0,                     0,             0,0}, /* 267 */
{0,               0,                           0,                     0,             0,0}, /* 268 */
{0,               0,                           0,                     0,             0,0}, /* 269 */
{0,               0,                           0,                     0,             0,0}, /* 270 */
{0,               0,                           0,                     0,             0,0}, /* 271 */
{0,               0,                           0,                     0,             0,0}, /* 272 */
{0,               0,                           0,                     0,             0,0}, /* 273 */
{0,               0,                           0,                     0,             0,0}, /* 274 */
{0,               0,                           0,                     0,             0,0}, /* 275 */
{0,               0,                           0,                     0,             0,0}, /* 276 */
{0,               0,                           0,                     0,             0,0}, /* 277 */
{0,               0,                           0,                     0,             0,0}, /* 278 */
{0,               0,                           0,                     0,             0,0}, /* 279 */
{0,               0,                           0,                     0,             0,0}, /* 280 */
{0,               0,                           0,                     0,             0,0}, /* 281 */
{0,               0,                           0,                     0,             0,0}, /* 282 */
{0,               0,                           0,                     0,             0,0}, /* 283 */
{0,               0,                           0,                     0,             0,0}, /* 284 */
{0,               0,                           0,                     0,             0,0}, /* 285 */
{0,               0,                           0,                     0,             0,0}, /* 286 */
{0,               0,                           0,                     0,             0,0}, /* 287 */
{0,               0,                           0,                     0,             0,0}, /* 288 */
{0,               0,                           0,                     0,             0,0}, /* 289 */
{0,               0,                           0,                     0,             0,0}, /* 290 */
{0,               0,                           0,                     0,             0,0}, /* 291 */
{0,               0,                           0,                     0,             0,0}, /* 292 */
{0,               0,                           0,                     0,             0,0}, /* 293 */
{0,               0,                           0,                     0,             0,0}, /* 294 */
{0,               0,                           0,                     0,             0,0}, /* 295 */
{0,               0,                           0,                     0,             0,0}, /* 296 */
{0,               0,                           0,                     0,             0,0}, /* 297 */
{0,               0,                           0,                     0,             0,0}, /* 298 */
{0,               0,                           0,                     0,             0,0}, /* 299 */

  
{0,               0,                           0,                     0,             0,0}, /* 300 non dovrebbe mai essere chiamata*/
{INT,             INT,                         INT,                   0,             0,0}, /* 301 */
{INT,             STRUCT_SOCKADDR_PTR,        SOCKLEN_T,             0,             0,0}, /* 302 */
{INT,             STRUCT_SOCKADDR_PTR,  SOCKLEN_T,             0,             0,0}, /* 303 */
{INT,             INT,                         0,                     0,             0,0}, /* 304 */
{INT,             STRUCT_SOCKADDR_PTR,        SOCKLEN_T_PTR,        0,             0,0}, /* 305 */
{INT,             STRUCT_SOCKADDR_PTR,        SOCKLEN_T_PTR,        0,             0,0}, /* 306 */
{INT,             STRUCT_SOCKADDR_PTR,        SOCKLEN_T_PTR,        0,             0,0}, /* 307 */
{INT,             INT,                         INT,                 INT_PTR, 0,0}, /* 308 */
{INT,             VOID_PTR,             SIZE_T,                INT,           0,0}, /* 309 */
{INT,             CHAR_PTR,                   SIZE_T,                INT,           0,0}, /* 310 */
{INT,             VOID_PTR,             SIZE_T,                INT,           STRUCT_SOCKADDR_PTR,SOCKLEN_T}, /* 311 */
{INT,             CHAR_PTR,                   SIZE_T,                INT,           STRUCT_SOCKADDR_PTR, SOCKLEN_T_PTR}, /* 312 */
{INT,             INT,                         0,                     0,             0,0}, /* 313 */
{INT,             INT,                         INT,                   VOID_PTR, SOCKLEN_T, 0}, /* 314 */
{INT,             INT,                         INT,                   VOID_PTR, SOCKLEN_T_PTR, 0}, /* 315 */
{INT,             STRUCT_MSGHDR_PTR,    INT,                   0,             0,0}, /* 316 syscallent.h segna 5 argomenti, ma il man e 
										       la funzione che si occupa di questa chiamata ne usano solo 3 */
{INT,             STRUCT_MSGHDR_PTR,          INT,                   0,             0,0}, /* 317 syscallent.h segna 5 argomenti, ma il man e 
											     la funzione che si occupa di questa chiamata ne usano solo 3 */



{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 318 non dovrebbe mai essere chiamata*/
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 319 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 320 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 321 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 322 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 323 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 324 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 325 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 326 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 327 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 328 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 329 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 330 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 331 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 332 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 333 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 334 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 335 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 336 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 337 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 338 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 339 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 340 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 341 */
{INT,             INT,                         INT,                   VOID_PTR,     0,0}, /* 342 */
