/*
 * Copyright (c) 2000, 2001 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <rete_nera@yahoogroups.com>
 * Copyright (c) 1993 Branko Lankester <branko@hacktic.nl>
 * Copyright (c) 1993, 1994, 1995 Rick Sladkey <jrs@world.std.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: syscallent.h,v 1.2 2003/02/17 16:12:48 frassi Exp $
 */

{ 0, internal_none, 		sys_setup,		print_setup,			free_syscall,		"setup"		}, /* 0 */
{ 1, internal_exit, 		sys_exit,		print_exit,			free_syscall,		"_exit"		}, /* 1 */
{ 0, internal_fork, 		sys_fork,		print_fork,			free_syscall,		"fork"		}, /* 2 */
{ 3, internal_none, 		sys_read,		print_read,			free_syscall,		"read"		}, /* 3 */
{ 3, internal_none, 		sys_write,		print_write,			free_syscall,		"write"		}, /* 4 */
{ 3, internal_none, 		sys_open,		print_open,			free_syscall,		"open"		}, /* 5 tested */
{ 1, internal_none, 		sys_close,		print_close,			free_syscall,		"close"		}, /* 6 tested */
{ 3, internal_wait, 		sys_waitpid,		print_waitpid,			free_syscall,		"waitpid"	}, /* 7 */
{ 2, internal_none, 		sys_creat,		print_creat,			free_syscall,		"creat"		}, /* 8 */
{ 2, internal_none, 		sys_link,		print_link,			free_syscall,		"link"		}, /* 9 */
{ 1, internal_none, 		sys_unlink,		print_unlink,			free_syscall,		"unlink"	}, /* 10 */
{ 3, internal_exec, 		sys_execve,		print_execve,			free_execve,		"execve"	}, /* 11 */
{ 1, internal_none, 		sys_chdir,		print_chdir,			free_syscall,		"chdir"		}, /* 12 */
{ 1, internal_none, 		sys_time,		print_time,			free_syscall,		"time"		}, /* 13 */
{ 3, internal_none, 		sys_mknod,		print_mknod,			free_syscall,		"mknod"		}, /* 14 */
{ 2, internal_none, 		sys_chmod,		print_chmod,			free_syscall,		"chmod"		}, /* 15 */
{ 3, internal_none, 		sys_chown,		print_chown,			free_syscall,		"lchown"	}, /* 16 */
{ 0, internal_none, 		sys_break,		print_break,			free_syscall,		"break"		}, /* 17 */
{ 2, internal_none, 		sys_oldstat,		print_oldstat,			free_syscall,		"oldstat"	}, /* 18 */
{ 3, internal_none, 		sys_lseek,		print_lseek,			free_syscall,		"lseek"		}, /* 19 tested */
{ 0, internal_none, 		sys_getpid,		print_getpid,			free_syscall,		"getpid"	}, /* 20 tested */
{ 5, internal_none, 		sys_mount,		print_mount,			free_syscall,		"mount"		}, /* 21 */
{ 1, internal_none, 		sys_umount,		print_umount,			free_syscall,		"oldumount"	}, /* 22 */
{ 1, internal_none, 		sys_setuid,		print_setuid,			free_syscall,		"setuid"	}, /* 23 */
{ 0, internal_none, 		sys_getuid,		print_getuid,			free_syscall,		"getuid"	}, /* 24 tested */
{ 1, internal_none, 		sys_stime,		print_stime,			free_syscall,		"stime"		}, /* 25 */
{ 4, internal_none, 		sys_ptrace,		print_ptrace,			free_syscall,		"ptrace"	}, /* 26 */
{ 1, internal_none, 		sys_alarm,		print_alarm,			free_syscall,		"alarm"		}, /* 27 */
{ 2, internal_none, 		sys_oldfstat,		print_oldfstat,			free_syscall,		"oldfstat"	}, /* 28 */
{ 0, internal_none, 		sys_pause,		print_pause,			free_syscall,		"pause"		}, /* 29 */
{ 2, internal_none, 		sys_utime,		print_utime,			free_syscall,		"utime"		}, /* 30 */
{ 2, internal_none, 		sys_stty,		print_stty,			free_syscall,		"stty"		}, /* 31 */
{ 2, internal_none, 		sys_gtty,		print_gtty,			free_syscall,		"gtty"		}, /* 32 */
{ 2, internal_none, 		sys_access,		print_access,			free_syscall,		"access"	}, /* 33 */
{ 1, internal_none, 		sys_nice,		print_nice,			free_syscall,		"nice"		}, /* 34 */
{ 0, internal_none, 		sys_ftime,		print_ftime,			free_syscall,		"ftime"		}, /* 35 */
{ 0, internal_none, 		sys_sync,		print_sync,			free_syscall,		"sync"		}, /* 36 */
{ 2, internal_none, 		sys_kill,		print_kill,			free_syscall,		"kill"		}, /* 37 */
{ 2, internal_none, 		sys_rename,		print_rename,			free_syscall,		"rename"	}, /* 38 */
{ 2, internal_none, 		sys_mkdir,		print_mkdir,			free_syscall,		"mkdir"		}, /* 39 */
{ 1, internal_none, 		sys_rmdir,		print_rmdir,			free_syscall,		"rmdir"		}, /* 40 */
{ 1, internal_none, 		sys_dup,		print_dup,			free_syscall,		"dup"		}, /* 41 */
{ 1, internal_none, 		sys_pipe,		print_pipe,			free_syscall,		"pipe"		}, /* 42 */
{ 1, internal_none, 		sys_times,		print_times,			free_syscall,		"times"		}, /* 43 */
{ 0, internal_none, 		sys_prof,		print_prof,			free_syscall,		"prof"		}, /* 44 */
{ 1, internal_none, 		sys_brk,		print_brk,			free_syscall,		"brk"		}, /* 45 tested */
{ 1, internal_none, 		sys_setgid,		print_setgid,			free_syscall,		"setgid"	}, /* 46 */
{ 0, internal_none, 		sys_getgid,		print_getgid,			free_syscall,		"getgid"	}, /* 47 tested */
{ 3, internal_signal,   	sys_signal,		print_signal,			free_syscall,		"signal"	}, /* 48 */
{ 0, internal_none, 		sys_geteuid,		print_geteuid,			free_syscall,		"geteuid"	}, /* 49 tested */
{ 0, internal_none, 		sys_getegid,		print_getegid,			free_syscall,		"getegid"	}, /* 50 tested */
{ 1, internal_none, 		sys_acct,		print_acct,			free_syscall,		"acct"		}, /* 51 */
{ 2, internal_none, 		sys_umount2,		print_umount2,			free_syscall,           "umount"	}, /* 52 */
{ 0, internal_none, 		sys_lock,		print_lock,			free_syscall,		"lock"		}, /* 53 */
{ 3, internal_none, 		sys_ioctl,		print_ioctl,			free_syscall,		"ioctl"		}, /* 54 */
{ 3, internal_none, 		sys_fcntl,		print_fcntl,			free_syscall,		"fcntl"		}, /* 55 */ 
{ 0, internal_none, 		sys_mpx,		print_mpx,			free_syscall,		"mpx"		}, /* 56 */
{ 2, internal_none, 		sys_setpgid,		print_setpgid,			free_syscall,		"setpgid"	}, /* 57 */
{ 2, internal_none, 		sys_ulimit,		print_ulimit,			free_syscall,		"ulimit"	}, /* 58 */
{ 1, internal_none, 		sys_oldolduname,	print_oldolduname,		free_syscall,   	"oldolduname"	}, /* 59 */
{ 1, internal_none, 		sys_umask,		print_umask,			free_syscall,		"umask"		}, /* 60 */
{ 1, internal_none, 		sys_chroot,		print_chroot,			free_syscall,		"chroot"	}, /* 61 */
{ 2, internal_none, 		sys_ustat,		print_ustat,			free_syscall,		"ustat"		}, /* 62 */
{ 2, internal_none, 		sys_dup2,		print_dup2,			free_syscall,           "dup2"		}, /* 63 */
{ 0, internal_none, 		sys_getppid,		print_getppid,			free_syscall,		"getppid"	}, /* 64 */
{ 0, internal_none, 		sys_getpgrp,		print_getpgrp,			free_syscall,		"getpgrp"	}, /* 65 */
{ 0, internal_none, 		sys_setsid,		print_setsid,			free_syscall,		"setsid"	}, /* 66 */
{ 3, internal_sigaction, 	sys_sigaction,		print_sigaction,		free_syscall,   	"sigaction"	}, /* 67 */
{ 0, internal_none, 	        sys_siggetmask,		print_siggetmask,		free_syscall,   	"siggetmask"	}, /* 68 */
{ 1, internal_sigsetmask, 	sys_sigsetmask,		print_sigsetmask,		free_syscall,   	"sigsetmask"	}, /* 69 */
{ 2, internal_none, 		sys_setreuid,		print_setreuid,			free_syscall,		"setreuid"	}, /* 70 */
{ 2, internal_none, 		sys_setregid,		print_setregid,			free_syscall,		"setregid"	}, /* 71 */
{ 3, internal_none, 		sys_sigsuspend,		print_sigsuspend,		free_syscall,   	"sigsuspend"	}, /* 72 */
{ 1, internal_none, 		sys_sigpending,		print_sigpending,		free_syscall,   	"sigpending"	}, /* 73 */
{ 2, internal_none, 		sys_sethostname,        print_sethostname,		free_syscall,   	"sethostname"	}, /* 74 */
{ 2, internal_none, 		sys_setrlimit,		print_setrlimit,		free_syscall,   	"setrlimit"	}, /* 75 */
{ 2, internal_none, 		sys_getrlimit,		print_getrlimit,		free_syscall,   	"getrlimit"	}, /* 76 */
{ 2, internal_none, 		sys_getrusage,		print_getrusage,		free_syscall,   	"getrusage"	}, /* 77 */
{ 2, internal_none, 		sys_gettimeofday,	print_gettimeofday,		free_syscall,   	"gettimeofday"	}, /* 78 */
{ 2, internal_none, 		sys_settimeofday,	print_settimeofday,		free_syscall,   	"settimeofday"	}, /* 79 */
{ 2, internal_none, 		sys_getgroups,		print_getgroups,		free_syscall,   	"getgroups"	}, /* 80 */
{ 2, internal_none, 		sys_setgroups,		print_setgroups,		free_syscall,   	"setgroups"	}, /* 81 */
{ 5, internal_oldselect, 	sys_select,             print_oldselect,		free_syscall,   	"oldselect"	}, /* 82 */ 
{ 2, internal_none, 		sys_symlink,		print_symlink,			free_syscall,		"symlink"	}, /* 83 */
{ 2, internal_none, 		sys_oldlstat,		print_oldlstat,			free_syscall,		"oldlstat"	}, /* 84 */
{ 3, internal_none, 		sys_readlink,		print_readlink,			free_syscall,		"readlink"	}, /* 85 */
{ 1, internal_none, 		sys_uselib,		print_uselib,			free_syscall,		"uselib"	}, /* 86 */
{ 2, internal_none, 		sys_swapon,		print_swapon,			free_syscall,		"swapon"	}, /* 87 VDS */
{ 4, internal_none, 		sys_reboot,		print_reboot,			free_syscall,		"reboot"	}, /* 88 VDS */
{ 3, internal_none, 		sys_readdir,		print_readdir,			free_syscall,		"readdir"	}, /* 89 */
{ 6, internal_none, 		sys_old_mmap,		print_old_mmap,			free_syscall,		"old_mmap"	}, /* 90 tested */
{ 2, internal_none, 		sys_munmap,		print_munmap,			free_syscall,		"munmap"	}, /* 91 */
{ 2, internal_none, 		sys_truncate,		print_truncate,			free_syscall,		"truncate"	}, /* 92 */
{ 2, internal_none, 		sys_ftruncate,		print_ftruncate,		free_syscall,   	"ftruncate"	}, /* 93 */
{ 2, internal_none, 		sys_fchmod,		print_fchmod,			free_syscall,		"fchmod"	}, /* 94 */
{ 3, internal_none, 		sys_fchown,		print_fchown,			free_syscall,		"fchown"	}, /* 95 */
{ 2, internal_none, 		sys_getpriority,	print_getpriority,		free_syscall,   	"getpriority"	}, /* 96 */
{ 3, internal_none, 		sys_setpriority,	print_setpriority,		free_syscall,   	"setpriority"	}, /* 97 */
{ 4, internal_none, 		sys_profil,		print_profil,			free_syscall,		"profil"	}, /* 98 */
{ 2, internal_none, 		sys_statfs,		print_statfs,			free_syscall,		"statfs"	}, /* 99 */
{ 2, internal_none, 		sys_fstatfs,		print_fstatfs,			free_syscall,		"fstatfs"	}, /* 100 */
{ 3, internal_none, 		sys_ioperm,		print_ioperm,			free_syscall,		"ioperm"	}, /* 101 */
{ 2, internal_none, 		sys_socketcall,		print_socketcall,		free_syscall,   	"socketcall"	}, /* 102 */
{ 3, internal_none, 		sys_syslog,		print_syslog,			free_syscall,		"syslog"	}, /* 103 */
{ 3, internal_none, 		sys_setitimer,		print_setitimer,		free_syscall,   	"setitimer"	}, /* 104 */
{ 2, internal_none, 		sys_getitimer,		print_getitimer,		free_syscall,   	"getitimer"	}, /* 105 */
{ 2, internal_none, 		sys_stat,		print_stat,			free_syscall,		"stat"		}, /* 106 */
{ 2, internal_none, 		sys_lstat,		print_lstat,			free_syscall,		"lstat"		}, /* 107 */
{ 2, internal_none, 		sys_fstat,		print_fstat,			free_syscall,		"fstat"		}, /* 108 tested */
{ 1, internal_none, 		sys_olduname,		print_olduname,			free_syscall,		"olduname"	}, /* 109 */
{ 1, internal_none, 		sys_iopl,		print_iopl,			free_syscall,		"iopl"		}, /* 110 */
{ 0, internal_none, 		sys_vhangup,		print_vhangup,			free_syscall,		"vhangup"	}, /* 111 */
{ 0, internal_none, 		sys_idle,		print_idle,			free_syscall,		"idle"		}, /* 112 */
{ 1, internal_none, 		sys_vm86old,		print_vm86old,			free_syscall,           "vm86old"	}, /* 113 */
{ 4, internal_wait, 		sys_wait4,		print_wait4,			free_syscall,           "wait4"		}, /* 114 */
{ 1, internal_none, 		sys_swapoff,		print_swapoff,			free_syscall,		"swapoff"	}, /* 115 */
{ 1, internal_none, 		sys_sysinfo,		print_sysinfo,			free_syscall,		"sysinfo"	}, /* 116 */
{ 5, internal_none, 		sys_ipc,		print_ipc,			free_syscall,		"ipc"		}, /* 117 */
{ 1, internal_none, 		sys_fsync,		print_fsync,			free_syscall,		"fsync"		}, /* 118 */
{ 1, internal_sigreturn, 	sys_sigreturn,		print_sigreturn,		free_syscall,           "sigreturn"	}, /* 119 */
{ 2, internal_clone, 		sys_clone,		print_clone,			free_syscall,		"clone"		}, /* 120 */
{ 2, internal_none, 		sys_setdomainname,	print_setdomainname,		free_syscall,	        "setdomainname"	}, /* 121 */
{ 1, internal_none, 		sys_uname,		print_uname,			free_syscall,		"uname"		}, /* 122 tested */
{ 3, internal_none, 		sys_modify_ldt,		print_modify_ldt,		free_syscall,   	"modify_ldt"	}, /* 123 */
{ 1, internal_none, 		sys_adjtimex,		print_adjtimex,			free_syscall,		"adjtimex"	}, /* 124 */
{ 3, internal_none, 		sys_mprotect,		print_mprotect,		        free_syscall,		"mprotect"	}, /* 125 tested */
{ 3, internal_none, 		sys_sigprocmask,	print_sigprocmask,		free_syscall,   	"sigprocmask"	}, /* 126 */
{ 2, internal_none, 		sys_create_module,	print_create_module,		free_syscall,   	"create_module"	}, /* 127 */
{ 2, internal_none, 		sys_init_module,	print_init_module,		free_syscall,   	"init_module"	}, /* 128 */
{ 1, internal_none, 		sys_delete_module,	print_delete_module,		free_syscall,   	"delete_module"	}, /* 129 */
{ 1, internal_none, 		sys_get_kernel_syms,	print_get_kernel_syms,		free_syscall,   	"get_kernel_syms"}, /* 130 */
{ 4, internal_none, 		sys_quotactl,		print_quotactl,			free_syscall,		"quotactl"	}, /* 131 */
{ 1, internal_none, 		sys_getpgid,		print_getpgid,			free_syscall,		"getpgid"	}, /* 132 */
{ 1, internal_none, 		sys_fchdir,		print_fchdir,			free_syscall,		"fchdir"	}, /* 133 */
{ 2, internal_none, 		sys_bdflush,		print_bdflush,			free_syscall,		"bdflush"	}, /* 134 VDS*/
{ 3, internal_none, 		sys_sysfs,		print_sysfs,			free_syscall,		"sysfs"		}, /* 135 */
{ 1, internal_none, 		sys_personality,	print_personality,		free_syscall,	        "personality"	}, /* 136 tested */
{ 5, internal_none, 		sys_afs_syscall,	print_afs_syscall,		free_syscall,   	"afs_syscall"	}, /* 137 */
{ 1, internal_none, 		sys_setfsuid,		print_setfsuid,			free_syscall,		"setfsuid"	}, /* 138 */
{ 1, internal_none, 		sys_setfsgid,		print_setfsgid,			free_syscall,		"setfsgid"	}, /* 139 */
{ 5, internal_none, 		sys_llseek,		print_llseek,			free_syscall,		"_llseek"	}, /* 140 */
{ 3, internal_none, 		sys_getdents,		print_getdents,			free_syscall,		"getdents"	}, /* 141 */
{ 5, internal_none, 		sys_select,		print_select,			free_syscall,		"select"	}, /* 142 */ 
{ 2, internal_none, 		sys_flock,		print_flock,			free_syscall,		"flock"		}, /* 143 */
{ 3, internal_none, 		sys_msync,		print_msync,			free_syscall,		"msync"		}, /* 144 */
{ 3, internal_none, 		sys_readv,		print_readv,			free_readv,		"readv"		}, /* 145 */
{ 3, internal_none, 		sys_writev,		print_writev,			free_writev,		"writev"	}, /* 146 */
{ 1, internal_none, 		sys_getsid,		print_getsid,			free_syscall,		"getsid"	}, /* 147 */
{ 1, internal_none, 		sys_fdatasync,		print_fdatasync,		free_syscall,	        "fdatasync"	}, /* 148 */
{ 1, internal_none, 		sys_sysctl,		print_sysctl,			free_sysctl,		"_sysctl"	}, /* 149 */
{ 2, internal_none, 		sys_mlock,		print_mlock,			free_syscall,		"mlock"		}, /* 150 VDS*/
{ 2, internal_none, 		sys_munlock,		print_munlock,			free_syscall,		"munlock"	}, /* 151 */
{ 1, internal_none, 		sys_mlockall,		print_mlockall,			free_syscall,		"mlockall"	}, /* 152 VDS*/
{ 0, internal_none, 		sys_munlockall,		print_munlockall,		free_syscall,           "munlockall"	}, /* 153 VDS*/
{ 2, internal_none, 		sys_sched_setparam,	print_sched_setparam,		free_syscall,   	"sched_setparam"}, /* 154 VDS*/
{ 2, internal_none, 		sys_sched_getparam,	print_sched_getparam,		free_syscall,   	"sched_getparam"}, /* 155 */
{ 3, internal_none, 		sys_sched_setscheduler,	print_sched_setscheduler,	free_syscall,       "sched_setscheduler"}, /* 156 */
{ 1, internal_none, 		sys_sched_getscheduler,	print_sched_getscheduler,	free_syscall,       "sched_getscheduler"}, /* 157 */
{ 0, internal_none, 		sys_sched_yield,	     print_sched_yield,		free_syscall,	        "sched_yield"   }, /* 158 */
{ 1, internal_none, 		sys_sched_get_priority_max,  print_sched_get_priority_max,	free_syscall,   "sched_get_priority_max"}, /* 159 */
{ 1, internal_none, 		sys_sched_get_priority_min,  print_sched_get_priority_min,	free_syscall,   "sched_get_priority_min"}, /* 160 */
{ 2, internal_none, 		sys_sched_rr_get_interval,   print_sched_rr_get_interval,       free_syscall,   "sched_rr_get_interval" }, /* 161 */
{ 2, internal_none, 		sys_nanosleep,		print_nanosleep,		free_syscall,	        "nanosleep"	}, /* 162 */
{ 4, internal_none, 		sys_mremap,              print_mremap,			free_syscall,		"mremap"	}, /* 163 */
{ 3, internal_none, 		sys_setresuid,		print_setresuid,		free_syscall,	        "setresuid"	}, /* 164 */
{ 3, internal_none, 		sys_getresuid,		print_getresuid,		free_syscall,	        "getresuid"	}, /* 165 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"vm86"		}, /* 166 */
{ 5, internal_none, 		sys_query_module,       print_query_module,		free_syscall,        	"query_module"	}, /* 167 */
{ 3, internal_none, 		sys_poll,		print_poll,			free_syscall,		"poll"		}, /* 168 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"nfsservctl"	}, /* 169 */
{ 3, internal_none, 		sys_setresgid,		print_setresgid,		free_syscall,	        "setresgid"	}, /* 170 */
{ 3, internal_none, 		sys_getresgid,		print_getresgid,		free_syscall,	        "getresgid"	}, /* 171 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"prctl"		}, /* 172 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"rt_sigreturn"	}, /* 173 */
{ 4, internal_none,     	sys_rt_sigaction,	print_rt_sigaction,	        free_syscall,	        "rt_sigaction"  }, /* 174 tested */
{ 4, internal_none, 		sys_rt_sigprocmask,	print_rt_sigprocmask,		free_syscall,	        "rt_sigprocmask"}, /* 175 */
{ 2, internal_none, 		sys_rt_sigpending,	print_rt_sigpending,		free_syscall,	        "rt_sigpending"	}, /* 176 */
{ 4, internal_none, 		sys_rt_sigtimedwait,	print_rt_sigtimedwait,		free_syscall,	       "rt_sigtimedwait"}, /* 177 */
{ 3, internal_none, 		sys_rt_sigqueueinfo,	print_rt_sigqueueinfo,		free_syscall,          "rt_sigqueueinfo"}, /* 178 */
{ 2, internal_none, 		sys_rt_sigsuspend,	print_rt_sigsuspend,	        free_syscall,	        "rt_sigsuspend"	}, /* 179 */


{ 4, internal_none, 		sys_pread,		print_pread,			free_syscall,		"pread"		}, /* 180 VDS*/
{ 4, internal_none, 		sys_pwrite,		print_pwrite,			free_syscall,		"pwrite"	}, /* 181 VDS*/
{ 3, internal_none, 		sys_chown,		print_chown,			free_syscall,		"chown"		}, /* 182 */
{ 2, internal_none, 		sys_getcwd,		print_getcwd,			free_syscall,		"getcwd"	}, /* 183 */
{ 2, internal_none, 		sys_capget,		print_capget,			free_syscall,		"capget"	}, /* 184 */
{ 2, internal_none, 		sys_capset,		print_capset,			free_syscall,		"capset"	}, /* 185 */
{ 2, internal_none, 		sys_sigaltstack,	print_sigaltstack,		free_syscall,	        "sigaltstack"	}, /* 186 */
{ 4, internal_none, 		sys_sendfile,		print_sendfile,			free_syscall,		"sendfile"	}, /* 187 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"getpmsg"	}, /* 188 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"putpmsg"	}, /* 189 */
{ 0, internal_fork, 		sys_vfork,		print_vfork,			free_syscall,		"vfork"		}, /* 190 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"getrlimit"	}, /* 191 */
{ 6, internal_none, 		sys_mmap,		print_mmap,			free_syscall,		"mmap2"		}, /* 192 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"truncate64"	}, /* 193 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"ftruncate64"	}, /* 194 */
{ 2, internal_none, 		sys_stat64,		print_stat64,			free_syscall,           "stat64"	}, /* 195 */
{ 2, internal_none, 		sys_lstat64,		print_lstat64,			free_syscall,           "lstat64"	}, /* 196 */
{ 2, internal_none, 		sys_fstat64,		print_fstat64,			free_syscall,           "fstat64"	}, /* 197 */
{ 3, internal_none,		sys_chown,	        printargs,			free_syscall,		"lchown32"	}, /* 198 */
{ 0, internal_none,		sys_getuid,	        printargs,			free_syscall,		"getuid32"	}, /* 199 */


{ 0, internal_none,		move_arg,	        printargs,			free_syscall,		"getgid32"	}, /* 200 */
{ 0, internal_none,		move_arg,	        printargs,			free_syscall,		"geteuid32"	}, /* 201 */
{ 0, internal_none,		move_arg,	        printargs,			free_syscall,		"getegid32"	}, /* 202 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"setreuid32"	}, /* 203 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"setregid32"	}, /* 204 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"getgroups32"	}, /* 205 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"setgroups32"	}, /* 206 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"fchown32"	}, /* 207 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"setresuid32"	}, /* 208 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"getresuid32"	}, /* 209 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"setresgid32"	}, /* 210 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"getresgid32"	}, /* 211 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"chown32"	}, /* 212 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"setuid32"	}, /* 213 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"setgid32"	}, /* 214 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"setfsuid32"	}, /* 215 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"setfsgid32"	}, /* 216 */
{ 2, internal_none,             sys_pivotroot,    /*print_pivotroot*/printargs,		free_syscall,		"pivot_root"	}, /* 217 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"mincore"	}, /* 218 */
{ 3, internal_none,             sys_madvise,      /*print_madvise*/ printargs,		free_syscall,		"madvise"	}, /* 219 */
{ 4, internal_none,	        sys_getdents64,	        printargs,			free_syscall,		"getdents64"	}, /* 220 */
{ 3, internal_none,             sys_fcntl,        /*print_fcntl*/ printargs,		free_syscall,		"fcntl64"	}, /* 221 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_222"	}, /* 222 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"security"	}, /* 223 */
{ 0, internal_none,		move_arg,	        printargs,			free_syscall,		"gettid"	}, /* 224 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"readahead"	}, /* 225 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"setxattr"	}, /* 226 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"lsetxattr"	}, /* 227 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"fsetxattr"	}, /* 228 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"getxattr"	}, /* 229 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"lgetxattr"	}, /* 230 */
{ 4, internal_none,             move_arg,               printargs,		        free_syscall,		"fgetxattr"	}, /* 231 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"listxattr"	}, /* 232 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"llistxattr"	}, /* 233 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"flistxattr"	}, /* 234 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"removexattr"	}, /* 235 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"lremovexattr"	}, /* 236 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"fremovexattr"	}, /* 237 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"tkill"  	}, /* 238 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"sendfile64"	}, /* 239 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"futex" 	}, /* 240 */
{ 3, internal_none,             move_arg,               printargs,		        free_syscall,		"sched_setaffinity"	}, /* 241 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"sched_getaffinity"	}, /* 242 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"set_thread_area"	}, /* 243 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"get_thread_area"	}, /* 244 */
{ 2, internal_none,		move_arg,	        printargs,			free_syscall,		"io_setup"	}, /* 245 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"io_destroy"	}, /* 246 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"io_getevents"	}, /* 247 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"io_submit"	}, /* 248 */
{ 3, internal_none,		move_arg,	        printargs,			free_syscall,		"io_cancel"	}, /* 249 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_250"	}, /* 250 */
{ 5, internal_none,             move_arg,               printargs,		        free_syscall,		"SYS_251"	}, /* 251 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"exit_group"	}, /* 252 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"lookup_dcookie"	}, /* 253 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"epoll_create"	}, /* 254 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"epoll_ctl"	}, /* 255 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"epoll_wait"	}, /* 256 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"remap_file_pages"	}, /* 257 */
{ 1, internal_none,		move_arg,	        printargs,			free_syscall,		"set_tid_address"	}, /* 258 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_259"	}, /* 259 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_260"	}, /* 260 */
{ 5, internal_none,             move_arg,               printargs,		        free_syscall,		"SYS_261"	}, /* 261 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_262"	}, /* 262 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_263"	}, /* 263 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_264"	}, /* 264 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_265"	}, /* 265 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_266"	}, /* 266 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_267"	}, /* 267 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_268"	}, /* 268 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_269"	}, /* 269 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_270"	}, /* 270 */
{ 5, internal_none,             move_arg,               printargs,		        free_syscall,		"SYS_271"	}, /* 271 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_272"	}, /* 272 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_273"	}, /* 273 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_274"	}, /* 274 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_275"	}, /* 275 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_276"	}, /* 276 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_277"	}, /* 277 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_278"	}, /* 278 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_279"	}, /* 279 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_280"	}, /* 280 */
{ 5, internal_none,             move_arg,               printargs,		        free_syscall,		"SYS_281"	}, /* 281 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_282"	}, /* 282 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_283"	}, /* 283 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_284"	}, /* 284 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_285"	}, /* 285 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_286"	}, /* 286 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_287"	}, /* 287 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_288"	}, /* 288 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_289"	}, /* 289 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_290"	}, /* 290 */
{ 5, internal_none,             move_arg,               printargs,		        free_syscall,		"SYS_291"	}, /* 291 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_292"	}, /* 292 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_293"	}, /* 293 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_294"	}, /* 294 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_295"	}, /* 295 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_296"	}, /* 296 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_297"	}, /* 297 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_298"	}, /* 298 */
{ 5, internal_none,		move_arg,	        printargs,			free_syscall,		"SYS_299"	}, /* 299 */


#if SYS_socket_subcall != 300
 #error fix me
#endif
{ 8, internal_none,		move_arg,	        printargs,			free_syscall,		"socket_subcall"}, /* 300 */
{ 3, internal_none, 		sys_socket,		print_socket,			free_syscall,		"socket"	}, /* 301 */
{ 3, internal_none, 		sys_bind,		print_bind,			free_syscall,		"bind"		}, /* 302 */
{ 3, internal_none, 		sys_connect,		print_connect,			free_syscall,		"connect"	}, /* 303 */
{ 2, internal_none, 		sys_listen,		print_listen,			free_syscall,		"listen"	}, /* 304 */
{ 3, internal_none, 		sys_accept,		print_accept,			free_syscall,		"accept"	}, /* 305 */
{ 3, internal_none, 		sys_getsockname,	print_getsockname,		free_syscall,	        "getsockname"	}, /* 306 */
{ 3, internal_none, 		sys_getpeername,        print_getpeername,		free_syscall,	        "getpeername"	}, /* 307 */
{ 4, internal_none, 		sys_socketpair,		print_socketpair,		free_syscall,	        "socketpair"	}, /* 308 */
{ 4, internal_none, 		sys_send,		print_send,			free_syscall,		"send"		}, /* 309 */
{ 4, internal_none, 		sys_recv,		print_recv,			free_syscall,		"recv"		}, /* 310 */
{ 6, internal_none, 		sys_sendto,		print_sendto,			free_syscall,		"sendto"	}, /* 311 */
{ 6, internal_none, 		sys_recvfrom,		print_recvfrom,			free_syscall,		"recvfrom"	}, /* 312 */
{ 2, internal_none, 		sys_shutdown,		print_shutdown,			free_syscall,		"shutdown"	}, /* 313 */
{ 5, internal_none, 		sys_setsockopt,		print_setsockopt,		free_syscall,	        "setsockopt"	}, /* 314 */
{ 5, internal_none, 		sys_getsockopt,		print_getsockopt,		free_syscall,	        "getsockopt"	}, /* 315 */
{ 5, internal_none, 		sys_sendmsg,		print_sendmsg,			free_sendmsg,		"sendmsg"	}, /* 316 */
{ 5, internal_none, 		sys_recvmsg,		print_recvmsg,			free_recvmsg,		"recvmsg"	}, /* 317 */


#if SYS_ipc_subcall != 318
 #error fix me
#endif
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 318 */
{ 4, internal_none, 		sys_semop,		print_semop,			free_syscall,		"semop"		}, /* 319 */
{ 4, internal_none, 		sys_semget,		print_semget,			free_syscall,		"semget"	}, /* 320 */
{ 4, internal_none, 		sys_semctl,		print_semctl,			free_semctl,		"semctl"	}, /* 321 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 322 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 323 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 324 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 325 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 326 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 327 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 328 */
{ 4, internal_none, 		sys_msgsnd,		print_msgsnd,			free_msgsnd,		"msgsnd"	}, /* 329 */
{ 4, internal_none, 		sys_msgrcv,		print_msgrcv,			free_msgrcv,		"msgrcv"	}, /* 330 */
{ 4, internal_none, 		sys_msgget,		print_msgget,			free_syscall,		"msgget"	}, /* 331 */
{ 4, internal_none, 		sys_msgctl,		print_msgctl,			free_syscall,		"msgctl"	}, /* 332 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 333 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 334 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 335 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 336 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 337 */
{ 4, internal_none,		move_arg,	        printargs,			free_syscall,		"ipc_subcall"	}, /* 338 */
{ 4, internal_none, 		sys_shmat,		print_shmat,			free_syscall,		"shmat"		}, /* 339 */
{ 4, internal_none, 		sys_shmdt,		print_shmdt,			free_syscall,		"shmdt"		}, /* 340 */
{ 4, internal_none, 		sys_shmget,		print_shmget,			free_syscall,		"shmget"	}, /* 341 */
{ 4, internal_none, 		sys_shmctl,		print_shmctl,			free_shmctl,		"shmctl"	}, /* 342 */
