/*
 * Copyright (c) 2000, 2001 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <rete_nera@yahoogroups.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: type_sys_args_ent.h,v 1.1.1.1 2001/12/17 08:59:10 frassi Exp $
 */


{  INT , "int" },
{  INT_PTR , "int_ptr" },
{  UINT , "uint" },
{  UNSIGNED_INT , "unsigned_int" },
{  UNSIGNED_INT_PTR , "unsigned_int_ptr" },
{  LONG , "long" },
{  UNSIGNED_LONG , "unsigned_long" },
{  UNSIGNED_LONG_PTR , "unsigned_long_ptr" },
{  VOID_PTR , "void_ptr" },
  /* {  CONST_VOID_PTR , "CONST_VOID_PTR" }, */
{  CHAR_PTR , "char_ptr" },
  /* {  CONST_CHAR_PTR , "CONST_CHAR_PTR" }, */
  /* {  CHAR_PTR_CONST_ARRAY , "CHAR_PTR_CONST_ARRAY" }, */
  /* {  CHAR_PTR_ARRAY , "CHAR_PTR_ARRAY" },  */
{  CHAR_PTR_PTR , "char_ptr_ptr" },  
{  SIZE_T , "size_t" },
{  SIZE_T_PTR , "size_t_ptr" },
{  PID_T , "pid_t" },
{  DEV_T , "dev_t" },
{  MODE_T , "mode_t" },
{  UID_T , "uid_t" },
{  UID_T_PTR , "uid_t_ptr" },
{  GID_T , "gid_t" },
{  GID_T_PTR , "gid_t_ptr" },
{  OFF_T , "off_t" },
{  OFF_T_PTR , "off_t_ptr" },
{  LOFF_T_PTR , "loff_t_ptr" },
{  LOFF_T , "loff_t" },
{  SIGHANDLER_T , "sighandler_t" },
{  OLD_SIGSET_T , "old_sigset_t" },
{  OLD_SIGSET_T_PTR , "old_sigset_t_ptr" },
{  SIGSET_T_PTR , "sigset_t_ptr" },
  /* {  CONST_SIGSET_T_PTR , "CONST_SIGSET_T_PTR" }, */
{  FD_SET_PTR , "fd_set_ptr" },
  /* {  STRUCT_OLD_KERNEL_STAT_PTR , "STRUCT_OLD_KERNEL_STAT_PTR" }, */
{  STRUCT_TIMEVAL_PTR , "struct_timeval_ptr" },
{  STRUCT_UTIMBUF_PTR , "struct_timeval_ptr" },
{  STRUCT_TIMEZONE_PTR , "struct_timezone_ptr" },
{  STRUCT_TMS_PTR , "struct_tms_ptr" },
{  STRUCT_OLDOLD_UTSNAME_PTR , "struct_old_old_utsname_ptr" },
{  STRUCT_USTAT_PTR , "struct_ustat_ptr" },
{  STRUCT_STAT_PTR , "struct_stat_ptr" },
{  STRUCT_OLD_SIGACTION_PTR , "struct_old_sigaction_ptr" },
  /* {  CONST_STRUCT_OLD_SIGACTION_PTR , "CONST_STRUCT_OLD_SIGACTION_PTR" }, */
  /* {  CONST_STRUCT_SIGACTION_PTR , "CONST_STRUCT_SIGACTION_PTR" }, */
{  STRUCT_SIGACTION_PTR , "struct_sigaction_ptr" },
{  STRUCT_RLIMIT_PTR , "struct_rlimit_ptr" },
{  STRUCT_SEL_ARG_STRUCT_PTR , "struct_sel_arg_struct" },
{  STRUCT_MMAP_ARG_STRUCT_PTR , "struct_mmap_arg_struct" },
{  STRUCT_RUSAGE_PTR , "struct_rusage_ptr" },
{  STRUCT_OLD_UTSNAME_PTR , "struct_old_utsname_ptr" },
{  STRUCT_NEW_UTSNAME_PTR , "struct_new_utsname_ptr" },
{  STRUCT_STATFS_PTR , "struct_statfs_ptr" },
{  STRUCT_ITIMERVAL_PTR , "struct_itimerval_ptr" },
{  STRUCT_VM86_STRUCT_PTR , "struct_vm86_struct_ptr" },
{  STRUCT_VM86PLUS_STRUCT_PTR , "struct_vm86plus_struct_ptr" },
{  STRUCT_SYSINFO_PTR , "struct_sysinfo_ptr" },
{  STRUCT_PT_REGS , "struct_pt_regs" },
{  STRUCT_TIMEX_PTR , "struct_timex_ptr" },
{  STRUCT_KERNEL_SYM_PTR , "struct_kernel_sym_ptr" },
{  STRUCT_MODULE_PTR , "struct_module_ptr" },
{  CADDR_T , "caddr_t" },
  /* {  STRUCT_SYSCTL_ARGS_PTR , "STRUCT_SYSCTL_ARGS_PTR" }, */
  /* {  CONST_STRUCT_IOVEC_PTR , "CONST_STRUCT_IOVEC_PTR" }, */
{  STRUCT_IOVEC_PTR , "struct_iovec_ptr" },
{  STRUCT_SCHED_PARAM_PTR , "struct_sched_param_ptr" },
{  STRUCT_TIMESPEC_PTR , "struct_timespec_ptr" },
  /* {  CONST_STRUCT_TIMESPEC_PTR , "CONST_STRUCT_TIMESPEC_PTR" }, */
{  STRUCT_POLLFD_PTR , "struct_pollfd_ptr" },
{  SIGINFO_T_PTR , "siginfo_t_ptr" },
{  CAP_USER_HEADER_T , "cap_user_header_t" },
  /* {  CONST_STACK_T_PTR , "CONST_STACK_T_PTR" }, */
{  CAP_USER_DATA_T , "cap_user_header_t" },
  /* {  CONST_CAP_USER_DATA_T , "CONST_CAP_USER_DATA_T" }, */
{  STACK_T_PTR , "stack_t_ptr" },
{  STRUCT_SOCKADDR_PTR , "struct_sockaddr_ptr" },
{  SOCKLEN_T , "socklen_t" },
  /* {  CONST_STRUCT_SOCKADDR_PTR , "CONST_STRUCT_SOCKADDR_PTR" }, */
{  SOCKLEN_T_PTR , "socklen_t_ptr" },
  /* {  ARRAY_OF_TWO_INT , "ARRAY_OF_TWO_INT" }, */
  /* { INT_ARRAY, "INT_ARRAY" }, */
{  STRUCT_MSGHDR_PTR , "struct_msghdr_ptr" },
{  STRUCT_MSGHDT_PTR , "struct_msghdt_ptr" },
{  OLD_SIGSET_PTR , "old_sigset_ptr" },
{  U_SHORT_PTR , "u_short_ptr" },
{  NOT_FOUND, NULL },
