/*
 * Copyright (c) 2001-2003 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <frassi@iit.cnr.it>
 * for adding wIDSard code
 * Copyright (c) 1991, 1992 Paul Kranenburg <pk@cs.few.eur.nl>
 * Copyright (c) 1993 Branko Lankester <branko@hacktic.nl>
 * Copyright (c) 1993, 1994, 1995, 1996 Rick Sladkey <jrs@world.std.com>
 * Copyright (c) 1996-1999 Wichert Akkerman <wichert@cistron.nl>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: process.c,v 1.2 2003/02/17 15:28:32 frassi Exp $
 */

#include "gets.h"
#include "util.h"
#include "runtime_util.h"
#include "pars_funct.h" /* get_nargs */

/* #include <fcntl.h> */
/* #include <sys/time.h> */
/* #include <sys/wait.h> */
/* //#include <sys/resource.h> */
/* #include <sys/utsname.h> */
/* #include <sys/user.h> */
/* #include <sys/syscall.h> */
/* #include <signal.h> */

/* /\* */
/* #include "automa.h" */
/* #include "gestione_automa.h" */


/* extern automa atm; */
/* extern follow_array_t arf; */
/* extern automa_state process_state; * era state * */
/* extern process_state_table_t process_state_table; */
/* extern begin_of_subseqs_ll subseqs_ll; */
/* *\/ */

/* #if HAVE_LINUX_PTRACE_H */
/* #undef PTRACE_SYSCALL */
/* #include <linux/ptrace.h> */
/* #endif  */

/* #ifdef HAVE_SYS_REG_H */
/* # include <sys/reg.h> */
/* #ifndef PTRACE_PEEKUSR */
/* # define PTRACE_PEEKUSR PTRACE_PEEKUSER */
/* #endif */
/* #ifndef PTRACE_POKEUSR */
/* # define PTRACE_POKEUSR PTRACE_POKEUSER */
/* #endif */
/* #endif */


/* #include <asm/posix_types.h> */
/* #undef GETGROUPS_T */
/* #define GETGROUPS_T __kernel_gid_t */


/* #ifdef HAVE_PRCTL */
/* #include <sys/prctl.h> */
/* #endif */

/* #ifndef WCOREDUMP */
/* #define WCOREDUMP(status) ((status) & 0200) */
/* #endif */


#include <fcntl.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/resource.h>
#include <sys/utsname.h>
#include <sys/user.h>
#include <sys/syscall.h>
#include <signal.h>


#ifdef HAVE_SYS_REG_H
# include <sys/reg.h>
#ifndef PTRACE_PEEKUSR
# define PTRACE_PEEKUSR PTRACE_PEEKUSER
#endif
#ifndef PTRACE_POKEUSR
# define PTRACE_POKEUSR PTRACE_POKEUSER
#endif
#elif defined(HAVE_LINUX_PTRACE_H)
#undef PTRACE_SYSCALL
#include <linux/ptrace.h>
#endif


#include <asm/posix_types.h>
#undef GETGROUPS_T
#define GETGROUPS_T __kernel_gid_t


#ifdef HAVE_PRCTL
#include <sys/prctl.h>
#endif

#ifndef WCOREDUMP
#define WCOREDUMP(status) ((status) & 0200)
#endif

/* WTA: this was `&& !defined(LINUXSPARC)', this seems unneeded though? */
#if defined(HAVE_PRCTL)

static struct xlat prctl_options[] = {
#ifdef PR_MAXPROCS
	{ PR_MAXPROCS,		"PR_MAXPROCS"		},
#endif
#ifdef PR_ISBLOCKED
	{ PR_ISBLOCKED,		"PR_ISBLOCKED"		},
#endif
#ifdef PR_SETSTACKSIZE
	{ PR_SETSTACKSIZE,	"PR_SETSTACKSIZE"	},
#endif
#ifdef PR_GETSTACKSIZE
	{ PR_GETSTACKSIZE,	"PR_GETSTACKSIZE"	},
#endif
#ifdef PR_MAXPPROCS
	{ PR_MAXPPROCS,		"PR_MAXPPROCS"		},
#endif
#ifdef PR_UNBLKONEXEC
	{ PR_UNBLKONEXEC,	"PR_UNBLKONEXEC"	},
#endif
#ifdef PR_ATOMICSIM
	{ PR_ATOMICSIM,		"PR_ATOMICSIM"		},
#endif
#ifdef PR_SETEXITSIG
	{ PR_SETEXITSIG,	"PR_SETEXITSIG"		},
#endif
#ifdef PR_RESIDENT
	{ PR_RESIDENT,		"PR_RESIDENT"		},
#endif
#ifdef PR_ATTACHADDR
	{ PR_ATTACHADDR,	"PR_ATTACHADDR"		},
#endif
#ifdef PR_DETACHADDR
	{ PR_DETACHADDR,	"PR_DETACHADDR"		},
#endif
#ifdef PR_TERMCHILD
	{ PR_TERMCHILD,		"PR_TERMCHILD"		},
#endif
#ifdef PR_GETSHMASK
	{ PR_GETSHMASK,		"PR_GETSHMASK"		},
#endif
#ifdef PR_GETNSHARE
	{ PR_GETNSHARE,		"PR_GETNSHARE"		},
#endif
#if defined(PR_SET_PDEATHSIG)
	{ PR_SET_PDEATHSIG,	"PR_SET_PDEATHSIG"	},
#endif
#ifdef PR_COREPID
	{ PR_COREPID,		"PR_COREPID"		},
#endif
#ifdef PR_ATTACHADDRPERM
	{ PR_ATTACHADDRPERM,	"PR_ATTACHADDRPERM"	},
#endif
#ifdef PR_PTHREADEXIT
	{ PR_PTHREADEXIT,	"PR_PTHREADEXIT"	},
#endif
#ifdef PR_SET_PDEATHSIG
	{ PR_SET_PDEATHSIG,	"PR_SET_PDEATHSIG"	},
#endif
#ifdef PR_GET_PDEATHSIG
	{ PR_GET_PDEATHSIG,	"PR_GET_PDEATHSIG"	},
#endif
#ifdef PR_GET_UNALIGN
	{ PR_GET_UNALIGN,	"PR_GET_UNALIGN"	},
#endif
#ifdef PR_SET_UNALIGN
	{ PR_SET_UNALIGN,	"PR_SET_UNALIGN"	},
#endif
#ifdef PR_GET_KEEPCAPS
	{ PR_GET_KEEPCAPS,	"PR_GET_KEEP_CAPS"	},
#endif
#ifdef PR_SET_KEEPCAPS
	{ PR_SET_KEEPCAPS,	"PR_SET_KEEP_CAPS"	},
#endif
	{ 0,			NULL			},
};

//const 
char *
unalignctl_string (unsigned int ctl)
{
	static char buf[16];

	switch (ctl) {
#ifdef PR_UNALIGN_NOPRINT
	      case PR_UNALIGN_NOPRINT:
		return "NOPRINT";
#endif
#ifdef PR_UNALIGN_SIGBUS
	      case PR_UNALIGN_SIGBUS:
		return "SIGBUS";
#endif
	      default:
		break;
	}
	sprintf(buf, "%x", ctl);
	return buf;
}


int
sys_prctl(tcp) /* CONTROLLARE: da implementare */
struct tcb *tcp;
{
	int i;

	if (entering(tcp)) {
		printxval(prctl_options, tcp->u_arg[0], "PR_???");
		switch (tcp->u_arg[0]) {
		case PR_SET_UNALIGN:
			tprintf(", %s", unalignctl_string(tcp->u_arg[1]));
			break;
		case PR_GET_UNALIGN:
			tprintf(", %#lx", tcp->u_arg[1]);
			break;
		default:
			for (i = 1; i < tcp->u_nargs; i++)
				tprintf(", %#lx", tcp->u_arg[i]);
			break;
		}
	} else {
		switch (tcp->u_arg[0]) {
		case PR_GET_PDEATHSIG:
			for (i=1; i<tcp->u_nargs; i++)
				tprintf(", %#lx", tcp->u_arg[i]);
			break;
		case PR_SET_UNALIGN:
			break;
		case PR_GET_UNALIGN:
		{
			int ctl;

			umove(tcp, tcp->u_arg[1], &ctl);
			tcp->auxstr = unalignctl_string(ctl);
			return RVAL_STR;
		}
		default:
			break;
		}
	}
	return 0;
}

#endif /* HAVE_PRCTL */


int 
print_sethostname(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("sethostname(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    string_quote((char *) info->u_arg[0]);
	    break;
	  case 1:
	    tprintf("%lu", *((unsigned long*)info->u_arg[1]));
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}


/*
  Numero argomenti: 2
  -) nome dell'host (const char *)
  -) lunghezza del nome (size_t == unsigned int)
*/
int 
sys_sethostname(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  int bytes;

  switch (n_arg) {
  case 0:
    //if (entering(tcp)) 
    {
	int *ptr;
	
	if ( (ptr = (int *) take_arg(1, tcp)) == NULL )
	  {
	    fprintf(stderr,"sys_sethostname: take_arg(1, tcp)\n");
	    return -1;
	  }
	bytes = *ptr;

	((char*) tcp->u_arg[0]) = get_str(tcp, tcp->u_arg[0], bytes);
	if ( get_error )
	  {
	    fprintf(stderr,"sys_sethostname: get_str\n");
	    tcp->arg_state[n_arg] = EMPTY;
	    return -1;
	  }
	tcp->arg_state[n_arg] = TAKEN;
    }
    break;
  case 1:
    arg_alloc(tcp,n_arg);
    break;
  }
  return 0;
}



int 
print_setdomainname(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("setdomainname(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    string_quote((char *) info->u_arg[0]);
	    break;
	  case 1:
	    tprintf("%lu", *((unsigned long*)info->u_arg[1]));
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}


/*
  Numero argomenti: 2
  -) nome del dominio (const char *)
  -) lunghezza del nome (size_t == unsigned int)
*/
int 
sys_setdomainname(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  int bytes;
  switch (n_arg) {
  case 0:
    //    if (entering(tcp)) 
      {
	int *ptr;
	
	if ( (ptr = (int *) take_arg(1, tcp)) == NULL )
	  {
	    fprintf(stderr,"sys_setdomainname: take_arg(1, tcp)\n");
	    return -1;
	  }
	bytes = *ptr;

	((char*)tcp->u_arg[0]) = get_str(tcp, tcp->u_arg[0], bytes);
	if ( get_error )
	{
	  fprintf(stderr,"sys_setdomainname: get_str\n");
	  tcp->arg_state[n_arg] = EMPTY;
	  return -1;
	}
	tcp->arg_state[n_arg] = TAKEN;
      }
    break;
  case 1:
    arg_alloc(tcp,n_arg);
    break;
  }
  return 0;
}


int 
print_exit(info)
msg_building_info *info;
{
  tprintf("exit(");
  
  if (info->arg_state[0]==TAKEN)
    tprintf("%ld)", *((long*)info->u_arg[0]));
  else
    tprintf("_)");
  
  return 0;
}



/*
  Numero argomenti: 1
  -) stato restituito al processo padre del chiamante (int)
*/
int 
sys_exit(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  if (exiting(tcp)) {
    fprintf(stderr, "_exit returned!\n");
    return -1;
  }
  /* TODO: se gli faccio prendere l'argomento in questione, poiche' l'uscita della chiamata di sistema non viene mai presa, 
     si ha un memory leak (4 bytes per ogni exit) */ /* CONTROLLARE */ 
  
  //arg_alloc(tcp,n_arg);
  return 0;
}


extern struct xlat clone_flags[];
/* definita in internal_syscall.c */

int 
print_clone(info)
msg_building_info *info;
{
  tprintf("clone(");
  
  if (info->arg_state[0]==TAKEN)
    printflags(clone_flags, *((int*)info->u_arg[0]));
  else
    tprintf("_");

  tprintf(", ");   
  if (info->arg_state[1]==TAKEN)
    tprintf("child_stack=%#lx", info->u_arg[1]);
  else
    tprintf("_");
  
  tprintf(")");
  
  return 0;
}


int 
sys_clone(tcp, n_arg) /* CONTROLLARE */
struct tcb *tcp;
int n_arg;
{
  if (n_arg == 0)
    {
      arg_alloc(tcp, n_arg);
      return 0;
    }
  
  return -1;
}


int 
print_fork(info)
msg_building_info *info;
{
  tprintf("fork()");
  return RVAL_UDECIMAL;
}


int
sys_fork(tcp,n_arg)
struct tcb *tcp;
int n_arg;
{
  return 0;
}


int 
print_vfork(info)
msg_building_info *info;
{
  tprintf("vfork()");
  return RVAL_UDECIMAL;
}


/*
  Numero argomenti: 0
*/
int 
sys_vfork(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  return 0;
}



int 
print_setuid(info)
msg_building_info *info;
{
  tprintf("setuid(");
  
  if (info->arg_state[0]==TAKEN)
    tprintf("%u)", *((uid_t*) info->u_arg[0]));
  else
    tprintf("_)");

  return 0;
}


/*
  Numero argomenti: 1
  -)user ID effettivo del processo chiamante (uid_t == unsigned int)
*/
int 
sys_setuid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}


int 
print_setgid(info)
msg_building_info *info;
{
  tprintf("setgid(");
  
  if (info->arg_state[0]==TAKEN)
    tprintf("%u)", *((gid_t*) info->u_arg[0]));
  else
    tprintf("_)");

  return 0;
}



/*
  Numero argomenti: 1
  -)group ID effettivo del processo chiamante (gid_t == unsigned int)
*/
int 
sys_setgid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}



int 
print_getresuid(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("getresuid(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    tprintf("ruid ");
	    if ((void*)info->u_arg[0]!=NULL)
	      tprintf("%lu", *((unsigned long*) info->u_arg[0]));
	    else
	      tprintf("NULL");
	    break;
	  case 1:
	    tprintf("euid ");
	    if ((void*)info->u_arg[1]!=NULL)
	      tprintf("%lu", *((unsigned long*) info->u_arg[1]));
	    else
	      tprintf("NULL");
	    break;
	  case 2:
	    tprintf("suid ");
	    if ((void*)info->u_arg[2]!=NULL)
	      tprintf("%lu", *((unsigned long*) info->u_arg[2]));
	    else
	      tprintf("NULL");
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



/*
  Numero argomenti: 3
  -)user ID reale del processo chiamante (uid_t * == unsigned int *)
  -)user ID effettivo del processo chiamante (uid_t * == unsigned int *)
  -)user ID salvato del processo chiamante (uid_t * == unsigned int *)
*/
int 
sys_getresuid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  if (exiting(tcp)) 
    {
      if (syserror(tcp))
	{
	  fprintf(stderr, "sys_getresuid: syscall failed\n");
	  return -1;
	}
      
      ((long*) tcp->u_arg[n_arg]) = get_num(tcp, tcp->u_arg[n_arg]);
      
      if ( get_error )
	{
	  fprintf(stderr, "sys_getresuid: get_num\n");
	  tcp->arg_state[n_arg] = EMPTY;
	  return -1;
	}
      
      tcp->arg_state[n_arg] = TAKEN;
    }
  return 0;
}



int 
print_getresgid(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("getresgid(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    tprintf("rgid ");
	    if ((void*)info->u_arg[0]!=NULL)
	      tprintf("%lu", *((unsigned long*) info->u_arg[0]));
	    else
	      tprintf("NULL");
	    break;
	  case 1:
	    tprintf("egid ");
	    if ((void*)info->u_arg[1]!=NULL)
	      tprintf("%lu", *((unsigned long*) info->u_arg[1]));
	    else
	      tprintf("NULL");
	    break;
	  case 2:
	    tprintf("sgid ");
	    if ((void*)info->u_arg[2]!=NULL)
	      tprintf("%lu", *((unsigned long*) info->u_arg[2]));
	    else
	      tprintf("NULL");
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



/*
  Numero argomenti: 3
  -)group ID reale del processo chiamante (gid_t * == unsigned int *)
  -)group ID effettivo del processo chiamante (gid_t * == unsigned int *)
  -)group ID salvato del processo chiamante (gid_t * == unsigned int *)
*/
int 
sys_getresgid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  if (exiting(tcp)) 
    {
      if (syserror(tcp))
	{
	  fprintf(stderr, "sys_getresgid: syscall failed\n");
	  return -1;
	}

      ((long*) tcp->u_arg[n_arg]) = get_num(tcp, tcp->u_arg[n_arg]);

      if ( get_error )
	{
	  fprintf(stderr, "sys_getresgid: get_num\n");
	  tcp->arg_state[n_arg] = EMPTY;
	  return -1;
	}
      
      tcp->arg_state[n_arg] = TAKEN;
    }
  return 0;
}



int 
print_setreuid(info)
msg_building_info *info;
{  
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("setreuid(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	tprintf("%lu", *((unsigned long*) info->u_arg[i]));  
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



/*
  Numero argomenti: 2
  -)user ID reale del processo chiamante (uid_t == unsigned int)
  -)user ID effettivo del processo chiamante (uid_t == unsigned int)
*/
int
sys_setreuid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;  
}



int 
print_setregid(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("setregid(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	tprintf("%lu", *((unsigned long*) info->u_arg[i]));  
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



/*
  Numero argomenti: 2
  -)group ID reale del processo chiamante (gid_t == unsigned int)
  -)group ID effettivo del processo chiamante (gid_t == unsigned int)
*/
int 
sys_setregid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}


int 
print_setresuid(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("setresuid(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    tprintf("ruid %u", *((unsigned int*) info->u_arg[0]));
	    break;
	  case 1:
	    tprintf("euid %u", *((unsigned int*) info->u_arg[1]));
	    break;
	  case 2:
	    tprintf("suid %u", *((unsigned int*) info->u_arg[2]));
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}


/*
  Numero argomenti: 3
  -)user ID reale del processo chiamante (uid_t == unsigned int)
  -)user ID effettivo del processo chiamante (uid_t == unsigned int)
  -)user ID salvato del processo chiamante (uid_t == unsigned int)
*/
int 
sys_setresuid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}



int 
print_setresgid(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("setresgid(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    tprintf("rgid %u", *((unsigned int*) info->u_arg[0]));
	    break;
	  case 1:
	    tprintf("egid %u", *((unsigned int*) info->u_arg[1]));
	    break;
	  case 2:
	    tprintf("sgid %u", *((unsigned int*) info->u_arg[2]));
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0; 
}



/*
  Numero argomenti: 3
  -)group ID reale del processo chiamante (gid_t == unsigned int)
  -)group ID effettivo del processo chiamante (gid_t == unsigned int)
  -)group ID salvato del processo chiamante (gid_t == unsigned int)
*/
int 
sys_setresgid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}



int 
print_setgroups(info)
msg_building_info *info;
{
  int i,j,len;
  int nargs=get_nargs(info->scno);
  GETGROUPS_T *gidset;
  
  tprintf("setgroups(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    tprintf("%u", *((unsigned int*) info->u_arg[0]));
	    break;
	  case 1:
	    len=*((unsigned int*) info->u_arg[0]);
	    gidset=((GETGROUPS_T *) info->u_arg[1]);
	    tprintf("[");
	    for (j = 0; j < len; j++)
	      tprintf("%s%lu", j ? ", " : "",(unsigned long) gidset[j]);
	    tprintf("]");
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



/*
  Numero argomenti: 2
  -) numero di gruppi supplementari da settare (size_t == unsigned int)
  -) lista dei gruppi (const gid_t * == const unsigned int *)
*/
int 
sys_setgroups(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  int len;
  GETGROUPS_T *gidset;

  switch (n_arg) {
  case 0:
    arg_alloc(tcp,n_arg);
    break;
  case 1:
    //if (entering(tcp)) 
      {
	int *ptr;
	
	if ( (ptr = (int *) take_arg(0, tcp)) == NULL )
	  {	
	    fprintf(stderr, "sys_setgroups: take_arg(0, tcp)\n");
	    return -1;
	  }
	len = *ptr;
      
	if (len<=0)
	  break;

	if ( set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&gidset, len * sizeof(GETGROUPS_T), "setgroups") )
	  {
	    fprintf(stderr, "sys_setgroups: set_copy\n");
	    return -1;
	  }
      }
    break;
  }
  return 0;
}



int 
print_getgroups(info)
msg_building_info *info;
{
  int i,j,len;
  int nargs=get_nargs(info->scno);
  GETGROUPS_T *gidset;
  
  tprintf("getgroups(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    tprintf("%u", *((unsigned int*) info->u_arg[0]));
	    break;
	  case 1:
	    len=info->u_rval;
	    gidset=((GETGROUPS_T *) info->u_arg[1]);
	    tprintf("[");
	    for (j = 0; j < len; j++)
	      tprintf("%s%lu", j ? ", " : "",(unsigned long) gidset[j]);
	    tprintf("]");
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



int
sys_getgroups(tcp,n_arg)
struct tcb *tcp;
int n_arg;
{
  int len, n_groups;
  GETGROUPS_T *gidset;

  switch(n_arg) {
  case 0:
    arg_alloc(tcp,n_arg);
    break;
  case 1:
    if (exiting(tcp)) 
      {
	int *ptr;
	
	if (syserror(tcp))
	  {
	    fprintf(stderr, "sys_getgroups: syscall failed\n");
	    return -1;
	  }

	len = tcp->u_rval;
	if (len <= 0) 
	  break;
	
	if ( (ptr = (int *) take_arg(0, tcp)) == NULL )
	  {
	    fprintf(stderr, "sys_getgroups: take_arg(0, tcp)\n");
	    return -1;
	  }
	n_groups = *ptr;
	            
	if ((tcp->u_arg[1]) && (n_groups != 0))
	  if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&gidset, len * sizeof(GETGROUPS_T), "getgroups"))
	    {
	      fprintf(stderr, "sys_getgroups: set_copy\n");
	      return -1;
	    }
	
	tcp->arg_state[n_arg] = TAKEN;
      }
    break;
  }
  return 0;
}


int 
print_getpgrp(info)
msg_building_info *info;
{
  tprintf("getpgrp(");
  
  if (info->arg_state[0]==TAKEN)
    tprintf("%lu)", *((unsigned long*) info->u_arg[0]));
  else
    tprintf("_)");

  return 0;
}



int
sys_getpgrp(tcp,n_arg) /* CONTROLLARE */
struct tcb *tcp;
int n_arg;
{
  /*il man dice che non ha argomenti??*/
  arg_alloc(tcp,n_arg);  
  return 0;
}


int 
print_getsid(info)
msg_building_info *info;
{
  tprintf("getsid(");
  
  if (info->arg_state[0]==TAKEN)
    tprintf("%lu)", *((unsigned long*) info->u_arg[0]));
  else
    tprintf("_)");

  return 0;
}


/*
  Numero argomenti: 1
  -) pid del processo del quale si richiede l'ID di sessione (pid_t == int)
*/
int 
sys_getsid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}


int 
print_setsid(info)
msg_building_info *info;
{
  tprintf("setsid()");
  return 0;
}


/*
  Numero argomenti: 0
*/
int 
sys_setsid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  return 0;
}


int 
print_getpgid(info)
msg_building_info *info;
{
  tprintf("getpgid(");
  
  if (info->arg_state[0]==TAKEN)
    tprintf("%lu)", *((unsigned long*) info->u_arg[0]));
  else
    tprintf("_)");

  return 0;
}


/*
  Numero argomenti: 1
  -) il pid del processo del quale si richiede il process group ID (pid_t == int)
*/
int 
sys_getpgid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}




int 
print_setpgid(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("setpgid(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	tprintf("%lu", *((unsigned long*) info->u_arg[i]));  
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}


/*
  Numero argomenti: 2
  -) il pid del processo del quale settare il process group ID (pid_t == int)
  -) il valore del process group ID (pid_t == int)
*/
int 
sys_setpgid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}


static void
realprintargv(cpp)
char **cpp;
{
  char *cp;
  char *sep="";
  int i=0;

  if (!cpp) 
    {
      tprintf("NULL");
      return;
    }
  	
  cp=cpp[i];
  
  while (cp!=NULL)
    {
      tprintf(sep);
      sep=", ";
      realprintstr(cp, -1);
      i++;
      cp=cpp[i];
    }

  return;
}



/* restituisce un array di stringhe, corrispondente all'argv o all'envp dell'execve */
char **
get_argv(tcp, addr)
struct tcb *tcp;
long addr;
{
  int max = 32; /* CONTROLLARE */
  int i = 0;
  int got_all_args = 0;

  char **cp_array_p = ((char**) calloc(max,sizeof(char*)));

  char *cp;

  get_error = 0;

  if ( (void *) addr == NULL)
    return NULL;

  while (!(got_all_args))
    {
      while(i < max)
	{
	  if (umove(tcp, addr, &cp) < 0) {
	    fprintf(stderr,"get_argv: umove failed");
	    get_error = 1;
	    cp_array_p[i] = NULL;/* termina l'array */
	    cp = 0;
	    break;
	  }
	  
	  if (cp == 0) /* ho trovato il null pointer che termina l'array, posso uscire dal ciclo*/
	    {
	      cp_array_p[i] = NULL;/* termina l'array */
	      break;
	    }
	  
	  cp_array_p[i] = get_str(tcp, (long) cp, -1);
	  
	  addr += sizeof(char *);
	  i++;
	}
      
      if (cp) /* controllo se fossero presenti + di max argomenti */
	{
	  max = max * 2;
	  cp_array_p = ((char**) realloc(cp_array_p,(max*sizeof(char*))));
	}
      else
	got_all_args = 1;
    }
  
  return cp_array_p;
}


void 
free_execve(u_arg, arg_state, u_nargs)
long u_arg[];
arg_state_t arg_state[]; 
int u_nargs;
{
  int i,j;
  
  for (i = 0; i < u_nargs; i++) 
    {
      switch (i) {
      case 0:
	if (arg_state[i] == TAKEN)
	  free( (int *) u_arg[0]); 
	arg_state[i] = EMPTY;
	break;
      case 1:
      case 2:
	if (arg_state[i] == TAKEN)
	  if (u_arg[i])
	    {
	      char **cp_array_p = (char **) u_arg[i];
	      for ( j=0 ; cp_array_p[j]!=NULL ; j++ )
		free(cp_array_p[j]);
	      free(cp_array_p);
	    }
	arg_state[i] = EMPTY;
	break;
      }
    }
  
  return;
}



int 
print_execve(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("execve(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    string_quote((char *) info->u_arg[0]);
	    break;
	  case 1:
	  case 2:
	    tprintf("[");
	    realprintargv(((char **)info->u_arg[i]));
	    tprintf("]");
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



int
sys_execve(tcp,n_arg)
struct tcb *tcp;
int n_arg;
{
  switch(n_arg) {
  case 0:
    //if (entering(tcp)) {
      ((char *) tcp->u_arg[0]) = get_path(tcp, tcp->u_arg[0]);
      if ( get_error )
	{
	  fprintf(stderr, "sys_execve: get_path\n");
	  tcp->arg_state[0] = EMPTY;
	  return -1;
	}
      tcp->arg_state[0] = TAKEN;
      //}
    break;
  case 1:
  case 2:
    //if (entering(tcp)) 
    //{
	((char **) tcp->u_arg[n_arg]) = get_argv(tcp, tcp->u_arg[n_arg]);
	
	tcp->arg_state[n_arg] = TAKEN;
	//}
    break;
  }
  
  return 0;
}


#ifndef __WCLONE
#define __WCLONE	0x8000000
#endif


static struct xlat wait4_options[] = {
	{ WNOHANG,	"WNOHANG"	},
#ifndef WSTOPPED
	{ WUNTRACED,	"WUNTRACED"	},
#endif
#ifdef WEXITED
	{ WEXITED,	"WEXITED"	},
#endif
#ifdef WTRAPPED
	{ WTRAPPED,	"WTRAPPED"	},
#endif
#ifdef WSTOPPED
	{ WSTOPPED,	"WSTOPPED"	},
#endif
#ifdef WCONTINUED
	{ WCONTINUED,	"WCONTINUED"	},
#endif
#ifdef WNOWAIT
	{ WNOWAIT,	"WNOWAIT"	},
#endif
#ifdef __WCLONE
	{ __WCLONE,	"__WCLONE"	},
#endif
#ifdef __WALL
	{ __WALL,	"__WALL"	},
#endif
#ifdef __WNOTHREAD
	{ __WNOTHREAD,	"__WNOTHREAD"	},
#endif
	{ 0,		NULL		},
};




static int
printstatus(status)
int status;
{
  int exited = 0;

  /*
   * Here is a tricky presentation problem.  This solution
   * is still not entirely satisfactory but since there
   * are no wait status constructors it will have to do.
   */
  if (WIFSTOPPED(status))
    tprintf("[WIFSTOPPED(s) && WSTOPSIG(s) == %s]", signame(WSTOPSIG(status)));
  else 
    if WIFSIGNALED(status) 
      {
	tprintf("[WIFSIGNALED(s) && WTERMSIG(s) == %s%s]", signame(WTERMSIG(status)), WCOREDUMP(status) ? " && WCOREDUMP(s)" : "");
      }
    else 
      if WIFEXITED(status) 
	{
	  tprintf("[WIFEXITED(s) && WEXITSTATUS(s) == %d]", WEXITSTATUS(status));
	  exited = 1;
	}
      else
	tprintf("[%#x]", status);
  return exited;
}


int 
print_waitpid(info)
msg_building_info *info;
{
  int i,exited;
  int nargs=get_nargs(info->scno);
  
  tprintf("waitpid(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    tprintf("%ld", *((unsigned long *)info->u_arg[0]));
	    break;
	  case 1:
	    if (!info->u_arg[1])
	      tprintf("NULL");
	    else 
	      exited = printstatus(*((int*)info->u_arg[1]));
	    break;
	  case 2:
	    if (!printflags(wait4_options, *((int*)info->u_arg[2])))
	      tprintf("0");
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



/*
  Numero argomenti: 3
x  -) il pid del processo da aspettare (pid_t == int)
  -) lo stato del processo terminato (int *)
  -) dei flag di opzione (int)
*/
int 
sys_waitpid(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  int *status;

  switch (n_arg) {
  case 0:
  case 2:
    arg_alloc(tcp,n_arg);
    break;
  case 1:
    if (exiting(tcp)) {
      if (!tcp->u_arg[1])
	tcp->arg_state[1] = TAKEN;
      else 
	{
	  if ((syserror(tcp)) || (tcp->u_rval == 0))
	    {
	      fprintf(stderr, "sys_waitpid: syscall failed or tcp->u_rval == 0\n");
	      return -1;
	    }
	  
	  if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&status, sizeof(int), "waitpid"))
	    {
	      fprintf(stderr, "sys_waitpid: set_copy\n");
	      return -1;
	    }
	}
    }
    break;
  }
  return 0;
}



int 
print_wait4(info)
msg_building_info *info;
{
  int i,exited;
  int nargs=get_nargs(info->scno);
  
  tprintf("wait4(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i] == TAKEN)
	{
 	  switch (i) {
	  case 0:
	    tprintf("%ld", *((unsigned long *)info->u_arg[0]));
	    break;
	  case 1:
	    if (!info->u_arg[1])
	      tprintf("NULL");
	    else 
	      exited = printstatus(*((int*)info->u_arg[1]));
	    break;
	  case 2:
	    if (!printflags(wait4_options, *((int*)info->u_arg[2])))
	      tprintf("0");
	    break;
	  case 3:
	    if (info->u_rval > 0)
	      realprintrusage(info, ((struct rusage *) info->u_arg[3]));
	    else
	      tprintf("_");
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}




int
sys_wait4(tcp,n_arg)
struct tcb *tcp;
int n_arg;
{
  int *status;

  switch (n_arg) {
  case 0:
  case 2:
    arg_alloc(tcp,n_arg);
    break;
  case 1:
    /* status */
    if (exiting(tcp)) {
      if (tcp->u_arg[1]) {
	
	if (syserror(tcp) || tcp->u_rval == 0)
	  {
	    fprintf(stderr, "sys_wait4: syscall failed or tcp->u_rval == 0\n");
	    return -1;
	  }

	if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&status, sizeof(int), "wait4"))
	  {
	    fprintf(stderr, "sys_wait4: set_copy\n");
	    return -1;
	  }
      }
      tcp->arg_state[1] = TAKEN;
    }
    break;
  case 3:
    /* usage */
    if (exiting(tcp)) 
      {
	if (tcp->u_arg[3]) 
	  {
	    if (tcp->u_rval > 0) 
	      {
		((struct rusage*) tcp->u_arg[3]) = get_rusage(tcp, tcp->u_arg[3]);
		if ( get_error )
		  {
		    fprintf(stderr, "sys_wait4: get_rusage\n");
		    tcp->arg_state[3] = EMPTY;
		    return -1;
		  }
		tcp->arg_state[3] = TAKEN;
	      }
	    else
	      {
		((struct rusage*) tcp->u_arg[3]) = NULL;

		fprintf(stderr, "sys_wait4: (tcp->u_rval <= 0)\n");
		tcp->arg_state[3] = EMPTY;
		return -1;
	      }
	  }
	tcp->arg_state[3] = TAKEN;      
      }
    break;
  }
  
  return 0;
}




int 
print_alarm(info)
msg_building_info *info;
{
  tprintf("alarm(");
  
  if (info->arg_state[0]==TAKEN)
    tprintf("%lu)", *((unsigned long*)info->u_arg[0]));
  else
    tprintf("_)");
  
  return 0;
}


/*
  Numero argomenti: 1
  -) secondi da aspettare (unsigned int)
*/
int 
sys_alarm(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}



int 
print_uname(info)
msg_building_info *info;
{
  struct utsname uname = *((struct utsname*)info->u_arg[0]);

  tprintf("uname(");
  
  if (info->arg_state[0]==TAKEN)
    {
      tprintf("{sysname=\"%s\", nodename=\"%s\", ", uname.sysname, uname.nodename);
      tprintf("release=\"%s\", version=\"%s\", ", uname.release, uname.version);
      tprintf("machine=\"%s\"", uname.machine);   
#ifndef __GLIBC__
      tprintf(", domainname=\"%s\"", uname.domainname);
#endif /* __GLIBC__ */
      tprintf("})");
    }
  else
    tprintf("_)");
  
  return 0;
}



int 
sys_uname(tcp, n_arg)
struct tcb *tcp;
int n_arg;
{
  struct utsname *uname;
  
  switch(n_arg){
  case 0:
    if (exiting(tcp)) 
      {
	if (syserror(tcp))
	  {
	    fprintf(stderr, "sys_uname: syscall failed\n");
	    return -1;
	  }

	if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&uname, sizeof(struct utsname), "uname"))
	  {
	    fprintf(stderr, "sys_uname: set_copy\n");
	    return -1;
	  }
      }
    break;
  }
  return 0;
}



static struct xlat ptrace_cmds[] = {
  { PTRACE_TRACEME,	"PTRACE_TRACEME"	},
  { PTRACE_PEEKTEXT,	"PTRACE_PEEKTEXT",	},
  { PTRACE_PEEKDATA,	"PTRACE_PEEKDATA",	},
  { PTRACE_PEEKUSER,	"PTRACE_PEEKUSER",	},
  { PTRACE_POKETEXT,	"PTRACE_POKETEXT",	},
  { PTRACE_POKEDATA,	"PTRACE_POKEDATA",	},
  { PTRACE_POKEUSER,	"PTRACE_POKEUSER",	},
  { PTRACE_CONT,	"PTRACE_CONT"		},
  { PTRACE_KILL,	"PTRACE_KILL"		},
  { PTRACE_SINGLESTEP,	"PTRACE_SINGLESTEP"	},
  { PTRACE_ATTACH,	"PTRACE_ATTACH"		},
  { PTRACE_DETACH,	"PTRACE_DETACH"		},
  { PTRACE_SYSCALL,	"PTRACE_SYSCALL"	},
  { 0,			NULL			},
};


static
struct xlat struct_user_offsets[] = {
  { 4*EBX,		"4*EBX"					},
  { 4*ECX,		"4*ECX"					},
  { 4*EDX,		"4*EDX"					},
  { 4*ESI,		"4*ESI"					},
  { 4*EDI,		"4*EDI"					},
  { 4*EBP,		"4*EBP"					},
  { 4*EAX,		"4*EAX"					},
  { 4*DS,		"4*DS"					},
  { 4*ES,		"4*ES"					},
  { 4*FS,		"4*FS"					},
  { 4*GS,		"4*GS"					},
  { 4*ORIG_EAX,		"4*ORIG_EAX"				},
  { 4*EIP,		"4*EIP"					},
  { 4*CS,		"4*CS"					},
  { 4*EFL,		"4*EFL"					},
  { 4*UESP,		"4*UESP"				},
  { 4*SS,		"4*SS"					},
  
  { uoff(u_fpvalid),	"offsetof(struct user, u_fpvalid)"	},

  { uoff(i387),		"offsetof(struct user, i387)"		},
  
  { uoff(u_tsize),	"offsetof(struct user, u_tsize)"	},
  { uoff(u_dsize),	"offsetof(struct user, u_dsize)"	},
  { uoff(u_ssize),	"offsetof(struct user, u_ssize)"	},
  { uoff(start_code),	"offsetof(struct user, start_code)"	},
  { uoff(start_stack),	"offsetof(struct user, start_stack)"	},
  { uoff(signal),	"offsetof(struct user, signal)"		},
  
  { uoff(reserved),	"offsetof(struct user, reserved)"	},

  { uoff(u_ar0),	"offsetof(struct user, u_ar0)"		},

  { uoff(u_fpstate),	"offsetof(struct user, u_fpstate)"	},

  { uoff(magic),	"offsetof(struct user, magic)"		},
  { uoff(u_comm),       "offsetof(struct user, u_comm)"		},

  { uoff(u_debugreg),	"offsetof(struct user, u_debugreg)"	},

  { sizeof(struct user),"sizeof(struct user)"			},
  { 0,			NULL					},
};


int 
print_ptrace(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  char *cmd;
  struct xlat *x;
  long addr;
  
  tprintf("ptrace(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    cmd = get_xlat_str(ptrace_cmds, *((int*)info->u_arg[0]));
	    if (!cmd)
	      cmd = "PTRACE_???";
	    break;
	  case 1:
	    tprintf("%lu", *((unsigned long *)info->u_arg[1]));
	    break;
	  case 2:
	    addr = *((long*)info->u_arg[2]);
	    if ((*((enum  __ptrace_request*)info->u_arg[0]) == PTRACE_PEEKUSER) || (*((enum  __ptrace_request*)info->u_arg[0]) == PTRACE_POKEUSER)) 
	      {
		for (x = struct_user_offsets; x->str; x++) 
		  {
		    if (x->val >= addr)
		      break;
		  }

		if (!x->str)
		  tprintf("%#lx", addr);
		else 
		  if (x->val > addr && x != struct_user_offsets) 
		    {
		      x--;
		      tprintf("%s + %ld", x->str, addr - x->val);
		    }
		  else
		    tprintf("%s", x->str);
	      }
	    else
	      tprintf("%#lx", addr);
	    break;
	  case 3:
	    switch (*((int*)info->u_arg[0])) {
	    case PTRACE_PEEKDATA:
	    case PTRACE_PEEKTEXT:
	    case PTRACE_PEEKUSER:
	      realprintnum(((int*)info->u_arg[3]), "%#x");
	      break;
	    case PTRACE_CONT:
	    case PTRACE_SINGLESTEP:
	    case PTRACE_SYSCALL:
	    case PTRACE_DETACH:
	      realprintsignal(((int*)info->u_arg[3]));
	      break;
	    default:
	      tprintf("%#lx", *((unsigned long *)info->u_arg[3]));
	      break;
	    }
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}




/*
  long int ptrace(enum __ptrace_request request, pid_t pid, void * addr, void * data)   
  Numero argomenti: 4
  -) un campo che specifica l'azione da eseguire (enum __ptrace_request)
  -) il pid del processo da tracciare (pid_t == int)
  -) indirizzo di memoria o offset (void *)
  -) indirizzo di memoria o numero di segnale (void *)
*/
int 
sys_ptrace(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  long *mem_ind;

  switch (n_arg) {
  case 0:
  case 1:
    arg_alloc(tcp,n_arg);
    break;
  case 2:
    //if (entering(tcp)) 
      {
	int arg0, *ptr;

	if ( (ptr = (int *) take_arg(0, tcp)) == NULL )
	  {
	    fprintf(stderr, "sys_ptrace: take_arg(0, tcp)\n");
	    return -1;
	  }
	arg0 = *ptr;
	
	if ( arg0 == PTRACE_PEEKUSER || arg0 == PTRACE_POKEUSER ) 
	  {
	    //in questo caso viene trattato come un offset
	    arg_alloc(tcp, n_arg);
	    break;
	  }
	
	//in questo caso viene trattato come un indirizzo
	if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&mem_ind, sizeof(long), "ptrace"))
	  {
	    fprintf(stderr, "sys_ptrace: set_copy\n");
	    return -1;
	  }
      }
    break;
  case 3: /* CONTROLLARE */
    if ( ((int *) take_arg(0, tcp)) == NULL )
      {
	fprintf(stderr, "sys_ptrace: take_arg(0, tcp)\n");
	return -1;
      }
    arg_alloc(tcp, n_arg);
    break;
  }
  return 0;
}
