/*
 * Copyright (c) 2001-2003 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <frassi@iit.cnr.it>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: protofunct.h,v 1.3 2003/02/17 15:55:51 frassi Exp $
 */

/*
struct funct_entry {
  char *name;
  char *so_filename;   // shared object file name
  int args_num;
  int ret_type;
  int args_type[10]; 
  void *(* ptr)(); 
};
*/

{"printf",               NULL, 1, INT,      {CHAR_PTR,0,0,0,0,0,0,0,0,0},                                        (void *(*)()) printf            },// libc
{"printfile",            NULL, 2, 0,        {CHAR_PTR,CHAR_PTR,0,0,0,0,0,0,0,0},                                 (void *(*)()) printfile         },
{"printconsole",         NULL, 1, 0,        {CHAR_PTR,0,0,0,0,0,0,0,0},                                          (void *(*)())    printconsole   },
{"firewalla",            NULL, 1, 0,        {CHAR_PTR,0,0,0,0,0,0,0,0,0},                                        (void *(*)()) firewalla         },
{"term",                 NULL, 1, 0,        {INT,0,0,0,0,0,0,0,0,0},                                             (void *(*)()) exit              },// libc
{"printchar",            NULL, 1, 0,        {0,0,0,0,0,0,0,0,0,0},                                               (void *(*)()) printchar         },  
{"printint",             NULL, 1, INT,      {INT,0,0,0,0,0,0,0,0,0},                                             (void *(*)()) printint          },  

{"find",                 NULL, 3, INT,      {CHAR_PTR,CHAR_PTR,CHAR_PTR,0,0,0,0,0,0,0},                          (void *(*)()) find              },
{"find_begin_nobar",     NULL, 3, INT,      {CHAR_PTR,CHAR_PTR,CHAR_PTR,0,0,0,0,0,0,0},                          (void *(*)()) find_begin_nobar  },
{"read_str_pwd",         NULL, 1, CHAR_PTR, {CHAR_PTR,0,0,0,0,0,0,0,0,0},                                        (void *(*)()) read_str_pwd      },
{"find_or",              NULL, 3, INT,      {CHAR_PTR,CHAR_PTR,CHAR_PTR,0,0,0,0,0,0,0},                          (void *(*)()) find_or           },
{"checksize",            NULL, 4, INT,      {CHAR_PTR,CHAR_PTR_PTR,INT,INT,0,0,0,0,0,0},                         (void *(*)()) checksize         },
{"find_cgi",             NULL, 3, INT,      {HASH_STRING,CHAR_PTR,CHAR_PTR,0,0,0,0,0,0,0},                       (void *(*)()) find_cgi          },
{"union_str",            NULL, 2, CHAR_PTR, {CHAR_PTR,CHAR_PTR,0,0,0,0,0,0,0,0},                                 (void *(*)()) union_str         },
{"find_begin",           NULL, 3, INT,      {CHAR_PTR,CHAR_PTR,CHAR_PTR,0,0,0,0,0,0,0},                          (void *(*)()) find_begin        },
{"two_find",             NULL, 4, INT,      {CHAR_PTR,CHAR_PTR,CHAR_PTR,INT_PTR,0,0,0,0,0},                      (void *(*)()) two_find          },
{"one_find_begin",       NULL, 4, INT,      {CHAR_PTR,CHAR_PTR,CHAR_PTR,INT_PTR,0,0,0,0,0},                      (void *(*)()) one_find_begin    },
{"one_find_begin_nobar", NULL, 4, INT,      {CHAR_PTR,CHAR_PTR,CHAR_PTR,INT_PTR,0,0,0,0,0,0},                    (void *(*)()) one_find_begin_nobar },
{"two_find_or",          NULL, 4, INT,      {CHAR_PTR,CHAR_PTR,CHAR_PTR,INT_PTR,0,0,0,0,0,0},                    (void *(*)()) two_find_or   },
{"find_execve",          NULL, 6, INT,      {CHAR_PTR,CHAR_PTR_PTR,CHAR_PTR,CHAR_PTR,CHAR_PTR,CHAR_PTR,0,0,0,0}, (void *(*)()) find_execve   },
{"find_or_array",        NULL, 6, INT,      {CHAR_PTR,CHAR_PTR_PTR,CHAR_PTR,CHAR_PTR,CHAR_PTR,INT_PTR,0,0,0,0},  (void *(*)()) find_or_array },
{"multi_find_begin_nobar",  NULL, 4, INT,   {CHAR_PTR,CHAR_PTR,CHAR_PTR,CHAR_PTR,0,0,0,0,0,0},                   (void *(*)()) multi_find_begin_nobar },


// {"print_syscall",      NULL, 0, 0,        {0,0,0,0,0,0,0,0,0,0},                     (void *(*)()) print_syscall_realtime },
{"freeze",                 NULL, 0, 0,       {0,0,0,0,0,0,0,0,0,0},                                              (void *(*)()) freeze            },
{"de_freeze",              NULL, 1, 0,       {INT,0,0,0,0,0,0,0,0,0},                                            (void *(*)()) de_freeze         },
{"kill_actual",            NULL, 0, 0,       {0,0,0,0,0,0,0,0,0,0},                                              (void *(*)()) kill_actual       },
{"get_pid",                NULL, 0, INT,     {0,0,0,0,0,0,0,0,0,0},                                              (void *(*)()) get_pid           },
{"get_ip_addr",            NULL, 1, CHAR_PTR, {STRUCT_SOCKADDR_PTR,0,0,0,0,0,0,0,0,0},                           (void *(*)()) get_ip_addr       },
{"get_sa_family",          NULL, 1, INT,      {STRUCT_SOCKADDR_PTR,0,0,0,0,0,0,0,0,0},                           (void *(*)()) get_sa_family     },
  //{"log",                    NULL, 2, 0 ,     {INT,CHAR_PTR,0,0,0,0,0,0,0,0},                                      (void *(*)()) log               },

{"search_path",            NULL, 2, INT,      {HASH_STRING,CHAR_PTR,0,0,0,0,0,0,0,0},                            (void *(*)()) search_path       },
{"canonicalize_file_name", NULL, 1, CHAR_PTR, {CHAR_PTR,0,0,0,0,0,0,0,0,0},                                      (void *(*)()) canonicalize_file_name },// libc
