#ifndef RUNTIME_UTIL_H
#define RUNTIME_UTIL_H

/*
 * Copyright (c) 2001-2003 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <frassi@iit.cnr.it>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: runtime_util.h,v 1.1.1.1 2001/12/17 08:58:48 frassi Exp $
 */


#include "automa_management.h"

/*#define DEBUG_WIZ 1*/

/******************************************
 * funzioni da definire per le condizioni *
 ******************************************/

/* 
struct tcb {
	short flags;		
	int pid;		
	long scno;		
	int u_nargs;		
	long u_arg[6];   	
        
        int arg_state[6];
	
        int u_error;		
	long u_rval;		
        char *auxstr;		
  
};
*/

int get_type_values(char *var_name, int num_macro);
var_t get_type_var(char *var_name, int num_macro);


typedef int (*cond_funct_ptr)(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);


cond_funct_ptr eq(arg_node_t *left_op, arg_node_t *right_op, int num_macro);

cond_funct_ptr arg_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr arg_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr funct_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr funct_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);

int eq_funct_funct_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_funct_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_funct_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

void *eval_funct(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

/******** Funzioni chiamate a run-time **********/
int eq_str_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_str_var(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_str_hashvar(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_hashvar_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_str_funct(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

int eq_chr_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_chr_var(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_chr_hashvar(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_hashvar_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_chr_funct(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

int eq_long_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_long_var(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_long_hashvar(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_hashvar_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_long_funct(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

int eq_var_var_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_var_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_var_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

int eq_var_hashvar(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_hashvar_var(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_hashvar_hashvar(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void confront_ht (gpointer key, gpointer value, gpointer user_data);  /* usata da eq_hashvar_hashvar */

int eq_var_funct_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_funct_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_funct_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_var_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_var_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_var_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_hashvar_funct(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_hashvar(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);


/* inserita per compilare 
struct sysent {
	int	nargs;
	int	sys_flags;
	int	(*sys_func)();
	char	*sys_name;
}sysent2[10];
*/

//int upeek (int a, long b, long *c);

void *take_arg(int num_arg, struct tcb *tcp);


int eq_str_label(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_chr_label(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_long_label(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_var_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_var_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_var_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_hashvar(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_label_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_label_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_var_label_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_hashvar_label(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_label_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_label_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_label_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_funct_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_funct_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_label_funct_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_label_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_label_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int eq_funct_label_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
/*****************************************************************************/

/************************* funzioni per != ******************************/

cond_funct_ptr ne(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr ne_arg_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr ne_arg_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr ne_funct_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr ne_funct_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);

/* queste funzioni ci sono per la compatibilita' con le funzioni di == */ 
int ne_str_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ne_chr_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ne_long_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ne_ht_v(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ne_v_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ne_ht_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
/* FINE queste funzioni ci sono per la compatibilita' con le funzioni di == */ 

int ne_s(char *a, char *b);
int ne_c(char *a, char *b);
int ne_l(long *a, long *b);
int ne_hash_v(GHashTable *ht, void *b);
int ne_v_hash(void *a, GHashTable *ht);
int ne_hash_hash(GHashTable *a, GHashTable *b);


/************************* funzioni per > ******************************/

cond_funct_ptr gt(arg_node_t *left_op, arg_node_t *right_op, int num_macro);  /* maggiore */
cond_funct_ptr gt_arg_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr gt_arg_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr gt_funct_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr gt_funct_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);


/* queste funzioni ci sono per la compatibilita' con le funzioni di == */ 
int gt_str_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int gt_chr_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int gt_long_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int gt_ht_v(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int gt_v_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int gt_ht_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
/* FINE queste funzioni ci sono per la compatibilita' con le funzioni di == */ 

int gt_s(char *a, char *b);
int gt_c(char *a, char *b);
int gt_l(long *a, long *b);
int gt_hash_v(GHashTable *ht, void *b);
int gt_v_hash(void *a, GHashTable *ht);
int gt_hash_hash(GHashTable *a, GHashTable *b);

/***************************************** maggiore o uguale *******************************/
cond_funct_ptr ge(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr ge_arg_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr ge_arg_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr ge_funct_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr ge_funct_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);


/* queste funzioni ci sono per la compatibilita' con le funzioni di == */ 
int ge_str_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ge_chr_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ge_long_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ge_ht_v(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ge_v_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int ge_ht_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
/* FINE queste funzioni ci sono per la compatibilita' con le funzioni di == */ 

int ge_s(char *a, char *b);
int ge_c(char *a, char *b);
int ge_l(long *a, long *b);
int ge_hash_v(GHashTable *ht, void *b);
int ge_v_hash(void *a, GHashTable *ht);
int ge_hash_hash(GHashTable *a, GHashTable *b);

/********************************* minore **********************************************/
cond_funct_ptr lt(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr lt_arg_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr lt_arg_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr lt_funct_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr lt_funct_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);


/* queste funzioni ci sono per la compatibilita' con le funzioni di == */ 
int lt_str_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int lt_chr_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int lt_long_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int lt_ht_v(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int lt_v_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int lt_ht_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
/* FINE queste funzioni ci sono per la compatibilita' con le funzioni di == */ 

int lt_s(char *a, char *b);
int lt_c(char *a, char *b);
int lt_l(long *a, long *b);
int lt_hash_v(GHashTable *ht, void *b);
int lt_v_hash(void *a, GHashTable *ht);
int lt_hash_hash(GHashTable *a, GHashTable *b);



/*************************************** minore o uguale ********************************/
cond_funct_ptr le(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr le_arg_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr le_arg_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr le_funct_arg(arg_node_t *left_op, arg_node_t *right_op, int num_macro);
cond_funct_ptr le_funct_funct(arg_node_t *left_op, arg_node_t *right_op, int num_macro);


/* queste funzioni ci sono per la compatibilita' con le funzioni di == */ 
int le_str_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int le_chr_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int le_long_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int le_ht_v(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int le_v_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
int le_ht_ht(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
/* FINE queste funzioni ci sono per la compatibilita' con le funzioni di == */ 

int le_s(char *a, char *b);
int le_c(char *a, char *b);
int le_l(long *a, long *b);
int le_hash_v(GHashTable *ht, void *b);
int le_v_hash(void *a, GHashTable *ht);
int le_hash_hash(GHashTable *a, GHashTable *b);


/******************************************************************************************
 ******************************* funzioni per gli statements ******************************
 ******************************************************************************************/

typedef void (*act_funct_ptr)(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

act_funct_ptr assign(arg_node_t *left_op, arg_node_t *right_op, int num_macro);

act_funct_ptr assign_to_var(arg_node_t *l, arg_node_t *r, int num_macro);
act_funct_ptr assign_to_hashvar(arg_node_t *l, arg_node_t *r, int num_macro);

/******** Funzioni chiamate a run-time **********/
void eval_stmt(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

void as_var_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_var_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_var_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

void as_var_var_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_var_var_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_var_var_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);


void as_var_label_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_var_label_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_var_label_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);


void as_var_funct_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_var_funct_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_var_funct_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);


void as_hashvar_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

void as_hashvar_hstr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_hchr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_hlong(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
/* void insert_ht(gpointer key, gpointer value, gpointer user_data); */

void as_hashvar_var_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_var_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_var_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

void as_hashvar_hashvar_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_hashvar_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_hashvar_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

void as_hashvar_label_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_label_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_label_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);

void as_hashvar_funct_str(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_funct_chr(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);
void as_hashvar_funct_long(GNode *funct_tree, GHashTable *ht, struct tcb *tcp);




#endif /* !RUNTIME_UTIL_H */
