/*
 * Copyright (c) 2001-2003 Davide Fais, Stefano Frassi, Vincenzo Di Stefano, Filippo Giuntini, Luca Pugliese <frassi@iit.cnr.it>
 * for adding wIDSard code
 * Copyright (c) 1991, 1992 Paul Kranenburg <pk@cs.few.eur.nl>
 * Copyright (c) 1993 Branko Lankester <branko@hacktic.nl>
 * Copyright (c) 1993, 1994, 1995, 1996 Rick Sladkey <jrs@world.std.com>
 * Copyright (c) 1996-1999 Wichert Akkerman <wichert@cistron.nl>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	$Id: system.c,v 1.3 2003/02/17 15:28:18 frassi Exp $
 */


/*
contiene il codice relativo alle chiamate:
mount
umount,umount2
personality
_sysctl
capget
capset
*/

//#include "defs.h"
//#include "gestione_automa.h"
#include "gets.h"
#include "util.h"
#include "pars_funct.h" /* get_nargs */


/* #define _LINUX_SOCKET_H */
/* #define _LINUX_FS_H */

/* #define MS_RDONLY   1  /\* Mount read-only *\/ */
/* #define MS_NOSUID   2  /\* Ignore suid and sgid bits *\/ */
/* #define MS_NODEV    4  /\* Disallow access to device special files *\/ */
/* #define MS_NOEXEC   8  /\* Disallow program execution *\/ */
/* #define MS_SYNCHRONOUS 16  /\* Writes are synced at once *\/ */
/* #define MS_REMOUNT 32  /\* Alter flags of a mounted FS *\/ */

/* #include <sys/socket.h> */
/* #include <netinet/in.h> */
/* #include <arpa/inet.h> */

/* #include <sys/syscall.h> */

/* #ifdef SYS_personality /\*presente in bits/syscall.h*\/ */
/* /\* Workaround for kernel namespace pollution. *\/ */
/* #define _LINUX_PTRACE_H */
/* /\* Yuck yuck yuck.  We can't include linux/ptrace.h, but personality.h */
/*    makes a declaration with struct pt_regs, which is defined there. *\/ */
/* //struct pt_regs; */
/* #define sys_personality kernel_sys_personality */
/* //#include <linux/personality.h> /\*file presente*\/ */
/* #undef sys_personality */
/* #endif /\* SYS_personality *\/ */

/* #ifdef SYS_capget /\*presente in bits/syscall.h*\/ */
/* #include <linux/capability.h> /\*il file e' presente*\/ */
/* #endif */

/* #ifdef SYS_cacheflush /\*presente in un commento all'interno di linux/capability.h, pero' a quanto ho capito si riferisce all'architettura m68k*\/ */
/* #include <asm/cachectl.h> /\*il file non e' presente*\/ */
/* #endif */

/* #include <linux/sysctl.h> */

/* static struct xlat mount_flags[] = { */
/*   { MS_RDONLY,	"MS_RDONLY"	}, */
/*   { MS_NOSUID,	"MS_NOSUID"	}, */
/*   { MS_NODEV,	"MS_NODEV"	}, */
/*   { MS_NOEXEC,	"MS_NOEXEC"	}, */
/* #ifdef MS_SYNCHRONOUS  /\*definita in /usr/include/sys/mount.h e anche in /linux/fs.h*\/ */
/*   { MS_SYNCHRONOUS,"MS_SYNCHRONOUS"}, */
/* #else */
/*   { MS_SYNC,	"MS_SYNC"	}, */
/* #endif */
/*   { MS_REMOUNT,	"MS_REMOUNT"	}, */
/*   { 0,		NULL		}, */
/* }; */

#define _LINUX_SOCKET_H
#define _LINUX_FS_H

#define MS_RDONLY   1  /* Mount read-only */
#define MS_NOSUID   2  /* Ignore suid and sgid bits */
#define MS_NODEV    4  /* Disallow access to device special files */
#define MS_NOEXEC   8  /* Disallow program execution */
#define MS_SYNCHRONOUS 16  /* Writes are synced at once */
#define MS_REMOUNT 32  /* Alter flags of a mounted FS */

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <sys/syscall.h>

#ifdef SYS_personality
/* Workaround for kernel namespace pollution. */
#define _LINUX_PTRACE_H
/* Yuck yuck yuck.  We can't include linux/ptrace.h, but personality.h
   makes a declaration with struct pt_regs, which is defined there. */
struct pt_regs;
#define sys_personality kernel_sys_personality
//#include <linux/personality.h>  ATTENZIONE: va in conflitto con handler_t di parser.h
#undef sys_personality
#endif /* SYS_personality */

#ifdef SYS_capget
#include <linux/capability.h>
#endif

#ifdef SYS_cacheflush
#include <asm/cachectl.h>
#endif

#ifdef HAVE_LINUX_USTNAME_H
#include <linux/utsname.h>
#endif

#ifdef HAVE_ASM_SYSMIPS_H
#include <asm/sysmips.h>
#endif

#include <linux/sysctl.h>

static struct xlat mount_flags[] = {
	{ MS_RDONLY,	"MS_RDONLY"	},
	{ MS_NOSUID,	"MS_NOSUID"	},
	{ MS_NODEV,	"MS_NODEV"	},
	{ MS_NOEXEC,	"MS_NOEXEC"	},
#ifdef MS_SYNCHRONOUS
	{ MS_SYNCHRONOUS,"MS_SYNCHRONOUS"},
#else
	{ MS_SYNC,	"MS_SYNC"	},
#endif
	{ MS_REMOUNT,	"MS_REMOUNT"	},
	{ 0,		NULL		},
};



int 
print_mount(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("mount(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	  case 1:
	  case 2:
	    string_quote((char *) info->u_arg[i]);
	    break;
	  case 3:
	    printflags(mount_flags, *((int*)info->u_arg[3]));
	    break;
	  case 4:
	    tprintf("%#lx", *((unsigned long*)info->u_arg[4]));
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}




/*
  Numero argomenti: 5
  -) nome di device indicante il filesystem (const char *)
  -) nome della directory alla quale viene attaccato il filesystem (const char *)
  -) nome del tipo del filesystem (const char *)
  -) flag di mount (unsigned long)
  -) dati interpretati dai diversi file system (const void *)
  N.B.: il parametro con i flag deve contenere il magic-number. Se questo e' assente,
        gli ultimi due parametri sono ignorati.
*/
int 
sys_mount(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  long *mem_2;

  switch (n_arg) {
  case 0:
  case 1:
  case 2:
    ((char *) tcp->u_arg[n_arg]) = get_path(tcp, tcp->u_arg[n_arg]);
    
    if ( get_error )
      {
	fprintf(stderr, "sys_mount: get_path\n");
	tcp->arg_state[n_arg] = EMPTY;
	return -1;
      }
    tcp->arg_state[n_arg] = TAKEN;
    break;
  case 3:
    arg_alloc(tcp,n_arg);
    break;
  case 4:
    //if (entering(tcp))
      if ( set_copy( tcp, n_arg, tcp->u_arg[n_arg], (long *) &mem_2, sizeof(tcp->u_arg[n_arg]), "mount") ) /* CONTROLLARE sizeof(tcp->u_arg[n_arg]) */
	{
	  fprintf(stderr, "sys_mount: set_copy\n");
	  return -1;
	}
    break;
  }
  return 0;
}



int 
print_umount2(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  
  tprintf("umount2(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    realprintstr((char*)info->u_arg[0], -1);
	    break;
	  case 1:
	    if (*((int*)info->u_arg[1]) & 1)
	      tprintf("MNT_FORCE");
	    else
	      tprintf("0");
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



/*
per quanto riguarda la "fantomatica" umount2, non riportata nel man:

l'header /usr/include/sys/mount.h contiene il seguente prototipo:

/ Unmount a filesystem.  /
extern int umount __P ((__const char *__special_file));
 
/ Unmount a filesystem.  Force unmounting if FLAGS is set to MNT_FORCE.  /
extern int umount2 __P ((__const char *__special_file, int __flags));       

a parte il solito giochetto del __P, quindi pare che ce ne sia un'altra di chiamata Umount con due argomenti:
il primo uguale a quello di umount, il secondo un flag che,se settato, serve a forzare l'unmounting
*/

/*
  Numero argomenti: 2
  -) nome di device indicante il filesystem (const char *)
  -) flag di forzatura (int)
*/
int 
sys_umount2(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  switch (n_arg) {
  case 0:
    ((char *) tcp->u_arg[0]) = get_str(tcp, tcp->u_arg[0], -1);
    if ( get_error )
      {
	fprintf(stderr, "sys_umount2: get_str\n");
	tcp->arg_state[0] = EMPTY;
	return -1;
      }
    tcp->arg_state[0] = TAKEN;
    break;
  case 1:
    arg_alloc(tcp,n_arg);
    break;
  }
  return 0;
}

/* ATTENZIONE: avendo commentato personality.h!!! */

static struct xlat personality_options[] = {
#ifdef PER_LINUX /* definita in /usr/include/linux/personality.h */
  { PER_LINUX,	"PER_LINUX"	},
#endif
#ifdef PER_LINUX_32BIT /* definita in /usr/include/linux/personality.h */
  { PER_LINUX_32BIT,	"PER_LINUX"	},
#endif
#ifdef PER_SVR4 /* definita in /usr/include/linux/personality.h */
  { PER_SVR4,	"PER_SVR4"	},
#endif
#ifdef PER_SVR3 /* definita in /usr/include/linux/personality.h */
  { PER_SVR3,	"PER_SVR3"	},
#endif
#ifdef PER_SCOSVR3 /* definita in /usr/include/linux/personality.h */
  { PER_SCOSVR3,	"PER_SCOSVR3"	},
#endif
#ifdef PER_WYSEV386  /* definita in /usr/include/linux/personality.h */
  { PER_WYSEV386,	"PER_WYSEV386"	},
#endif
#ifdef PER_ISCR4 /* definita in /usr/include/linux/personality.h */
  { PER_ISCR4,	"PER_ISCR4"	},
#endif
#ifdef PER_BSD /* definita in /usr/include/linux/personality.h */
  { PER_BSD,	"PER_BSD"	},
#endif
#ifdef PER_XENIX /* definita in /usr/include/linux/personality.h */
  { PER_XENIX,	"PER_XENIX"	},
#endif
  { 0,		NULL		},
};



int 
print_personality(info)
msg_building_info *info;
{
  tprintf("personality(");
  
  if (info->arg_state[0]==TAKEN)
    { 
      printxval(personality_options, *((int*)info->u_arg[0]), "PER_???");
      tprintf(")");
    }
  else
    tprintf("_)");
  
  return 0;
}


/*
NAME
       personality - setta il dominio di esecuzione del processo
 
SYNOPSIS
       int personality(unsigned long persona);     
*/
int
sys_personality(tcp,n_arg)
struct tcb *tcp;
int n_arg;
{
  arg_alloc(tcp,n_arg);
  return 0;
}



#include <linux/reboot.h>
static struct xlat bootflags1[] = {
	{ LINUX_REBOOT_MAGIC1,	"LINUX_REBOOT_MAGIC1"	},
	{ 0,			NULL			},
};

static struct xlat bootflags2[] = {
	{ LINUX_REBOOT_MAGIC2,	"LINUX_REBOOT_MAGIC2"	},
	{ LINUX_REBOOT_MAGIC2A,	"LINUX_REBOOT_MAGIC2A"	},
	{ LINUX_REBOOT_MAGIC2B,	"LINUX_REBOOT_MAGIC2B"	},
	{ 0,			NULL			},
};

static struct xlat bootflags3[] = {
	{ LINUX_REBOOT_CMD_CAD_OFF,	"LINUX_REBOOT_CMD_CAD_OFF"	},
	{ LINUX_REBOOT_CMD_RESTART,	"LINUX_REBOOT_CMD_RESTART"	},
	{ LINUX_REBOOT_CMD_HALT,	"LINUX_REBOOT_CMD_HALT"		},
	{ LINUX_REBOOT_CMD_CAD_ON,	"LINUX_REBOOT_CMD_CAD_ON"	},
	{ LINUX_REBOOT_CMD_POWER_OFF,	"LINUX_REBOOT_CMD_POWER_OFF"	},
	{ LINUX_REBOOT_CMD_RESTART2,	"LINUX_REBOOT_CMD_RESTART2"	},
	{ 0,				NULL				},
};

/*
int 
print_reboot(info)
msg_building_info *info;
{

}
*/

int
sys_reboot(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  /*
	if (entering(tcp)) {
		if (!printflags(bootflags1, tcp->u_arg[0]))
			tprintf("LINUX_REBOOT_MAGIC???");
		tprintf(", ");
		if (!printflags(bootflags2, tcp->u_arg[1]))
			tprintf("LINUX_REBOOT_MAGIC???");
		tprintf(", ");
		if (!printflags(bootflags3, tcp->u_arg[2]))
			tprintf("LINUX_REBOOT_CMD_???");
		if (tcp->u_arg[2] == LINUX_REBOOT_CMD_RESTART2) {
			tprintf(", ");
			printstr(tcp, tcp->u_arg[3], -1);
		}
	}
	return 0;
  */
  switch (n_arg) {
  case 0:
  case 1:
  case 2:
    arg_alloc(tcp,n_arg);
    break;
  case 3:
    ((char *) tcp->u_arg[3]) = get_str(tcp, tcp->u_arg[3], -1);
    if ( get_error )
      {
	fprintf(stderr, "sys_reboot: get_str\n");
	tcp->arg_state[3] = EMPTY;
	return -1;
      }
    tcp->arg_state[3] = TAKEN;
    break;
  }
  
  return 0;
}



#ifdef SYS_capget
static struct xlat capabilities[] = {
	{ 1<<CAP_CHOWN,		"CAP_CHOWN"	},
	{ 1<<CAP_DAC_OVERRIDE,	"CAP_DAC_OVERRIDE"},
	{ 1<<CAP_DAC_READ_SEARCH,"CAP_DAC_READ_SEARCH"},
	{ 1<<CAP_FOWNER,	"CAP_FOWNER"	},
	{ 1<<CAP_FSETID,	"CAP_FSETID"	},
	{ 1<<CAP_KILL,		"CAP_KILL"	},
	{ 1<<CAP_SETGID,	"CAP_SETGID"	},
	{ 1<<CAP_SETUID,	"CAP_SETUID"	},
	{ 1<<CAP_SETPCAP,	"CAP_SETPCAP"	},
	{ 1<<CAP_LINUX_IMMUTABLE,"CAP_LINUX_IMMUTABLE"},
	{ 1<<CAP_NET_BIND_SERVICE,"CAP_NET_BIND_SERVICE"},
	{ 1<<CAP_NET_BROADCAST,	"CAP_NET_BROADCAST"},
	{ 1<<CAP_NET_ADMIN,	"CAP_NET_ADMIN"	},
	{ 1<<CAP_NET_RAW,	"CAP_NET_RAW"	},
	{ 1<<CAP_IPC_LOCK,	"CAP_IPC_LOCK"	},
	{ 1<<CAP_IPC_OWNER,	"CAP_IPC_OWNER"	},
	{ 1<<CAP_SYS_MODULE,	"CAP_SYS_MODULE"},
	{ 1<<CAP_SYS_RAWIO,	"CAP_SYS_RAWIO"	},
	{ 1<<CAP_SYS_CHROOT,	"CAP_SYS_CHROOT"},
	{ 1<<CAP_SYS_PTRACE,	"CAP_SYS_PTRACE"},
	{ 1<<CAP_SYS_PACCT,	"CAP_SYS_PACCT"	},
	{ 1<<CAP_SYS_ADMIN,	"CAP_SYS_ADMIN"	},
	{ 1<<CAP_SYS_BOOT,	"CAP_SYS_BOOT"	},
	{ 1<<CAP_SYS_NICE,	"CAP_SYS_NICE"	},
	{ 1<<CAP_SYS_RESOURCE,	"CAP_SYS_RESOURCE"},
	{ 1<<CAP_SYS_TIME,	"CAP_SYS_TIME"	},
	{ 1<<CAP_SYS_TTY_CONFIG,"CAP_SYS_TTY_CONFIG"},
	{ 0,                    NULL            },
};


int 
print_capget(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  cap_user_header_t arg0;
  cap_user_data_t arg1;
  
  tprintf("capget(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    arg0 = (cap_user_header_t)*((long*)info->u_arg[0]);	    
	    //tprintf("{%lx, %d}", (unsigned long)arg0->version, arg0->pid);

	    if (!arg0)
	      tprintf("NULL");
	    else
	      {
		tprintf("%#x, %d", arg0->version, arg0->pid);
	      }
	    break;
	  case 1:
	    arg1 = (cap_user_data_t)*((long*)info->u_arg[1]);
	    //tprintf("{%lx, %lx, %lx}", (unsigned long)arg1->effective,(unsigned long)arg1->permitted, (unsigned long)arg1->inheritable);

	    if (!arg1)
	      tprintf("NULL");
	    else
	      {
		tprintf("{");
		printflags(capabilities, arg1->effective);
		tprintf(", ");
		printflags(capabilities, arg1->permitted);
		tprintf(", ");
		printflags(capabilities, arg1->inheritable);
		tprintf("}");
	      }
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}


/*
  Numero argomenti: 2
  -) header delle capabilities dell'utente (cap_user_header_t)
  -) capabilities dell'utente (cap_user_data_t)

typedef struct __user_cap_header_struct {
        __u32 version;
        int pid;
} *cap_user_header_t;

typedef struct __user_cap_data_struct {
        __u32 effective;
        __u32 permitted;
        __u32 inheritable;
} *cap_user_data_t;

*/
int 
sys_capget(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{  
  cap_user_header_t arg0; // arg0 e arg1 sono puntatori a struct (vedi sopra)
  cap_user_data_t arg1;
  
  switch (n_arg) {
  case 0:
    if (exiting(tcp))
      {
	if (syserror(tcp))
	  {
	    fprintf(stderr,"sys_capget: syscall failed");
	    return -1;
	  }
	if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&arg0, sizeof(struct __user_cap_header_struct), "capget")) /* prima era: sizeof(tcp->u_arg[n_arg]) */
	  {
	    fprintf(stderr, "sys_capget: set_copy\n");
	    return -1;
	  }
      }
    break;
  case 1:
    if (exiting(tcp))
      {
	if (syserror(tcp))
	  {
	    fprintf(stderr,"sys_capget: syscall failed");
	    return -1;
	  }
	if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&arg1 ,sizeof(struct __user_cap_data_struct), "capget")) /* prima era: sizeof(tcp->u_arg[n_arg]) */
	  {
	    fprintf(stderr, "sys_capget: set_copy\n");
	    return -1;
	  }
      }
    break;
  }
  return 0;
}



int 
print_capset(info)
msg_building_info *info;
{
  int i;
  int nargs=get_nargs(info->scno);
  cap_user_header_t arg0;
  cap_user_data_t arg1;
  
  tprintf("capset(");
  
  for (i=0;i<nargs;i++)
    {
      if (info->arg_state[i]==TAKEN)
	{
 	  switch (i) {
	  case 0:
	    arg0 = (cap_user_header_t)*((long*)info->u_arg[0]);	    
	    //tprintf("{%lx, %d}", (unsigned long)arg0->version, arg0->pid);

	    if (!arg0)
	      tprintf("NULL");
	    else
	      {
		tprintf("%#x, %d", arg0->version, arg0->pid);
	      }
	    break;
	  case 1:
	    arg1 = (cap_user_data_t)*((long*)info->u_arg[1]);
	    //tprintf("{%lx, %lx, %lx}", (unsigned long)arg1->effective,(unsigned long)arg1->permitted, (unsigned long)arg1->inheritable);

	    if (!arg1)
	      tprintf("NULL");
	    else
	      {
		tprintf("{");
		printflags(capabilities, arg1->effective);
		tprintf(", ");
		printflags(capabilities, arg1->permitted);
		tprintf(", ");
		printflags(capabilities, arg1->inheritable);
		tprintf("}");
	      }
	    break;
	  }
	}
      else
	tprintf("_");
      
      if (i!=nargs-1)
	tprintf(", ");    
    }
  
  tprintf(") ");

  return 0;
}



/*
  Numero argomenti: 2
  -) header delle capabilities dell'utente (const cap_user_header_t)
  -) capabilities dell'utente (const cap_user_data_t)
*/

int 
sys_capset(tcp, n_arg) 
struct tcb *tcp;
int n_arg;
{
  cap_user_header_t       arg0; // arg0 e arg1 sono puntatori a struct.....
  cap_user_data_t         arg1;
  
  switch (n_arg) {
  case 0:
    //if (entering(tcp))
      if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&arg0, sizeof(struct __user_cap_header_struct), "capset")) /* prima era: sizeof(tcp->u_arg[n_arg]) */
	{
	  fprintf(stderr, "sys_capset: set_copy\n");
	  return -1;
	}
    break;
  case 1:
    //if (entering(tcp))
      if (set_copy(tcp, n_arg, tcp->u_arg[n_arg], (long*)&arg1, sizeof(struct __user_cap_data_struct), "capset")) /* prima era: sizeof(tcp->u_arg[n_arg]) */
	{
	  fprintf(stderr, "sys_capset: set_copy\n");
	  return -1;
	}
    break;
  }
  return 0;
}


#endif


static struct xlat sysctl_root[] = {
	{ CTL_KERN, "CTL_KERN" },
	{ CTL_VM, "CTL_VM" },
	{ CTL_NET, "CTL_NET" },
	{ CTL_PROC, "CTL_PROC" },
	{ CTL_FS, "CTL_FS" },
	{ CTL_DEBUG, "CTL_DEBUG" },
	{ CTL_DEV, "CTL_DEV" },
	{ 0, NULL }
};

static struct xlat sysctl_kern[] = {
	{ KERN_OSTYPE, "KERN_OSTYPE" },
	{ KERN_OSRELEASE, "KERN_OSRELEASE" },
	{ KERN_OSREV, "KERN_OSREV" },
	{ KERN_VERSION, "KERN_VERSION" },
	{ KERN_SECUREMASK, "KERN_SECUREMASK" },
	{ KERN_PROF, "KERN_PROF" },
	{ KERN_NODENAME, "KERN_NODENAME" },
	{ KERN_DOMAINNAME, "KERN_DOMAINNAME" },
#ifdef KERN_SECURELVL
	{ KERN_SECURELVL, "KERN_SECURELVL" },
#endif
	{ KERN_PANIC, "KERN_PANIC" },
#ifdef KERN_REALROOTDEV
	{ KERN_REALROOTDEV, "KERN_REALROOTDEV" },
#endif
#ifdef KERN_JAVA_INTERPRETER
	{ KERN_JAVA_INTERPRETER, "KERN_JAVA_INTERPRETER" },
#endif
#ifdef KERN_JAVA_APPLETVIEWER
	{ KERN_JAVA_APPLETVIEWER, "KERN_JAVA_APPLETVIEWER" },
#endif
	{ KERN_SPARC_REBOOT, "KERN_SPARC_REBOOT" },
	{ KERN_CTLALTDEL, "KERN_CTLALTDEL" },
	{ KERN_PRINTK, "KERN_PRINTK" },
	{ KERN_NAMETRANS, "KERN_NAMETRANS" },
	{ KERN_PPC_HTABRECLAIM, "KERN_PPC_HTABRECLAIM" },
	{ KERN_PPC_ZEROPAGED, "KERN_PPC_ZEROPAGED" },
	{ KERN_PPC_POWERSAVE_NAP, "KERN_PPC_POWERSAVE_NAP" },
	{ KERN_MODPROBE, "KERN_MODPROBE" },
	{ KERN_SG_BIG_BUFF, "KERN_SG_BIG_BUFF" },
	{ KERN_ACCT, "KERN_ACCT" },
	{ KERN_PPC_L2CR, "KERN_PPC_L2CR" },
	{ KERN_RTSIGNR, "KERN_RTSIGNR" },
	{ KERN_RTSIGMAX, "KERN_RTSIGMAX" },
	{ KERN_SHMMAX, "KERN_SHMMAX" },
	{ KERN_MSGMAX, "KERN_MSGMAX" },
	{ KERN_MSGMNB, "KERN_MSGMNB" },
	{ KERN_MSGPOOL, "KERN_MSGPOOL" },
	{ 0, NULL }
};

static struct xlat sysctl_vm[] = {
	{ VM_SWAPCTL, "VM_SWAPCTL" },
	{ VM_SWAPOUT, "VM_SWAPOUT" },
	{ VM_FREEPG, "VM_FREEPG" },
	{ VM_BDFLUSH, "VM_BDFLUSH" },
	{ VM_OVERCOMMIT_MEMORY, "VM_OVERCOMMIT_MEMORY" },
	{ VM_BUFFERMEM, "VM_BUFFERMEM" },
	{ VM_PAGECACHE, "VM_PAGECACHE" },
	{ VM_PAGERDAEMON, "VM_PAGERDAEMON" },
	{ VM_PGT_CACHE, "VM_PGT_CACHE" },
	{ VM_PAGE_CLUSTER, "VM_PAGE_CLUSTER" },
	{ 0, NULL },
};

static struct xlat sysctl_net[] = {
	{ NET_CORE, "NET_CORE" },
	{ NET_ETHER, "NET_ETHER" },
	{ NET_802, "NET_802" },
	{ NET_UNIX, "NET_UNIX" },
	{ NET_IPV4, "NET_IPV4" },
	{ NET_IPX, "NET_IPX" },
	{ NET_ATALK, "NET_ATALK" },
	{ NET_NETROM, "NET_NETROM" },
	{ NET_AX25, "NET_AX25" },
	{ NET_BRIDGE, "NET_BRIDGE" },
	{ NET_ROSE, "NET_ROSE" },
	{ NET_IPV6, "NET_IPV6" },
	{ NET_X25, "NET_X25" },
	{ NET_TR, "NET_TR" },
	{ NET_DECNET, "NET_DECNET" },
	{ 0, NULL }
};

static struct xlat sysctl_net_core[] = {
	{ NET_CORE_WMEM_MAX, "NET_CORE_WMEM_MAX" },
	{ NET_CORE_RMEM_MAX, "NET_CORE_RMEM_MAX" },
	{ NET_CORE_WMEM_DEFAULT, "NET_CORE_WMEM_DEFAULT" },
	{ NET_CORE_RMEM_DEFAULT, "NET_CORE_RMEM_DEFAULT" },
	{ NET_CORE_MAX_BACKLOG, "NET_CORE_MAX_BACKLOG" },
	{ NET_CORE_FASTROUTE, "NET_CORE_FASTROUTE" },
	{ NET_CORE_MSG_COST, "NET_CORE_MSG_COST" },
	{ NET_CORE_MSG_BURST, "NET_CORE_MSG_BURST" },
	{ NET_CORE_OPTMEM_MAX, "NET_CORE_OPTMEM_MAX" },
	{ 0, NULL }
};

static struct xlat sysctl_net_unix[] = {
	{ NET_UNIX_DESTROY_DELAY, "NET_UNIX_DESTROY_DELAY" },
	{ NET_UNIX_DELETE_DELAY, "NET_UNIX_DELETE_DELAY" },
	{ 0, NULL }
};

static struct xlat sysctl_net_ipv4[] = {
	{ NET_IPV4_FORWARD, "NET_IPV4_FORWARD" },
	{ NET_IPV4_DYNADDR, "NET_IPV4_DYNADDR" },
	{ NET_IPV4_CONF, "NET_IPV4_CONF" },
	{ NET_IPV4_NEIGH, "NET_IPV4_NEIGH" },
	{ NET_IPV4_ROUTE, "NET_IPV4_ROUTE" },
	{ NET_IPV4_FIB_HASH, "NET_IPV4_FIB_HASH" },
	{ NET_IPV4_TCP_TIMESTAMPS, "NET_IPV4_TCP_TIMESTAMPS" },
	{ NET_IPV4_TCP_WINDOW_SCALING, "NET_IPV4_TCP_WINDOW_SCALING" },
	{ NET_IPV4_TCP_SACK, "NET_IPV4_TCP_SACK" },
	{ NET_IPV4_TCP_RETRANS_COLLAPSE, "NET_IPV4_TCP_RETRANS_COLLAPSE" },
	{ NET_IPV4_DEFAULT_TTL, "NET_IPV4_DEFAULT_TTL" },
	{ NET_IPV4_AUTOCONFIG, "NET_IPV4_AUTOCONFIG" },
	{ NET_IPV4_NO_PMTU_DISC, "NET_IPV4_NO_PMTU_DISC" },
	{ NET_IPV4_TCP_SYN_RETRIES, "NET_IPV4_TCP_SYN_RETRIES" },
	{ NET_IPV4_IPFRAG_HIGH_THRESH, "NET_IPV4_IPFRAG_HIGH_THRESH" },
	{ NET_IPV4_IPFRAG_LOW_THRESH, "NET_IPV4_IPFRAG_LOW_THRESH" },
	{ NET_IPV4_IPFRAG_TIME, "NET_IPV4_IPFRAG_TIME" },
	{ NET_IPV4_TCP_MAX_KA_PROBES, "NET_IPV4_TCP_MAX_KA_PROBES" },
	{ NET_IPV4_TCP_KEEPALIVE_TIME, "NET_IPV4_TCP_KEEPALIVE_TIME" },
	{ NET_IPV4_TCP_KEEPALIVE_PROBES, "NET_IPV4_TCP_KEEPALIVE_PROBES" },
	{ NET_IPV4_TCP_RETRIES1, "NET_IPV4_TCP_RETRIES1" },
	{ NET_IPV4_TCP_RETRIES2, "NET_IPV4_TCP_RETRIES2" },
	{ NET_IPV4_TCP_FIN_TIMEOUT, "NET_IPV4_TCP_FIN_TIMEOUT" },
	{ NET_IPV4_IP_MASQ_DEBUG, "NET_IPV4_IP_MASQ_DEBUG" },
	{ NET_TCP_SYNCOOKIES, "NET_TCP_SYNCOOKIES" },
	{ NET_TCP_STDURG, "NET_TCP_STDURG" },
	{ NET_TCP_RFC1337, "NET_TCP_RFC1337" },
	{ NET_TCP_SYN_TAILDROP, "NET_TCP_SYN_TAILDROP" },
	{ NET_TCP_MAX_SYN_BACKLOG, "NET_TCP_MAX_SYN_BACKLOG" },
	{ NET_IPV4_LOCAL_PORT_RANGE, "NET_IPV4_LOCAL_PORT_RANGE" },
	{ NET_IPV4_ICMP_ECHO_IGNORE_ALL, "NET_IPV4_ICMP_ECHO_IGNORE_ALL" },
	{ NET_IPV4_ICMP_ECHO_IGNORE_BROADCASTS, "NET_IPV4_ICMP_ECHO_IGNORE_BROADCASTS" },
	{ NET_IPV4_ICMP_SOURCEQUENCH_RATE, "NET_IPV4_ICMP_SOURCEQUENCH_RATE" },
	{ NET_IPV4_ICMP_DESTUNREACH_RATE, "NET_IPV4_ICMP_DESTUNREACH_RATE" },
	{ NET_IPV4_ICMP_TIMEEXCEED_RATE, "NET_IPV4_ICMP_TIMEEXCEED_RATE" },
	{ NET_IPV4_ICMP_PARAMPROB_RATE, "NET_IPV4_ICMP_PARAMPROB_RATE" },
	{ NET_IPV4_ICMP_ECHOREPLY_RATE, "NET_IPV4_ICMP_ECHOREPLY_RATE" },
	{ NET_IPV4_ICMP_IGNORE_BOGUS_ERROR_RESPONSES, "NET_IPV4_ICMP_IGNORE_BOGUS_ERROR_RESPONSES" },
	{ NET_IPV4_IGMP_MAX_MEMBERSHIPS, "NET_IPV4_IGMP_MAX_MEMBERSHIPS" },
	{  0, NULL }
};

static struct xlat sysctl_net_ipv4_route[] = {
	{ NET_IPV4_ROUTE_FLUSH, "NET_IPV4_ROUTE_FLUSH" },
	{ NET_IPV4_ROUTE_MIN_DELAY, "NET_IPV4_ROUTE_MIN_DELAY" },
	{ NET_IPV4_ROUTE_MAX_DELAY, "NET_IPV4_ROUTE_MAX_DELAY" },
	{ NET_IPV4_ROUTE_GC_THRESH, "NET_IPV4_ROUTE_GC_THRESH" },
	{ NET_IPV4_ROUTE_MAX_SIZE, "NET_IPV4_ROUTE_MAX_SIZE" },
	{ NET_IPV4_ROUTE_GC_MIN_INTERVAL, "NET_IPV4_ROUTE_GC_MIN_INTERVAL" },
	{ NET_IPV4_ROUTE_GC_TIMEOUT, "NET_IPV4_ROUTE_GC_TIMEOUT" },
	{ NET_IPV4_ROUTE_GC_INTERVAL, "NET_IPV4_ROUTE_GC_INTERVAL" },
	{ NET_IPV4_ROUTE_REDIRECT_LOAD, "NET_IPV4_ROUTE_REDIRECT_LOAD" },
	{ NET_IPV4_ROUTE_REDIRECT_NUMBER, "NET_IPV4_ROUTE_REDIRECT_NUMBER" },
	{ NET_IPV4_ROUTE_REDIRECT_SILENCE, "NET_IPV4_ROUTE_REDIRECT_SILENCE" },
	{ NET_IPV4_ROUTE_ERROR_COST, "NET_IPV4_ROUTE_ERROR_COST" },
	{ NET_IPV4_ROUTE_ERROR_BURST, "NET_IPV4_ROUTE_ERROR_BURST" },
	{ NET_IPV4_ROUTE_GC_ELASTICITY, "NET_IPV4_ROUTE_GC_ELASTICITY" },
	{ 0, NULL }
};

static struct xlat sysctl_net_ipv4_conf[] = {
	{ NET_IPV4_CONF_FORWARDING, "NET_IPV4_CONF_FORWARDING" },
	{ NET_IPV4_CONF_MC_FORWARDING, "NET_IPV4_CONF_MC_FORWARDING" },
	{ NET_IPV4_CONF_PROXY_ARP, "NET_IPV4_CONF_PROXY_ARP" },
	{ NET_IPV4_CONF_ACCEPT_REDIRECTS, "NET_IPV4_CONF_ACCEPT_REDIRECTS" },
	{ NET_IPV4_CONF_SECURE_REDIRECTS, "NET_IPV4_CONF_SECURE_REDIRECTS" },
	{ NET_IPV4_CONF_SEND_REDIRECTS, "NET_IPV4_CONF_SEND_REDIRECTS" },
	{ NET_IPV4_CONF_SHARED_MEDIA, "NET_IPV4_CONF_SHARED_MEDIA" },
	{ NET_IPV4_CONF_RP_FILTER, "NET_IPV4_CONF_RP_FILTER" },
	{ NET_IPV4_CONF_ACCEPT_SOURCE_ROUTE, "NET_IPV4_CONF_ACCEPT_SOURCE_ROUTE" },
	{ NET_IPV4_CONF_BOOTP_RELAY, "NET_IPV4_CONF_BOOTP_RELAY" },
	{ NET_IPV4_CONF_LOG_MARTIANS, "NET_IPV4_CONF_LOG_MARTIANS" },
	{ 0, NULL }
};

static struct xlat sysctl_net_ipv6[] = {
	{ NET_IPV6_CONF, "NET_IPV6_CONF" },
	{ NET_IPV6_NEIGH, "NET_IPV6_NEIGH" },
	{ NET_IPV6_ROUTE, "NET_IPV6_ROUTE" },
	{ 0, NULL }
};

static struct xlat sysctl_net_ipv6_route[] = {
	{ NET_IPV6_ROUTE_FLUSH, "NET_IPV6_ROUTE_FLUSH" },
	{ NET_IPV6_ROUTE_GC_THRESH, "NET_IPV6_ROUTE_GC_THRESH" },
	{ NET_IPV6_ROUTE_MAX_SIZE, "NET_IPV6_ROUTE_MAX_SIZE" },
	{ NET_IPV6_ROUTE_GC_MIN_INTERVAL, "NET_IPV6_ROUTE_GC_MIN_INTERVAL" },
	{ NET_IPV6_ROUTE_GC_TIMEOUT, "NET_IPV6_ROUTE_GC_TIMEOUT" },
	{ NET_IPV6_ROUTE_GC_INTERVAL, "NET_IPV6_ROUTE_GC_INTERVAL" },
	{ NET_IPV6_ROUTE_GC_ELASTICITY, "NET_IPV6_ROUTE_GC_ELASTICITY" },
	{ 0, NULL }
};




void 
free_sysctl(u_arg, arg_state, u_nargs)
long u_arg[];
arg_state_t arg_state[]; 
int u_nargs;
{
  if (arg_state[0] == TAKEN)
    if (u_arg[0])
      {
	struct __sysctl_args *infosysctl = (struct __sysctl_args *) u_arg[0];
	if (infosysctl->name)
	  free(infosysctl->name);
	if(infosysctl->oldlenp)
	  free(infosysctl->oldlenp);
	if(infosysctl->oldval)
	  free(infosysctl->oldval);
	if(infosysctl->newval)
	  free(infosysctl->newval);
	
	free(infosysctl);
      }
  arg_state[0] = EMPTY;
  return;
}  



int 
print_sysctl(info)
msg_building_info *info;
{
  struct __sysctl_args *infosysctl;
  int *name;
  int cnt = 0;

  tprintf("sysctl(");
  
  if (info->arg_state[0]==TAKEN)
    { 
      infosysctl=(struct __sysctl_args *) info->u_arg[0];
      
      tprintf("{{");
      
      if (infosysctl->nlen == 0)
	goto out;
      
      name=infosysctl->name;
      
      if (name != NULL)
	{
	  printxval(sysctl_root, name[0], "CTL_???");
	  ++cnt;
	  
	  if (infosysctl->nlen == 1)
	    goto out;
	  
	  switch (name[0])
	    {
	    case CTL_KERN:
	      tprintf(", ");
	      printxval(sysctl_kern, name[1], "KERN_???");
	      ++cnt;
	      break;
	    case CTL_VM:
	      tprintf(", ");
	      printxval(sysctl_vm, name[1], "VM_???");
	      ++cnt;
	      break;
	    case CTL_NET:
	      tprintf(", ");
	      printxval(sysctl_net, name[1], "NET_???");
	      ++cnt;
	      if (infosysctl->nlen == 2)
		goto out;
	      switch (name[1]) 
		{
		case NET_CORE:
		  tprintf(", ");
		  printxval(sysctl_net_core, name[2],"NET_CORE_???");
		  break;
		case NET_UNIX:
		  tprintf(", ");
		  printxval(sysctl_net_unix, name[2],"NET_UNIX_???");
		  break;
		case NET_IPV4:
		  tprintf(", ");
		  printxval(sysctl_net_ipv4, name[2],"NET_IPV4_???");
		  if (infosysctl->nlen == 3)
		    goto out;
		  switch (name[2]) {
		  case NET_IPV4_ROUTE:
		    tprintf(", ");
		    printxval(sysctl_net_ipv4_route,name[3],"NET_IPV4_ROUTE_???");
		    break;
		  case NET_IPV4_CONF:
		    tprintf(", ");
		    printxval(sysctl_net_ipv4_conf,name[3],"NET_IPV4_CONF_???");
		    break;
		  default:
		    goto out;
		  }
		  break;
		case NET_IPV6:
		  tprintf(", ");
		  printxval(sysctl_net_ipv6, name[2],"NET_IPV6_???");
		  if (infosysctl->nlen == 3)
		    goto out;
		  switch (name[2]) {
		  case NET_IPV6_ROUTE:
		    tprintf(", ");
		    printxval(sysctl_net_ipv6_route,name[3],"NET_IPV6_ROUTE_???");
		    break;
		  default:
		    goto out;
		  }
		  break;
		default:
		  goto out;
		}
	      break;
	    default:
	      goto out;
	    }
	

	out:
	  while (cnt < infosysctl->nlen)
	    tprintf(", %x", name[cnt++]);
	  tprintf("}, %d, ", infosysctl->nlen);
	  
	  
	  if (infosysctl->nlen >= 2 && ((name[0] == CTL_KERN && (name[1] == KERN_OSRELEASE || name[1] == KERN_OSTYPE
#ifdef KERN_JAVA_INTERPRETER   /*presente in /usr/include/linux/sysctl.h*/
								 
								 || name[1] == KERN_JAVA_INTERPRETER
#endif
#ifdef KERN_JAVA_APPLETVIEWER /*presente in /usr/include/linux/sysctl.h*/
							     
								 || name[1] == KERN_JAVA_APPLETVIEWER
#endif
								 ))))
	    {
	      if (infosysctl->oldval != NULL)
		string_quote(infosysctl->oldval);
	      tprintf(", %d, ", *(infosysctl->oldlenp));
	      if (infosysctl->newval == NULL)
		tprintf("NULL");
	      else
		if (syserror(info))
		  tprintf("%p", infosysctl->newval);
		else
		  {
		    if (infosysctl->newval != NULL)
		      string_quote(infosysctl->newval);
		  }
	      tprintf(", %Zd", infosysctl->newlen);
	    }
	  else
	    {
	      tprintf("%p, %d, %p, %Zd", infosysctl->oldval, *(infosysctl->oldlenp),infosysctl->newval, infosysctl->newlen);
	    }
	  tprintf("}");
	}
      tprintf(")");
    }
  else
    tprintf("_)");
  
  
  return 0;
}


/*
  Numero argomenti: 1
  -) struttura dove leggere/scrivere i parametri del kernel (struct __sysctl_args *)
*/
int 
sys_sysctl(tcp, n_arg) /* CONTROLLARE */
struct tcb *tcp;
int n_arg;
{
  struct __sysctl_args *info;

  if (set_element(tcp, tcp->u_arg[n_arg], (long*)&info, sizeof(struct __sysctl_args), "sysctl"))
    {
      fprintf(stderr, "sys_sysctl: set_element\n");
      return -1;
    }

  if (set_element(tcp, (long)((struct __sysctl_args *)tcp->u_arg[n_arg])->name, (long *) &info->name, info->nlen * sizeof(int), "sysctl"))
    {
      fprintf(stderr,"WARNING: unable to take field name of __sysctl_args\n");
      info->name=NULL;
    }
  
  if (((struct __sysctl_args *)tcp->u_arg[n_arg])->oldlenp)
    {
      (long *)info->oldlenp = get_num(tcp,(long)((struct __sysctl_args *)tcp->u_arg[n_arg])->oldlenp);
      if ( get_error ) 
	info->oldlenp=NULL;
    }

  if (exiting(tcp)) 
    {
      if (syserror(tcp))
	{
	  fprintf(stderr,"sys_sysctl: syscall failed");
	  return -1;
	}
      
      if (((struct __sysctl_args *)tcp->u_arg[n_arg])->oldval) 
	{
	  size_t lun = sizeof(((struct __sysctl_args *)tcp->u_arg[n_arg])->oldval);
	  if (set_element(tcp,(long)((struct __sysctl_args *)tcp->u_arg[n_arg])->oldval,(long*)&info->oldval,lun,"sysctl"))
	    {
	      fprintf(stderr,"WARNING: unable to take field oldval of __sysctl_args\n");
	      info->oldval=NULL;
	    }
    	}
      
      if (((struct __sysctl_args *)tcp->u_arg[n_arg])->newval) 
	{
	  size_t lun = sizeof(((struct __sysctl_args *)tcp->u_arg[n_arg])->newlen);
	  if (set_element(tcp,(long)((struct __sysctl_args *)tcp->u_arg[n_arg])->newval,(long*)&info->newval,lun,"sysctl"))
	    {
	      fprintf(stderr,"WARNING: unable to take field newlen of __sysctl_args\n");
	      info->newval=NULL;
	    }
	}
    }
  
  (long)tcp->u_arg[n_arg] = (long)info;
  tcp->arg_state[n_arg] = TAKEN;
  
  return 0;
}
